module DAPDpApbIfClamp (/*AUTOARG*/
  nCDBGPWRDN, Busreq, Busack, Buswrite, Busabort, Busaddr, Busrdata, Buswdata,
  Buscmp, Buserror, Busendcnt, Busmode, Busmask, Bustrncnt,
  BusreqC, BusackC, BuswriteC, BusabortC, BusaddrC, BusrdataC, BuswdataC,
  BuscmpC, BuserrorC, BusendcntC, BusmodeC, BusmaskC, BustrncntC
  );

  parameter DP_PRESENT    = 1;

  input         nCDBGPWRDN;     // Debug infrastructure power-down control
  input         Busreq;         // Clamp input
  input         Busack;         // Clamp input
  input         Buswrite;       // Clamp input
  input         Busabort;       // Clamp input
  input  [31:0] Busaddr;        // Clamp input
  input  [31:0] Busrdata;       // Clamp input
  input  [31:0] Buswdata;       // Clamp input
  input         Buscmp;         // Clamp input
  input         Buserror;       // Clamp input
  input  [11:0] Busendcnt;      // Clamp input
  input   [1:0] Busmode;        // Clamp input
  input   [3:0] Busmask;        // Clamp input
  input  [11:0] Bustrncnt;      // Clamp input

  output        BusreqC;        // Clamp output
  output        BusackC;        // Clamp output
  output        BuswriteC;      // Clamp output
  output        BusabortC;      // Clamp output
  output [31:0] BusaddrC;       // Clamp output
  output [31:0] BusrdataC;      // Clamp output
  output [31:0] BuswdataC;      // Clamp output
  output        BuscmpC;        // Clamp output
  output        BuserrorC;      // Clamp output
  output [11:0] BusendcntC;     // Clamp output
  output  [1:0] BusmodeC;       // Clamp output
  output  [3:0] BusmaskC;       // Clamp output
  output [11:0] BustrncntC;     // Clamp output

  wire          iBusreqC;
  wire          iBusackC;
  wire          iBuswriteC;
  wire          iBusabortC;
  wire [31:0]   iBusaddrC;
  wire [31:0]   iBusrdataC;
  wire [31:0]   iBuswdataC;
  wire          iBuscmpC;
  wire          iBuserrorC;
  wire [11:0]   iBusendcntC;
  wire [1:0]    iBusmodeC;
  wire [3:0]    iBusmaskC;
  wire [11:0]   iBustrncntC;

  assign BusreqC    = (DP_PRESENT != 0) ? iBusreqC    : 1'b0;
  assign BusackC    = (DP_PRESENT != 0) ? iBusackC    : 1'b0;
  assign BuswriteC  = (DP_PRESENT != 0) ? iBuswriteC  : 1'b0;
  assign BusabortC  = (DP_PRESENT != 0) ? iBusabortC  : 1'b0;
  assign BusaddrC   = (DP_PRESENT != 0) ? iBusaddrC   : {32{1'b0}};
  assign BusrdataC  = (DP_PRESENT != 0) ? iBusrdataC  : {32{1'b0}};
  assign BuswdataC  = (DP_PRESENT != 0) ? iBuswdataC  : {32{1'b0}};
  assign BuscmpC    = (DP_PRESENT != 0) ? iBuscmpC    : 1'b0;
  assign BuserrorC  = (DP_PRESENT != 0) ? iBuserrorC  : 1'b0;
  assign BusendcntC = (DP_PRESENT != 0) ? iBusendcntC : {12{1'b0}};
  assign BusmodeC   = (DP_PRESENT != 0) ? iBusmodeC   : 2'b00;
  assign BusmaskC   = (DP_PRESENT != 0) ? iBusmaskC   : 4'b0000;
  assign BustrncntC = (DP_PRESENT != 0) ? iBustrncntC : {12{1'b0}};


  DAPDpClamp0 #(DP_PRESENT, 1) uPCbusreq (
  .nPWRDN       (nCDBGPWRDN),
  .NetIn        (Busreq),

  .NetOut       (iBusreqC)
  );

  DAPDpClamp0 #(DP_PRESENT, 1) uPCbusack (
  .nPWRDN       (nCDBGPWRDN),
  .NetIn        (Busack),

  .NetOut       (iBusackC)
  );

  DAPDpClamp0 #(DP_PRESENT, 1) uPCbuswrite (
  .nPWRDN       (nCDBGPWRDN),
  .NetIn        (Buswrite),

  .NetOut       (iBuswriteC)
  );

  DAPDpClamp0 #(DP_PRESENT, 1) uPCbusabort (
  .nPWRDN       (nCDBGPWRDN),
  .NetIn        (Busabort),

  .NetOut       (iBusabortC)
  );

  DAPDpClamp0 #(DP_PRESENT, 32) uPCbusaddr (
  .nPWRDN       (nCDBGPWRDN),
  .NetIn        (Busaddr),

  .NetOut       (iBusaddrC)
  );

  DAPDpClamp0 #(DP_PRESENT, 32) uPCbusrdata (
  .nPWRDN       (nCDBGPWRDN),
  .NetIn        (Busrdata),

  .NetOut       (iBusrdataC)
  );

  DAPDpClamp0 #(DP_PRESENT, 32) uPCbuswdata (
  .nPWRDN       (nCDBGPWRDN),
  .NetIn        (Buswdata),

  .NetOut       (iBuswdataC)
  );

  DAPDpClamp0 #(DP_PRESENT, 1) uPCbuscmp (
  .nPWRDN       (nCDBGPWRDN),
  .NetIn        (Buscmp),

  .NetOut       (iBuscmpC)
  );

  DAPDpClamp0 #(DP_PRESENT, 1) uPCbuserror (
  .nPWRDN       (nCDBGPWRDN),
  .NetIn        (Buserror),

  .NetOut       (iBuserrorC)
  );

  DAPDpClamp0 #(DP_PRESENT, 12) uPCbusendcnt (
  .nPWRDN       (nCDBGPWRDN),
  .NetIn        (Busendcnt),

  .NetOut       (iBusendcntC)
  );

  DAPDpClamp0 #(DP_PRESENT, 2) uPCbusmode (
  .nPWRDN       (nCDBGPWRDN),
  .NetIn        (Busmode),

  .NetOut       (iBusmodeC)
  );

  DAPDpClamp0 #(DP_PRESENT, 4) uPCbusmask (
  .nPWRDN       (nCDBGPWRDN),
  .NetIn        (Busmask),

  .NetOut       (iBusmaskC)
  );

  DAPDpClamp0 #(DP_PRESENT, 12) uPCbustrncnt (
  .nPWRDN       (nCDBGPWRDN),
  .NetIn        (Bustrncnt),

  .NetOut       (iBustrncntC)
  );

endmodule
