module DAPDpApbSync
  (/*AUTOARG*/
  DAPRESETn, DAPCLK, DAPCLKEN, Busreq, Busabort,
  BusreqD, BusabortD
  );

  parameter DP_PRESENT    = 1;

  input         DAPRESETn;      // synchroniser reset
  input         DAPCLK;         // synchroniser clock
  input         DAPCLKEN;       // synchroniser clock enable
  input         Busreq;         // synchroniser input
  input         Busabort;       // synchroniser input

  output        BusreqD;        // synchroniser output
  output        BusabortD;      // synchroniser output

  wire          iBusreqD;
  wire          iBusabortD;

  assign BusreqD   = (DP_PRESENT != 0) ? iBusreqD   : 1'b0;
  assign BusabortD = (DP_PRESENT != 0) ? iBusabortD : 1'b0;

  DAPDpEnSync #(DP_PRESENT) uSyncBusReq
   (
    .SYNCRSTn       (DAPRESETn),
    .SYNCCLK        (DAPCLK),
    .SYNCCLKEN      (DAPCLKEN),
    .SYNCDI         (Busreq),

    .SYNCDO         (iBusreqD)
   );

  DAPDpEnSync #(DP_PRESENT) uSyncBusAbort
   (
    .SYNCRSTn       (DAPRESETn),
    .SYNCCLK        (DAPCLK),
    .SYNCCLKEN      (DAPCLKEN),
    .SYNCDI         (Busabort),

    .SYNCDO         (iBusabortD)
   );

endmodule
