module DAPDpEnSync (
  SYNCCLK,
  SYNCRSTn,
  SYNCCLKEN,
  SYNCDI,
  SYNCDO
  );

  parameter DP_PRESENT    = 1;


input SYNCCLK;
input SYNCRSTn;
input SYNCCLKEN;
input SYNCDI;

output SYNCDO;


reg sync_reg;
reg sync2_reg;

wire          iSYNCDO;

  assign SYNCDO = (DP_PRESENT != 0) ? iSYNCDO : 1'b0;


`ifdef ARM_CDC_ON

  cdc_random_en u_rand_en (
                      .clock(SYNCCLK),
                      .clocken(SYNCCLKEN),
                      .nreset(SYNCRSTn),
                      .synced(sync2_reg),
                      .sync_out(iSYNCDO)
                    );


`else

  assign iSYNCDO = sync2_reg;

`endif


always @ (posedge SYNCCLK or negedge SYNCRSTn)
  begin
    if (~SYNCRSTn)
      begin
        sync_reg <= 1'b0;
        sync2_reg <= 1'b0;
      end
    else
      begin
        if(SYNCCLKEN)
         begin
          sync_reg <= SYNCDI;
          sync2_reg <= sync_reg;
         end
      end
  end



endmodule
