module DAPDpSync (
  SYNCCLK,
  SYNCRSTn,
  SYNCDI,
  SYNCDO
  );

  parameter DP_PRESENT = 1;


input SYNCCLK;
input SYNCRSTn;
input SYNCDI;

output SYNCDO;

reg sync_reg;
reg sync2_reg;

wire          iSYNCDO;

  assign SYNCDO = (DP_PRESENT != 0) ? iSYNCDO : 1'b0;


`ifdef ARM_CDC_ON

  cdc_random u_rand (
                      .clock(SYNCCLK),
                      .nreset(SYNCRSTn),
                      .synced(sync2_reg),
                      .sync_out(iSYNCDO)
                    );


`else

  assign iSYNCDO = sync2_reg;

`endif


always @ (posedge SYNCCLK or negedge SYNCRSTn)
  begin
    if (~SYNCRSTn)
      begin
        sync_reg <= 1'b0;
        sync2_reg <= 1'b0;
      end
    else
      begin
         sync_reg <= SYNCDI;
         sync2_reg <= sync_reg;
      end
  end

endmodule
