module DAPSwDpSync
  (/*AUTOARG*/
   DBGRESETn, DBGCLK,
   Busack, CDBGPWRUPACK, CSYSPWRUPACK, CDBGRSTACK,

   BusackT, CdbgpwrupackS, CsyspwrupackS, CdbgrstackS
   );

  parameter DP_PRESENT    = 1;

  input         DBGRESETn;      // synchroniser reset
  input         DBGCLK;         // synchroniser clock
  input         Busack;         // synchroniser input
  input         CDBGPWRUPACK;   // synchroniser input
  input         CSYSPWRUPACK;   // synchroniser input
  input         CDBGRSTACK;     // synchroniser input

  output        BusackT;        // synchroniser output
  output        CdbgpwrupackS;  // synchroniser output
  output        CsyspwrupackS;  // synchroniser output
  output        CdbgrstackS;    // synchroniser output

  wire          iBusackT;
  wire          iCdbgpwrupackS;
  wire          iCsyspwrupackS;
  wire          iCdbgrstackS;

  assign BusackT       = (DP_PRESENT != 0) ? iBusackT       : 1'b0;
  assign CdbgpwrupackS = (DP_PRESENT != 0) ? iCdbgpwrupackS : 1'b0;
  assign CsyspwrupackS = (DP_PRESENT != 0) ? iCsyspwrupackS : 1'b0;
  assign CdbgrstackS   = (DP_PRESENT != 0) ? iCdbgrstackS   : 1'b0;


  DAPDpSync  uSyncBusAck
   (
    .SYNCRSTn       (DBGRESETn),
    .SYNCCLK        (DBGCLK),
    .SYNCDI         (Busack),

    .SYNCDO         (iBusackT)
   );


  DAPDpSync  uCDBGPWRUPACK
   (
    .SYNCRSTn       (DBGRESETn),
    .SYNCCLK        (DBGCLK),
    .SYNCDI         (CDBGPWRUPACK),

    .SYNCDO         (iCdbgpwrupackS)
   );


  DAPDpSync  uCSYSPWRUPACK
   (
    .SYNCRSTn       (DBGRESETn),
    .SYNCCLK        (DBGCLK),
    .SYNCDI         (CSYSPWRUPACK),

    .SYNCDO         (iCsyspwrupackS)
   );


  DAPDpSync  uCDBGRSTACK
   (
    .SYNCRSTn       (DBGRESETn),
    .SYNCCLK        (DBGCLK),
    .SYNCDI         (CDBGRSTACK),

    .SYNCDO         (iCdbgrstackS)
   );

endmodule
