module cm3_cdc_capt_sync (clk, reset_n, async_i, sync_o);

  input     clk;
  input     reset_n;
  input     async_i;     // May be connected to an asynchronous input
  output    sync_o;

  wire      data_noz;
  reg       data_sync1;
  reg       data_sync2;

`ifdef ARM_CDC_CHECK

  cm3_cdc_random u_cdc_random
   (
    .data_i  (async_i),
    .data_o  (data_noz)
    );

`else

  assign data_noz = async_i;

`endif

  always @(posedge clk or negedge reset_n)
    if (!reset_n)
      begin
        data_sync1 <= 1'b0;
        data_sync2 <= 1'b0;
      end
    else
      begin
        data_sync1 <= data_noz;
        data_sync2 <= data_sync1;
      end

  assign sync_o = data_sync2;

endmodule
