module cm3_cdc_connect (clk_launch, clk_capture, data_i, data_o);

  parameter IH = 0;
  parameter IL = 0;


  input               clk_launch;
  input               clk_capture;
  input    [IH:IL]    data_i;
  output   [IH:IL]    data_o;



`ifdef ARM_CDC_CHECK

  reg      [IH:IL]    data;
  reg      [IH:IL]    launch_unct;
  reg      [IH:IL]    capture_unct;
  wire     [IH:IL]    muxsel;

  integer             i;

  assign muxsel = (capture_unct ^ data_i) & (launch_unct ^ data_i);

  always @(data_i or muxsel)
    for (i = IL; i <= IH; i = i + 1)
      data[i] = muxsel[i] ? 1'bz : data_i[i];

  always @ (posedge clk_launch)
    launch_unct <= data_i;

  always @ (posedge clk_capture)
    capture_unct <= data_i;

  assign data_o = data;

`else

  assign data_o = data_i;

`endif

endmodule
