module cm3_cdc_random (data_i, data_o);
  parameter             HIER_LEN = 100;

  input                 data_i;
  output                data_o;

`ifdef ARM_CDC_CHECK


  reg                   data;

  integer               seed;
  integer               i;
  integer               seed_char;
  reg [0:(8*HIER_LEN)]  seed_string;
  integer               top_level_seed;

  reg [31:0]            lfsr;
  wire                  lfsr_feedback;
  integer               a,b;

  initial
    begin
      $swrite(seed_string,"%m");


      seed = 0;
      for (i = 0; i < (8*HIER_LEN); i = i + 8)
        begin
          seed_char = (seed_string[i+:8]);
          seed = seed + seed_char;
        end

      if ($value$plusargs("seed=%d",top_level_seed)) seed = seed+top_level_seed;

      $display ("%s using seed %h",seed_string, seed);

      lfsr <= seed;

    end

  assign lfsr_feedback = lfsr[2] ^ lfsr[30];

  always @(data_i)
    if (data_i === 1'bz)
      begin
        data = lfsr[0];
        lfsr = {lfsr[30:0],lfsr_feedback};
      end
    else
      data = data_i;

  assign data_o = data;
`else // !`ifdef ARM_CDC_CHECK
  assign data_o = data_i;

`endif

endmodule
