`include "cm3_dpu_defs.vp"

module cm3_dpu
  (// Inputs
   hreset_n, hclk, ext_cg_bypass_i, mtx_ahb_haddracci_i, mtx_ahb_hreadyi_i,
   mtx_ahb_hrdatai_i, mtx_ahb_hrespi_i, mpu_hrespi_i, mtx_ahb_haddraccd_i,
   mtx_ahb_hreadyd_i, mtx_ahb_hrdatad_i, mtx_ahb_hrespd_i, mpu_hrespd_i,
   mtx_ahb_exrespd_i, ext_iflush_i, nvic_data_be8_i, mtx_bm_active_i,
   mpu_canceld_i, mpu_addrd_non_buf_i, nvic_bfhfnmign_i, nvic_int_stk_algn_i,
   nvic_div_0_trp_i, nvic_unalign_trp_i, nvic_nonbasethrden_i, nvic_disfold_i,
   nvic_dismcycint_i, nvic_basepri_i, nvic_fmask_i, nvic_pmask_i,
   nvic_int_nxt_isr_i, nvic_int_curr_isr_i, nvic_lockup_i, nvic_int_invoke_i,
   nvic_int_newarrival_i, nvic_int_addr_i, nvic_int_tail_i, nvic_int_stk_actv_i,
   nvic_int_in_nmihf_i, nvic_slp_asleep_i, nvic_slp_sleeponexit_i,
   nvic_dbg_halt_req_i, nvic_dbg_mon_req_i, nvic_dbg_step_i, nvic_dbg_trans_i,
   nvic_dbg_reg_wr_i, nvic_dbg_reg_addr_i, etm_ifen_i, etm_fifofull_i,
   dpu_ahb_haddri_o, dpu_ahb_htransi_o, dpu_ahb_hsizei_o, dpu_ahb_hproti_o,
   dpu_ahb_haddrd_o, dpu_ahb_htransd_o, dpu_ahb_hwrited_o, dpu_ahb_hsized_o,
   dpu_ahb_hwdatad_o, dpu_ahb_hprotd_o, dpu_ahb_exreqd_o, dpu_ahb_htransi_iss_o,
   dpu_rst_pc_valid_o, dpu_int_entry_o, dpu_int_exit_o, dpu_int_return_o,
   dpu_int_retisr_o, dpu_branch_stat_o, dpu_ivalid_o, dpu_retire_o, dpu_bkpt_o,
   dpu_nxt_bfsr_o, dpu_nxt_mfsr_o, dpu_nxt_ufsr_o, dpu_nxt_hfsr_o,
   dpu_basepri_we_o, dpu_basepri_nxt_o, dpu_fmask_we_o, dpu_fmask_nxt_o,
   dpu_pmask_we_o, dpu_pmask_nxt_o, dpu_raisepri_o, dpu_slp_txev_o,
   dpu_slp_ctl_o, dpu_ahb_haddrd_valid_o, dpu_mcyc_invk_msk_o,
   dpu_ahb_invk_msk_o, dpu_force_non_buf_o, dpu_svc_o, dpu_obs_rf_o,
   dpu_obs_instr_o, dpu_dbg_halted_o, dpu_dbg_ready_o, dpu_dbg_wr_isr_o,
   dpu_etm_ivalid_o, dpu_etm_istall_o, dpu_etm_ibranch_o, dpu_etm_iindrbr_o,
   dpu_etm_iccfail_o, dpu_etm_isb_o, dpu_etm_dvalid_o, dpu_etm_ia_o,
   dpu_etm_pstat_o, dpu_etm_fold_o, dpu_etm_lsu_o, dpu_etm_cancel_o,
   dpu_etm_intstat_o, dpu_etm_intnum_o, dpu_etm_flush_o, dpu_etm_findbr_o
   );

  parameter CLKGATE_PRESENT = 0; // Architectural clock gating present if 1
  parameter RESET_ALL_REGS  = 0; // Reset all registers if 1
  parameter OBSERVATION     = 0; // Allow internal observation if 1
  parameter CONST_AHB_CTRL  = 0; // Constant AHB control info if 1

  input          hreset_n;
  input          hclk;
  input          ext_cg_bypass_i;
  input          mtx_ahb_haddracci_i;
  input          mtx_ahb_hreadyi_i;
  input [1:0]    mtx_ahb_hrespi_i;
  input [31:0]   mtx_ahb_hrdatai_i;
  input          mpu_hrespi_i;
  input          mtx_ahb_haddraccd_i;
  input          mtx_ahb_hreadyd_i;
  input [31:0]   mtx_ahb_hrdatad_i;
  input [1:0]    mtx_ahb_hrespd_i;
  input          mpu_hrespd_i;
  input          mtx_ahb_exrespd_i;
  input          ext_iflush_i;
  input          nvic_data_be8_i;
  input          mtx_bm_active_i;
  input          mpu_canceld_i;
  input          mpu_addrd_non_buf_i;
  input          nvic_bfhfnmign_i;
  input          nvic_int_stk_algn_i;
  input          nvic_div_0_trp_i;
  input          nvic_unalign_trp_i;
  input          nvic_nonbasethrden_i;
  input          nvic_disfold_i;
  input          nvic_dismcycint_i;
  input [7:0]    nvic_basepri_i;
  input          nvic_fmask_i;
  input          nvic_pmask_i;
  input [7:0]    nvic_int_nxt_isr_i;
  input [8:0]    nvic_int_curr_isr_i;
  input [1:0]    nvic_lockup_i;
  input          nvic_int_invoke_i;
  input          nvic_int_newarrival_i;
  input [31:0]   nvic_int_addr_i;
  input          nvic_int_tail_i;
  input          nvic_int_stk_actv_i;
  input [2:0]    nvic_int_in_nmihf_i;
  input          nvic_slp_asleep_i;
  input          nvic_slp_sleeponexit_i;
  input          nvic_dbg_halt_req_i;
  input          nvic_dbg_mon_req_i;
  input          nvic_dbg_step_i;
  input          nvic_dbg_trans_i;
  input          nvic_dbg_reg_wr_i;
  input [6:0]    nvic_dbg_reg_addr_i;
  input          etm_ifen_i;
  input          etm_fifofull_i;

  output [31:0]  dpu_ahb_haddri_o;
  output [1:0]   dpu_ahb_htransi_o;
  output [1:0]   dpu_ahb_hsizei_o;
  output [1:0]   dpu_ahb_hproti_o;
  output [31:0]  dpu_ahb_haddrd_o;
  output [1:0]   dpu_ahb_htransd_o;
  output         dpu_ahb_hwrited_o;
  output [1:0]   dpu_ahb_hsized_o;
  output [31:0]  dpu_ahb_hwdatad_o;
  output [1:0]   dpu_ahb_hprotd_o;
  output         dpu_ahb_exreqd_o;
  output         dpu_ahb_htransi_iss_o;
  output         dpu_rst_pc_valid_o;
  output         dpu_int_entry_o;
  output         dpu_int_exit_o;
  output         dpu_int_return_o;
  output [8:0]   dpu_int_retisr_o;
  output [3:0]   dpu_branch_stat_o;
  output         dpu_ivalid_o;
  output         dpu_retire_o;
  output         dpu_bkpt_o;
  output [5:0]   dpu_nxt_bfsr_o;
  output [4:0]   dpu_nxt_mfsr_o;
  output [9:0]   dpu_nxt_ufsr_o;
  output         dpu_nxt_hfsr_o;
  output         dpu_basepri_we_o;
  output [7:0]   dpu_basepri_nxt_o;
  output         dpu_fmask_we_o;
  output         dpu_fmask_nxt_o;
  output         dpu_pmask_we_o;
  output         dpu_pmask_nxt_o;
  output         dpu_raisepri_o;
  output         dpu_slp_txev_o;
  output [1:0]   dpu_slp_ctl_o;
  output         dpu_ahb_haddrd_valid_o;
  output         dpu_mcyc_invk_msk_o;
  output         dpu_ahb_invk_msk_o;
  output         dpu_force_non_buf_o;
  output         dpu_svc_o;
  output [108:0] dpu_obs_rf_o;
  output [31:0]  dpu_obs_instr_o;
  output         dpu_dbg_halted_o;
  output         dpu_dbg_ready_o;
  output         dpu_dbg_wr_isr_o;
  output         dpu_etm_ivalid_o;
  output         dpu_etm_istall_o;
  output         dpu_etm_ibranch_o;
  output         dpu_etm_iindrbr_o;
  output         dpu_etm_iccfail_o;
  output         dpu_etm_isb_o;
  output [31:1]  dpu_etm_ia_o;
  output [1:0]   dpu_etm_pstat_o;
  output         dpu_etm_fold_o;
  output         dpu_etm_dvalid_o;
  output         dpu_etm_lsu_o;
  output         dpu_etm_cancel_o;
  output [2:0]   dpu_etm_intstat_o;
  output [8:0]   dpu_etm_intnum_o;
  output         dpu_etm_flush_o;
  output         dpu_etm_findbr_o;

  wire           rst_pc_valid_ex;
  wire [3:0]     state_fe;
  wire [31:1]    fe_address_add_res;
  wire           fe_haddracci;
  wire           fe_buf_has_valid_instr;
  wire           instr_valid_fe;
  wire           instr_word_present_fe;
  wire           instr_stop_adv_fe;
  wire           instr_ext_pflush_fe;
  wire [1:0]     instr_fault_fe;
  wire           instr_det_erly_br_trk_v;
  wire           instr_det_erly_br_trk;
  wire [31:0]    instr_de;
  wire           instr_valid_de;
  wire           instr_advance_de;
  wire           instr_used_word_de;
  wire [3:0]     instr_cond_code_de;
  wire           instr_ccpass_de;
  wire           instr_itblock_de;
  wire           instr_itccfail_de;
  wire           instr_itfold_de;
  wire [9:0]     instr_itctl_de;
  wire           instr_bkpt_de;
  wire           instr_czb_de;
  wire           instr_svc_de;
  wire           instr_wfe_de;
  wire           instr_wfi_de;
  wire           instr_undef_de;
  wire           instr_copro_de;
  wire           instr_txev_de;
  wire [1:0]     instr_barrier_de;
  wire           instr_imm_valid_fast_de;
  wire           instr_imm_valid_de;
  wire [31:0]    instr_immed_de;
  wire [31:0]    instr_lsm_immed_de;
  wire           instr_has_shft_imm_de;
  wire [1:0]     instr_data_size_de;
  wire           instr_algn_de;
  wire           instr_sign_de;
  wire           instr_mla_track_de;
  wire           instr_16_mul_valid_de;
  wire           instr_exit_op_de;
  wire [4:0]     instr_msr_ctl_de;
  wire [2:0]     instr_cps_ctl_de;
  wire [20:0]    instr_alu_ctl_de;
  wire [15:0]    instr_lsu_ctl_de;
  wire           instr_ls_allow_pline_de;
  wire           instr_ls_single_adv_de;
  wire           instr_lsm_baseinlist_de;
  wire [3:0]     instr_br_cond_de;
  wire           instr_br_t_changer_de;
  wire           instr_br_lr_sel_de;
  wire [31:0]    instr_br_imm_de;
  wire           instr_br_ccpass_de;
  wire           instr_de_br_det_de;
  wire           instr_br_req_de;
  wire [3:0]     instr_brchstat_de;
  wire [1:0]     instr_br_pflush_fast_de;
  wire [1:0]     instr_br_pflush_de;
  wire           instr_lsu_int_ilock_de;
  wire           instr_lr_ilock_de;
  wire           instr_all_ilock_de;
  wire           instr_rf_rd_a_en_de;
  wire [3:0]     instr_rf_rd_a_addr_de;
  wire           instr_rf_rd_b_en_de;
  wire [3:0]     instr_rf_rd_b_addr_de;
  wire [3:0]     instr_rf_rd_c_addr_de;
  wire [1:0]     instr_sp_rd_de;
  wire [1:0]     instr_sp_wr_de;
  wire [1:0]     instr_pc_lr_de;
  wire           instr_de_2_ex_en;
  wire [31:0]    instr_br_imm_ex;
  wire           instr_valid_ex;
  wire           instr_ccpass_ex;
  wire           instr_advance_ex;
  wire           instr_complete_ex;
  wire           instr_retire_ex;
  wire [3:0]     instr_stall_ex;
  wire           instr_immed_valid_ex;
  wire [31:0]    instr_immed_ex;
  wire           instr_bkpt_ex;
  wire           instr_not_bkpt_ex;
  wire           instr_czb_ex;
  wire           instr_16_mul_ex;
  wire [1:0]     instr_link_ex;
  wire           instr_itblock_ex;
  wire           instr_itfold_ex;
  wire           instr_excl_ex;
  wire [1:0]     instr_data_size_ex;
  wire           instr_algn_ex;
  wire           instr_sign_ex;
  wire           instr_atbase_ex;
  wire           instr_exit_op_ex;
  wire           instr_detect_exit_ex;
  wire [15:0]    instr_lsu_ctl_ex;
  wire           lsu_valid_ex;
  wire           instr_lsu_br_det_ex;
  wire           instr_br_t_changer_ex;
  wire [1:0]     instr_br_type_ex;
  wire           instr_pflush_ex;
  wire [2:0]     instr_br_pflush_ex;
  wire           instr_dp_pflush_ex;
  wire           instr_flag_wr_ex;
  wire [3:0]     instr_rf_wr_d_addr_ex;
  wire           instr_lr_ilock_ex;
  wire           instr_mcyc_ilock_ex;
  wire           instr_excl_reg;
  wire           privileged;
  wire           user_thread_ex;
  wire           fpu_active_ex;
  wire           psr_t_ex;
  wire [31:0]    psr_ex;
  wire [31:0]    ahb_haddri;
  wire [1:0]     ahb_htransi;
  wire [1:0]     ahb_hsizei;
  wire [1:0]     ahb_hproti;
  wire [31:0]    ahb_haddrd;
  wire [1:0]     ahb_htransd;
  wire           ahb_hwrited;
  wire [1:0]     ahb_hsized;
  wire [31:0]    ahb_hwdatad;
  wire [1:0]     ahb_hprotd;
  wire           ahb_exreqd;
  wire           ahb_htransi_track;
  wire           int_stack_op;
  wire           int_unstacking;
  wire           int_vector_fault;
  wire           int_first_instr_valid;
  wire           int_entry;
  wire [4:0]     int_lr_exit_code_ex;
  wire [8:0]     int_isr_ex;
  wire           int_exit;
  wire           int_return;
  wire [8:0]     int_retisr;
  wire           iflush_pflush_ex;
  wire [5:0]     dpu_nxt_bfsr;
  wire [4:0]     dpu_nxt_mfsr;
  wire [9:0]     dpu_nxt_ufsr;
  wire           dpu_nxt_hfsr;
  wire           dpu_basepri_we;
  wire [7:0]     dpu_basepri_ex;
  wire           dpu_fmask_we;
  wire           dpu_fmask_ex;
  wire           dpu_pmask_we;
  wire           dpu_pmask_ex;
  wire           dpu_raisepri_ex;
  wire           dpu_slp_txev_ex;
  wire [1:0]     dpu_slp_ctl_ex;
  wire           dpu_addrd_valid;
  wire           dpu_mcyc_invk_msk;
  wire           lsu_ahb_invk_msk;
  wire           alu_stall_ex;
  wire           alu_will_wr_rf_ex;
  wire           alu_zero_res_ex;
  wire           alu_exit_valid_ex;
  wire [4:0]     alu_exit_code_ex;
  wire           alu_mcyc_ilock_ex;
  wire           alu_mcyc_invk_msk_ex;
  wire [5:0]     alu_flag_wr_ex;
  wire [4:0]     alu_flag_res_ex;
  wire [3:0]     alu_ge_res_ex;
  wire [4:0]     alu_mul_flag_res_ex;
  wire           alu_rf_rd_a_en_ex;
  wire [3:0]     alu_rf_rd_a_addr_ex;
  wire           alu_rf_wr_d_en_ex;
  wire [3:0]     alu_rf_wr_d_addr_ex;
  wire [31:0]    alu_rf_wr_d_data_ex;
  wire           e_undef_de;
  wire           e_shft_inlinec_de;
  wire           e_rf_rd_a_en_de;
  wire [3:0]     e_rf_rd_a_addr_de;
  wire           e_rf_rd_b_en_de;
  wire [3:0]     e_rf_rd_b_addr_de;
  wire           e_rf_wr_d_en_de;
  wire [3:0]     e_rf_wr_d_addr_de;
  wire [3:0]     e_rd_c_addr_de;
  wire [4:0]     e_mac_flag_wr_ex;
  wire [1:0]     e_mac_nz_ex;
  wire           e_mac_q_set_ex;
  wire [31:0]    e_simd_res_ex;
  wire           e_simd_q_set_ex;
  wire [3:0]     e_simd_ge_res_ex;
  wire           e_simd_ge_wr_ex;
  wire [31:0]    e_rf_wr_d_data_ex;
  wire           e_rf_wr_z_en_ex;
  wire [3:0]     e_rf_wr_z_addr_ex;
  wire [31:0]    e_rf_wr_z_data_ex;
  wire           instr_valid_fpu_de;
  wire           fpu_enabled;
  wire           fpu_undef_de;
  wire           fpu_lazy_stall_de;
  wire           fpu_ici_invalid_de;
  wire           fpu_ls_valid_de;
  wire [7:0]     fpu_ls_immed_de;
  wire [7:0]     fpu_lsm_immed_de;
  wire [14:0]    fpu_lsu_ctl_de;
  wire [4:0]     fpu_first_reg_de;
  wire           fpu_busy_ex;
  wire           fpu_stall_ex;
  wire           fpu_interlock_de;
  wire           fpu_r14_ilock_de;
  wire           fpu_mcyc_de;
  wire [1:0]     fpu_str_fwd_de;
  wire           fpu_rf_rd_en_de;
  wire           fpu_rf_rd_en_erly_de;
  wire           fpu_rf_rd_en_ex;
  wire [3:0]     fpu_rf_rd_addr_de;
  wire           fpu_rf_wr_en_ex;
  wire [3:0]     fpu_rf_addr_ex;
  wire           fpu_psr_wr_ex;
  wire [5:0]     lsu_state_ex;
  wire           lsu_active_ex;
  wire           lsu_sp_wb_ex;
  wire           lsu_stall_ex;
  wire           lsu_stall_late_ex;
  wire           lsu_str_buf_imm_ex;
  wire           lsu_stackpush_rdy_ex;
  wire           lsu_stack_start;
  wire           lsu_exit_valid_ex;
  wire [4:0]     lsu_exit_code_ex;
  wire           lsu_pflush_ex;
  wire           lsu_mcyc_ilock_ex;
  wire           lsu_mcyc_invk_msk_ex;
  wire           lsu_will_wr_rf_ex;
  wire           lsu_main_sp_en;
  wire           lsu_real_sp_rd;
  wire           lsu_fix_pc_ex;
  wire [31:0]    lsu_psr_ex;
  wire           lsu_flag_wr_ex;
  wire           lsu_it_valid_ex;
  wire [7:0]     lsu_it_ex;
  wire [3:0]     lsu_ici_cont;
  wire [1:0]     lsu_local_fault_ex;
  wire           lsu_dbl_fault_ex;
  wire           lsu_addrd_non_buf;
  wire           lsu_rf_rd_a_en_ex;
  wire           lsu_rf_rd_a_en_fast_ex;
  wire [3:0]     lsu_rf_rd_a_addr_ex;
  wire           lsu_rf_wr_d_en_ex;
  wire           lsu_rf_wr_d_en_fast_ex;
  wire [3:0]     lsu_rf_wr_d_addr_ex;
  wire [31:0]    lsu_rf_wr_d_data_ex;
  wire [3:0]     lsu_rf_wr_z_addr_ex;
  wire           lsu_rf_wr_z_en_ex;
  wire [31:0]    lsu_rf_wr_z_data_ex;
  wire [1:0]     fpu_update_ctrl;
  wire           rf_wr_d_en_fe;
  wire [3:0]     rf_wr_d_addr_fe;
  wire [31:0]    rf_wr_d_data_fe;
  wire           rf_rd_a_en_de;
  wire [3:0]     rf_rd_a_addr_de;
  wire [31:0]    rf_rd_a_data_de;
  wire           rf_rd_b_en_de;
  wire [3:0]     rf_rd_b_addr_de;
  wire [31:0]    rf_rd_b_data_de;
  wire           rf_wr_d_en_de;
  wire [3:0]     rf_wr_d_addr_de;
  wire           rf_wr_z_en_de;
  wire [3:0]     rf_wr_z_addr_de;
  wire [31:0]    rf_rd_a_data_ex;
  wire [1:0]     rf_rd_a_zero_ex;
  wire [31:0]    rf_rd_b_data_ex;
  wire [1:0]     rf_rd_b_zero_ex;
  wire [3:0]     rf_rd_x_addr_ex;
  wire [31:0]    rf_rd_x_data_ex;
  wire [3:0]     rf_rd_y_addr_ex;
  wire [31:0]    rf_rd_y_data_ex;
  wire           rf_wr_d_en_ex;
  wire [3:0]     rf_wr_d_addr_erly_ex;
  wire [3:0]     rf_wr_d_addr_ex;
  wire [31:0]    rf_wr_d_data_erly_ex;
  wire [31:0]    rf_wr_d_data_ex;
  wire [1:0]     rf_sp_rd_de;
  wire [1:0]     rf_sp_wr_ex;
  wire [1:0]     rf_sp_sel_ex;
  wire [31:0]    rf_rd_lr_de;
  wire [31:1]    rf_pc_wr_data_de;
  wire           rf_inc_pc_ex;
  wire [1:0]     rf_pc_ctl_ex;
  wire [31:0]    rf_pc_fwd_ex;
  wire [108:0]   rf_observation;
  wire [31:0]    instr_ex;
  wire [1:0]     fault_fetch_de;
  wire           instr_isb_de;
  wire           fault_state_de;
  wire           fault_ici_de;
  wire           fault_divby0_ex;
  wire           fault_svc_ex;
  wire [10:0]    fault_lsu_ex;
  wire           fault_lsu_precise_ex;
  wire           fault_dblfault_ex;
  wire           dbg_halt_set;
  wire           dbg_halted;
  wire           dbg_halted_reg;
  wire           dbg_ready;
  wire           dbg_wr_isr;
  wire           dbg_ctrl_wr_ex;
  wire           etm_instr_valid_de;
  wire           etm_stall;
  wire           etm_ivalid;
  wire           etm_istall;
  wire           etm_ibranch;
  wire           etm_iindrbr;
  wire           etm_iccfail;
  wire           etm_isb;
  wire [31:1]    etm_ia;
  wire [1:0]     etm_pstat;
  wire           etm_fold;
  wire           etm_dvalid;
  wire           etm_lsu;
  wire           etm_cancel;
  wire [2:0]     etm_intstat;
  wire [8:0]     etm_intnum;
  wire           etm_flush;
  wire           etm_findbr;
  wire           lazy_stall_erly_de;
  wire           int_ret_fpu;
  wire [31:0]    nvic_fpccr;
  wire [31:0]    nvic_fpcar;
  wire           nvic_no_lazy_stk;
  wire           set_instr_redo_ex;
  wire           instr_redo_ex;
  wire [31:0]    fpu_wr_data_ex;
  wire           fpu_lazy_stack_op;
  wire           fpu_fpscr_wr_de;
  wire           fault_nocopro_fpu;
  wire [1:0]     fpu_tail_status;
  wire           fpu_lazy_done;
  wire           fpu_lazy_start;
  wire           fpu_lazy_cancel;
  wire           fpu_flip_stack;
  wire           fpu_int_cp_fault;
  wire [1:0]     fpu_stack_ctl;
  wire [1:0]     fpu_unstack_ctl;

  cm3_dpu_fetch #(RESET_ALL_REGS, CONST_AHB_CTRL)
    u_cm3_dpu_fetch
      (// Inputs
       .hreset_n                   (hreset_n),
       .hclk                       (hclk),
       .ext_iflush_i               (ext_iflush_i),
       .instr_valid_de_i           (instr_valid_de),
       .instr_use_word_de_i        (instr_used_word_de),
       .instr_br_lr_sel_de_i       (instr_br_lr_sel_de),
       .instr_br_imm_de_i          (instr_br_imm_de),
       .instr_br_ccpass_de_i       (instr_br_ccpass_de),
       .instr_de_br_det_de_i       (instr_de_br_det_de),
       .instr_br_req_de_i          (instr_br_req_de),
       .instr_br_pflush_fast_de_i  (instr_br_pflush_fast_de),
       .instr_br_pflush_de_i       (instr_br_pflush_de),
       .instr_br_imm_ex_i          (instr_br_imm_ex),
       .instr_br_pflush_ex_i       (instr_br_pflush_ex),
       .instr_pflush_ex_i          (instr_pflush_ex),
       .instr_lsu_br_det_ex_i      (instr_lsu_br_det_ex),
       .instr_br_type_ex_i         (instr_br_type_ex),
       .instr_advance_ex_i         (instr_advance_ex),
       .instr_detect_exit_ex_i     (instr_detect_exit_ex),
       .instr_dblfault_ex_i        (fault_dblfault_ex),
       .instr_det_erly_br_trk_i    (instr_det_erly_br_trk),
       .instr_det_erly_br_trk_v_i  (instr_det_erly_br_trk_v),
       .privileged_i               (privileged),
       .nvic_int_invoke_i          (nvic_int_invoke_i),
       .nvic_int_tail_i            (nvic_int_tail_i),
       .nvic_int_addr_i            (nvic_int_addr_i),
       .int_entry_i                (int_entry),
       .int_exit_i                 (int_exit),
       .int_return_i               (int_return),
       .nvic_int_newarrival_i      (nvic_int_newarrival_i),
       .nvic_int_in_nmihf_i        (nvic_int_in_nmihf_i),
       .mtx_ahb_hreadyi_i          (mtx_ahb_hreadyi_i),
       .mtx_ahb_haddracci_i        (mtx_ahb_haddracci_i),
       .mtx_ahb_hrespi_i           (mtx_ahb_hrespi_i),
       .mpu_hrespi_i               (mpu_hrespi_i),
       .mtx_ahb_hrdatai_i          (mtx_ahb_hrdatai_i),
       .mtx_ahb_hreadyd_i          (mtx_ahb_hreadyd_i),
       .etm_stall_i                (etm_stall),
       .etm_fifofull_i             (etm_fifofull_i),
       .nvic_slp_asleep_i          (nvic_slp_asleep_i),
       .nvic_slp_sleeponexit_i     (nvic_slp_sleeponexit_i),
       .nvic_data_be8_i            (nvic_data_be8_i),
       .lsu_stackpush_rdy_ex_i     (lsu_stackpush_rdy_ex),
       .lsu_pflush_ex_i            (lsu_pflush_ex),
       .fpu_lazy_stack_op_i        (fpu_lazy_stack_op),
       .fpu_lazy_stall_de_i        (fpu_lazy_stall_de),
       .rf_rd_lr_de_i              (rf_rd_lr_de),
       .rf_pc_wr_data_de_i         (rf_pc_wr_data_de),
       .rf_rd_b_data_ex_i          (rf_rd_b_data_ex),
       .rf_pc_fwd_ex_i             (rf_pc_fwd_ex),
       .dbg_halted_i               (dbg_halted),
       .nvic_dbg_halt_req_i        (nvic_dbg_halt_req_i),
       .nvic_dbg_mon_req_i         (nvic_dbg_mon_req_i),
       .state_fe_o                 (state_fe),
       .fe_address_add_res_o       (fe_address_add_res),
       .fe_buf_has_valid_instr_o   (fe_buf_has_valid_instr),
       .fe_haddracci_o             (fe_haddracci),
       .instr_valid_fe_o           (instr_valid_fe),
       .instr_word_present_fe_o    (instr_word_present_fe),
       .instr_stop_adv_fe_o        (instr_stop_adv_fe),
       .instr_fault_fe_o           (instr_fault_fe),
       .instr_ext_pflush_fe_o      (instr_ext_pflush_fe),
       .instr_de_o                 (instr_de),
       .int_first_instr_valid_o    (int_first_instr_valid),
       .int_vector_fault_o         (int_vector_fault),
       .rf_wr_d_en_fe_o            (rf_wr_d_en_fe),
       .rf_wr_d_addr_fe_o          (rf_wr_d_addr_fe),
       .rf_wr_d_data_fe_o          (rf_wr_d_data_fe),
       .ahb_htransi_o              (ahb_htransi),
       .ahb_hsizei_o               (ahb_hsizei),
       .ahb_haddri_o               (ahb_haddri),
       .ahb_hproti_o               (ahb_hproti),
       .ahb_htransi_track_o        (ahb_htransi_track));

  cm3_dpu_dec #(0, 0)
    u_cm3_dpu_dec
      (// Inputs
       .hreset_n                   (hreset_n),
       .hclk                       (hclk),
       .state_fe_i                 (state_fe),
       .fe_address_add_res_i       (fe_address_add_res),
       .fe_buf_has_valid_instr_i   (fe_buf_has_valid_instr),
       .instr_word_present_fe_i    (instr_word_present_fe),
       .instr_stop_adv_fe_i        (instr_stop_adv_fe),
       .instr_valid_fe_i           (instr_valid_fe),
       .instr_fault_fe_i           (instr_fault_fe),
       .instr_de_i                 (instr_de),
       .instr_ccpass_de_i          (instr_ccpass_de),
       .instr_itccfail_de_i        (instr_itccfail_de),
       .instr_itblock_de_i         (instr_itblock_de),
       .instr_valid_ex_i           (instr_valid_ex),
       .instr_ccpass_ex_i          (instr_ccpass_ex),
       .instr_stall_ex_i           (instr_stall_ex),
       .instr_not_bkpt_ex_i        (instr_not_bkpt_ex),
       .instr_16_mul_ex_i          (instr_16_mul_ex),
       .instr_immed_valid_ex_i     (instr_immed_valid_ex),
       .instr_mcyc_ilock_ex_i      (instr_mcyc_ilock_ex),
       .instr_lsu_ctl_ex_i         (instr_lsu_ctl_ex),
       .instr_flag_wr_ex_i         (instr_flag_wr_ex),
       .instr_atbase_ex_i          (instr_atbase_ex),
       .instr_detect_exit_ex_i     (instr_detect_exit_ex),
       .instr_dp_pflush_ex_i       (instr_dp_pflush_ex),
       .instr_br_pflush_ex_i       (instr_br_pflush_ex),
       .instr_lr_ilock_ex_i        (instr_lr_ilock_ex),
       .instr_rf_wr_d_addr_ex_i    (instr_rf_wr_d_addr_ex),
       .instr_excl_reg_i           (instr_excl_reg),
       .set_instr_redo_ex_i        (set_instr_redo_ex),
       .alu_will_wr_rf_ex_i        (alu_will_wr_rf_ex),
       .lsu_valid_ex_i             (lsu_valid_ex),
       .lsu_stall_late_ex_i        (lsu_stall_late_ex),
       .lsu_flag_wr_ex_i           (lsu_flag_wr_ex),
       .lsu_pflush_ex_i            (lsu_pflush_ex),
       .lsu_will_wr_rf_ex_i        (lsu_will_wr_rf_ex),
       .lsu_rf_wr_d_addr_ex_i      (lsu_rf_wr_d_addr_ex),
       .lsu_rf_wr_d_data_ex_i      (lsu_rf_wr_d_data_ex),
       .lsu_stack_start_i          (lsu_stack_start),
       .lsu_ici_cont_i             (lsu_ici_cont),
       .e_undef_de_i               (e_undef_de),
       .e_shft_inlinec_de_i        (e_shft_inlinec_de),
       .e_rf_rd_a_en_de_i          (e_rf_rd_a_en_de),
       .e_rf_rd_a_addr_de_i        (e_rf_rd_a_addr_de),
       .e_rf_rd_b_en_de_i          (e_rf_rd_b_en_de),
       .e_rf_rd_b_addr_de_i        (e_rf_rd_b_addr_de),
       .e_rd_c_addr_de_i           (e_rd_c_addr_de),
       .e_rf_wr_d_en_de_i          (e_rf_wr_d_en_de),
       .e_rf_wr_d_addr_de_i        (e_rf_wr_d_addr_de),
       .e_rf_wr_z_en_ex_i          (e_rf_wr_z_en_ex),
       .e_rf_wr_z_addr_ex_i        (e_rf_wr_z_addr_ex),
       .fpu_enabled_i              (fpu_enabled),
       .fpu_interlock_de_i         (fpu_interlock_de),
       .fpu_r14_ilock_de_i         (fpu_r14_ilock_de),
       .fpu_lsu_ctl_de_i           (fpu_lsu_ctl_de),
       .fpu_ls_valid_de_i          (fpu_ls_valid_de),
       .fpu_ls_immed_de_i          (fpu_ls_immed_de),
       .fpu_lsm_immed_de_i         (fpu_lsm_immed_de),
       .fpu_undef_de_i             (fpu_undef_de),
       .fpu_lazy_stall_de_i        (fpu_lazy_stall_de),
       .fpu_ici_invalid_de_i       (fpu_ici_invalid_de),
       .fpu_rf_rd_en_de_i          (fpu_rf_rd_en_de),
       .fpu_rf_rd_en_erly_de_i     (fpu_rf_rd_en_erly_de),
       .fpu_rf_rd_en_ex_i          (fpu_rf_rd_en_ex),
       .fpu_rf_rd_addr_de_i        (fpu_rf_rd_addr_de),
       .fpu_rf_wr_en_ex_i          (fpu_rf_wr_en_ex),
       .fpu_rf_addr_ex_i           (fpu_rf_addr_ex),
       .fpu_mcyc_de_i              (fpu_mcyc_de),
       .fpu_tail_status_i          (fpu_tail_status),
       .fpu_lazy_cancel_i          (fpu_lazy_cancel),
       .fpu_lazy_done_i            (fpu_lazy_done),
       .psr_t_ex_i                 (psr_t_ex),
       .privileged_i               (privileged),
       .mtx_bm_active_i            (mtx_bm_active_i),
       .nvic_disfold_i             (nvic_disfold_i),
       .nvic_slp_asleep_i          (nvic_slp_asleep_i),
       .nvic_aux_ctrl1_we_i        (1'b0),
       .ext_iflush_i               (ext_iflush_i),
       .mtx_ahb_hrespd_i           (mtx_ahb_hrespd_i),
       .mtx_ahb_hreadyd_i          (mtx_ahb_hreadyd_i),
       .mtx_ahb_hreadyi_i          (mtx_ahb_hreadyi_i),
       .fe_haddracci_i             (fe_haddracci),
       .ahb_htransi_i              (ahb_htransi),
       .nvic_int_invoke_i          (nvic_int_invoke_i),
       .nvic_int_tail_i            (nvic_int_tail_i),
       .int_entry_i                (int_entry),
       .int_return_i               (int_return),
       .int_stack_op_i             (int_stack_op),
       .int_ret_fpu_i              (int_ret_fpu),
       .rf_rd_lr_de_i              (rf_rd_lr_de),
       .rf_wr_z_en_de_i            (rf_wr_z_en_de),
       .rf_wr_z_addr_de_i          (rf_wr_z_addr_de),
       .rf_rd_b_data_ex_i          (rf_rd_b_data_ex),
       .rf_rd_b_zero_ex_i          (rf_rd_b_zero_ex),
       .rf_wr_d_addr_erly_ex_i     (rf_wr_d_addr_erly_ex),
       .fault_dblfault_ex_i        (fault_dblfault_ex),
       .dbg_halted_i               (dbg_halted),
       .nvic_dbg_halt_req_i        (nvic_dbg_halt_req_i),
       .nvic_dbg_mon_req_i         (nvic_dbg_mon_req_i),
       .nvic_dbg_step_i            (nvic_dbg_step_i),
       .dbg_halted_reg_i           (dbg_halted_reg),
       .instr_valid_de_o           (instr_valid_de),
       .instr_valid_fpu_de_o       (instr_valid_fpu_de),
       .instr_use_word_de_o        (instr_used_word_de),
       .instr_advance_de_o         (instr_advance_de),
       .instr_imm_valid_fast_de_o  (instr_imm_valid_fast_de),
       .instr_imm_valid_de_o       (instr_imm_valid_de),
       .instr_immed_de_o           (instr_immed_de),
       .instr_lsm_immed_de_o       (instr_lsm_immed_de),
       .instr_has_shft_imm_de_o    (instr_has_shft_imm_de),
       .instr_copro_de_o           (instr_copro_de),
       .instr_bkpt_de_o            (instr_bkpt_de),
       .instr_svc_de_o             (instr_svc_de),
       .instr_wfe_de_o             (instr_wfe_de),
       .instr_wfi_de_o             (instr_wfi_de),
       .instr_undef_de_o           (instr_undef_de),
       .instr_txev_de_o            (instr_txev_de),
       .instr_czb_de_o             (instr_czb_de),
       .instr_16_mul_valid_de_o    (instr_16_mul_valid_de),
       .instr_barrier_de_o         (instr_barrier_de),
       .instr_msr_ctl_de_o         (instr_msr_ctl_de),
       .instr_cps_ctl_de_o         (instr_cps_ctl_de),
       .instr_algn_de_o            (instr_algn_de),
       .instr_sign_de_o            (instr_sign_de),
       .instr_data_size_de_o       (instr_data_size_de),
       .instr_mla_track_de_o       (instr_mla_track_de),
       .instr_lsm_baseinlist_de_o  (instr_lsm_baseinlist_de),
       .instr_ls_allow_pline_de_o  (instr_ls_allow_pline_de),
       .instr_ls_single_adv_de_o   (instr_ls_single_adv_de),
       .instr_cond_code_de_o       (instr_cond_code_de),
       .instr_itfold_de_o          (instr_itfold_de),
       .instr_itctl_de_o           (instr_itctl_de),
       .instr_sp_rd_de_o           (instr_sp_rd_de),
       .instr_sp_wr_de_o           (instr_sp_wr_de),
       .instr_pc_lr_de_o           (instr_pc_lr_de),
       .instr_exit_op_de_o         (instr_exit_op_de),
       .instr_isb_de_o             (instr_isb_de),
       .instr_br_t_changer_de_o    (instr_br_t_changer_de),
       .instr_br_lr_sel_de_o       (instr_br_lr_sel_de),
       .instr_br_cond_de_o         (instr_br_cond_de),
       .instr_br_imm_de_o          (instr_br_imm_de),
       .instr_br_ccpass_de_o       (instr_br_ccpass_de),
       .instr_brchstat_de_o        (instr_brchstat_de),
       .instr_de_br_det_de_o       (instr_de_br_det_de),
       .instr_br_req_de_o          (instr_br_req_de),
       .instr_br_pflush_fast_de_o  (instr_br_pflush_fast_de),
       .instr_br_pflush_de_o       (instr_br_pflush_de),
       .instr_lr_ilock_de_o        (instr_lr_ilock_de),
       .instr_lsu_int_ilock_de_o   (instr_lsu_int_ilock_de),
       .instr_all_ilock_de_o       (instr_all_ilock_de),
       .instr_alu_ctl_de_o         (instr_alu_ctl_de),
       .instr_lsu_ctl_de_o         (instr_lsu_ctl_de),
       .instr_de_2_ex_en_o         (instr_de_2_ex_en),
       .instr_br_imm_ex_o          (instr_br_imm_ex),
       .instr_pflush_ex_o          (instr_pflush_ex),
       .instr_br_type_ex_o         (instr_br_type_ex),
       .instr_lsu_br_det_ex_o      (instr_lsu_br_det_ex),
       .instr_det_erly_br_trk_o    (instr_det_erly_br_trk),
       .instr_det_erly_br_trk_v_o  (instr_det_erly_br_trk_v),
       .lazy_stall_erly_de_o       (lazy_stall_erly_de),
       .lazy_stall_de_o            (/* Not connected */),
       .etm_instr_valid_de_o       (etm_instr_valid_de),
       .rf_pc_wr_data_de_o         (rf_pc_wr_data_de),
       .rf_rd_a_en_de_o            (instr_rf_rd_a_en_de),
       .rf_rd_a_addr_de_o          (instr_rf_rd_a_addr_de),
       .rf_rd_b_en_de_o            (instr_rf_rd_b_en_de),
       .rf_rd_b_addr_de_o          (instr_rf_rd_b_addr_de),
       .instr_rf_rd_c_addr_de_o    (instr_rf_rd_c_addr_de),
       .rf_wr_d_en_de_o            (rf_wr_d_en_de),
       .rf_wr_d_addr_de_o          (rf_wr_d_addr_de),
       .fault_state_de_o           (fault_state_de),
       .fault_ici_de_o             (fault_ici_de),
       .fault_fetch_de_o           (fault_fetch_de));

  cm3_dpu_exec #(RESET_ALL_REGS, OBSERVATION, 0, 0)
    u_cm3_dpu_exec
      (// Inputs
       .hreset_n                   (hreset_n),
       .hclk                       (hclk),
       .instr_valid_fe_i           (instr_valid_fe),
       .instr_ext_pflush_fe_i      (instr_ext_pflush_fe),
       .instr_de_i                 (instr_de),
       .instr_valid_de_i           (instr_valid_de),
       .instr_ccpass_de_i          (instr_ccpass_de),
       .instr_immed_de_i           (instr_immed_de),
       .instr_imm_valid_de_i       (instr_imm_valid_de),
       .instr_algn_de_i            (instr_algn_de),
       .instr_barrier_de_i         (instr_barrier_de),
       .instr_br_t_changer_de_i    (instr_br_t_changer_de),
       .instr_czb_de_i             (instr_czb_de),
       .instr_used_word_de_i       (instr_used_word_de),
       .instr_sign_de_i            (instr_sign_de),
       .instr_data_size_de_i       (instr_data_size_de),
       .instr_exit_op_de_i         (instr_exit_op_de),
       .instr_msr_ctl_de_i         (instr_msr_ctl_de),
       .instr_cps_ctl_de_i         (instr_cps_ctl_de),
       .instr_svc_de_i             (instr_svc_de),
       .instr_wfe_de_i             (instr_wfe_de),
       .instr_wfi_de_i             (instr_wfi_de),
       .instr_undef_de_i           (instr_undef_de),
       .instr_txev_de_i            (instr_txev_de),
       .instr_bkpt_de_i            (instr_bkpt_de),
       .instr_copro_de_i           (instr_copro_de),
       .instr_16_mul_valid_de_i    (instr_16_mul_valid_de),
       .instr_has_shft_imm_de_i    (instr_has_shft_imm_de),
       .instr_alu_ctl_de_i         (instr_alu_ctl_de),
       .instr_lsu_ctl_de_i         (instr_lsu_ctl_de),
       .instr_itfold_de_i          (instr_itfold_de),
       .instr_sp_rd_de_i           (instr_sp_rd_de),
       .instr_sp_wr_de_i           (instr_sp_wr_de),
       .instr_pc_lr_de_i           (instr_pc_lr_de),
       .instr_advance_de_i         (instr_advance_de),
       .instr_lr_ilock_de_i        (instr_lr_ilock_de),
       .instr_all_ilock_de_i       (instr_all_ilock_de),
       .instr_de_2_ex_en_i         (instr_de_2_ex_en),
       .instr_ccpass_ex_i          (instr_ccpass_ex),
       .instr_excl_ex_i            (instr_excl_ex),
       .lsu_active_ex_i            (lsu_active_ex),
       .lsu_sp_wb_ex_i             (lsu_sp_wb_ex),
       .lsu_stall_ex_i             (lsu_stall_ex),
       .lsu_stall_late_ex_i        (lsu_stall_late_ex),
       .lsu_psr_ex_i               (lsu_psr_ex),
       .lsu_main_sp_en_i           (lsu_main_sp_en),
       .lsu_real_sp_rd_i           (lsu_real_sp_rd),
       .lsu_exit_code_ex_i         (lsu_exit_code_ex),
       .lsu_exit_valid_ex_i        (lsu_exit_valid_ex),
       .lsu_mcyc_ilock_ex_i        (lsu_mcyc_ilock_ex),
       .lsu_mcyc_invk_msk_ex_i     (lsu_mcyc_invk_msk_ex),
       .lsu_rf_rd_a_en_ex_i        (lsu_rf_rd_a_en_ex),
       .lsu_rf_rd_a_en_fast_ex_i   (lsu_rf_rd_a_en_fast_ex),
       .lsu_rf_rd_a_addr_ex_i      (lsu_rf_rd_a_addr_ex),
       .lsu_rf_wr_d_en_ex_i        (lsu_rf_wr_d_en_ex),
       .lsu_rf_wr_d_en_fast_ex_i   (lsu_rf_wr_d_en_fast_ex),
       .lsu_rf_wr_d_addr_ex_i      (lsu_rf_wr_d_addr_ex),
       .lsu_rf_wr_d_data_ex_i      (lsu_rf_wr_d_data_ex),
       .lsu_rf_wr_z_addr_ex_i      (lsu_rf_wr_z_addr_ex),
       .lsu_rf_wr_z_data_ex_i      (lsu_rf_wr_z_data_ex),
       .lsu_rf_wr_z_en_ex_i        (lsu_rf_wr_z_en_ex),
       .lsu_stack_start_i          (lsu_stack_start),
       .alu_stall_ex_i             (alu_stall_ex),
       .alu_exit_valid_ex_i        (alu_exit_valid_ex),
       .alu_exit_code_ex_i         (alu_exit_code_ex),
       .alu_mcyc_ilock_ex_i        (alu_mcyc_ilock_ex),
       .alu_mcyc_invk_msk_ex_i     (alu_mcyc_invk_msk_ex),
       .alu_rf_rd_a_en_ex_i        (alu_rf_rd_a_en_ex),
       .alu_rf_rd_a_addr_ex_i      (alu_rf_rd_a_addr_ex),
       .alu_rf_wr_d_en_ex_i        (alu_rf_wr_d_en_ex),
       .alu_rf_wr_d_addr_ex_i      (alu_rf_wr_d_addr_ex),
       .alu_rf_wr_d_data_ex_i      (alu_rf_wr_d_data_ex),
       .e_rf_wr_z_en_ex_i          (e_rf_wr_z_en_ex),
       .e_rf_wr_z_addr_ex_i        (e_rf_wr_z_addr_ex),
       .e_rf_wr_z_data_ex_i        (e_rf_wr_z_data_ex),
       .e_undef_de_i               (e_undef_de),
       .e_rf_wr_d_data_ex_i        (e_rf_wr_d_data_ex),
       .lazy_stall_erly_de_i       (lazy_stall_erly_de),
       .fpu_fpscr_wr_de_i          (fpu_fpscr_wr_de),
       .fpu_busy_ex_i              (fpu_busy_ex),
       .fpu_stall_ex_i             (fpu_stall_ex),
       .fpu_rf_addr_ex_i           (fpu_rf_addr_ex),
       .fpu_rf_wr_en_ex_i          (fpu_rf_wr_en_ex),
       .fpu_wr_data_ex_i           (fpu_wr_data_ex),
       .fpu_update_ctrl_i          (fpu_update_ctrl),
       .fpu_lazy_start_i           (fpu_lazy_start),
       .fpu_lazy_stack_op_i        (fpu_lazy_stack_op),
       .fpu_interlock_de_i         (fpu_interlock_de),
       .mtx_ahb_hreadyd_i          (mtx_ahb_hreadyd_i),
       .mtx_bm_active_i            (mtx_bm_active_i),
       .nvic_pmask_i               (nvic_pmask_i),
       .nvic_basepri_i             (nvic_basepri_i),
       .nvic_nonbasethrden_i       (nvic_nonbasethrden_i),
       .nvic_bfhfnmign_i           (nvic_bfhfnmign_i),
       .nvic_dismcycint_i          (nvic_dismcycint_i),
       .nvic_no_lazy_stk_i         (nvic_no_lazy_stk),
       .nvic_int_curr_isr_i        (nvic_int_curr_isr_i),
       .int_stack_op_i             (int_stack_op),
       .nvic_int_invoke_i          (nvic_int_invoke_i),
       .int_entry_i                (int_entry),
       .int_return_i               (int_return),
       .int_retisr_i               (int_retisr),
       .nvic_int_stk_actv_i        (nvic_int_stk_actv_i),
       .nvic_int_in_nmihf_i        (nvic_int_in_nmihf_i),
       .int_vector_fault_i         (int_vector_fault),
       .instr_rf_rd_a_en_de_i      (instr_rf_rd_a_en_de),
       .instr_rf_rd_a_addr_de_i    (instr_rf_rd_a_addr_de),
       .instr_rf_rd_b_en_de_i      (instr_rf_rd_b_en_de),
       .instr_rf_rd_b_addr_de_i    (instr_rf_rd_b_addr_de),
       .instr_rf_rd_c_addr_de_i    (instr_rf_rd_c_addr_de),
       .rf_wr_d_en_fe_i            (rf_wr_d_en_fe),
       .rf_wr_d_addr_fe_i          (rf_wr_d_addr_fe),
       .rf_wr_d_data_fe_i          (rf_wr_d_data_fe),
       .rf_wr_d_addr_de_i          (rf_wr_d_addr_de),
       .rf_rd_b_data_ex_i          (rf_rd_b_data_ex),
       .fault_fetch_de_i           (fault_fetch_de),
       .fault_state_de_i           (fault_state_de),
       .fault_ici_de_i             (fault_ici_de),
       .fault_lsu_ex_i             (fault_lsu_ex),
       .fault_divby0_ex_i          (fault_divby0_ex),
       .fault_nocopro_fpu_i        (fault_nocopro_fpu),
       .nvic_dbg_halt_req_i        (nvic_dbg_halt_req_i),
       .nvic_dbg_mon_req_i         (nvic_dbg_mon_req_i),
       .dbg_ctrl_wr_ex_i           (dbg_ctrl_wr_ex),
       .nvic_dbg_reg_addr_i        (nvic_dbg_reg_addr_i),
       .dbg_wr_isr_i               (dbg_wr_isr),
       .rst_pc_valid_ex_o          (rst_pc_valid_ex),
       .iflush_pflush_ex_o         (iflush_pflush_ex),
       .instr_ex_o                 (instr_ex),
       .instr_stall_ex_o           (instr_stall_ex),
       .instr_valid_ex_o           (instr_valid_ex),
       .instr_immed_ex_o           (instr_immed_ex),
       .instr_immed_valid_ex_o     (instr_immed_valid_ex),
       .instr_algn_ex_o            (instr_algn_ex),
       .instr_link_ex_o            (instr_link_ex),
       .instr_sign_ex_o            (instr_sign_ex),
       .instr_data_size_ex_o       (instr_data_size_ex),
       .instr_exit_op_ex_o         (instr_exit_op_ex),
       .instr_16_mul_ex_o          (instr_16_mul_ex),
       .instr_czb_ex_o             (instr_czb_ex),
       .instr_bkpt_ex_o            (instr_bkpt_ex),
       .instr_not_bkpt_ex_o        (instr_not_bkpt_ex),
       .instr_retire_ex_o          (instr_retire_ex),
       .instr_complete_ex_o        (instr_complete_ex),
       .instr_advance_ex_o         (instr_advance_ex),
       .instr_itfold_ex_o          (instr_itfold_ex),
       .instr_detect_exit_ex_o     (instr_detect_exit_ex),
       .instr_atbase_ex_o          (instr_atbase_ex),
       .instr_lr_ilock_ex_o        (instr_lr_ilock_ex),
       .instr_mcyc_ilock_ex_o      (instr_mcyc_ilock_ex),
       .instr_br_t_changer_ex_o    (instr_br_t_changer_ex),
       .instr_dp_pflush_ex_o       (instr_dp_pflush_ex),
       .instr_br_pflush_ex_o       (instr_br_pflush_ex),
       .set_instr_redo_ex_o        (set_instr_redo_ex),
       .instr_redo_ex_o            (instr_redo_ex),
       .instr_excl_reg_o           (instr_excl_reg),
       .privileged_o               (privileged),
       .user_thread_ex_o           (user_thread_ex),
       .rf_sp_rd_de_o              (rf_sp_rd_de),
       .rf_sp_wr_ex_o              (rf_sp_wr_ex),
       .rf_sp_sel_ex_o             (rf_sp_sel_ex),
       .rf_pc_ctl_ex_o             (rf_pc_ctl_ex),
       .rf_inc_pc_ex_o             (rf_inc_pc_ex),
       .rf_rd_a_en_de_o            (rf_rd_a_en_de),
       .rf_rd_a_addr_de_o          (rf_rd_a_addr_de),
       .rf_rd_b_en_de_o            (rf_rd_b_en_de),
       .rf_rd_b_addr_de_o          (rf_rd_b_addr_de),
       .rf_wr_d_en_ex_o            (rf_wr_d_en_ex),
       .rf_wr_d_addr_erly_ex_o     (rf_wr_d_addr_erly_ex),
       .rf_wr_d_addr_ex_o          (rf_wr_d_addr_ex),
       .rf_wr_d_data_erly_ex_o     (rf_wr_d_data_erly_ex),
       .rf_wr_d_data_ex_o          (rf_wr_d_data_ex),
       .rf_wr_z_en_ex_o            (/* Not connected */),
       .rf_wr_z_addr_ex_o          (/* Not connected */),
       .rf_wr_z_data_ex_o          (/* Not connected */),
       .dpu_mcyc_invk_msk_o        (dpu_mcyc_invk_msk),
       .dpu_slp_ctl_ex_o           (dpu_slp_ctl_ex),
       .dpu_slp_txev_ex_o          (dpu_slp_txev_ex),
       .dpu_basepri_we_o           (dpu_basepri_we),
       .dpu_basepri_ex_o           (dpu_basepri_ex),
       .dpu_fmask_we_o             (dpu_fmask_we),
       .dpu_fmask_ex_o             (dpu_fmask_ex),
       .dpu_pmask_we_o             (dpu_pmask_we),
       .dpu_pmask_ex_o             (dpu_pmask_ex),
       .dpu_raisepri_ex_o          (dpu_raisepri_ex),
       .fpu_active_ex_o            (fpu_active_ex),
       .frc_context_ex_o           (/* Not connected */),
       .int_lr_exit_code_ex_o      (int_lr_exit_code_ex),
       .int_isr_ex_o               (int_isr_ex),
       .dbg_halt_set_o             (dbg_halt_set),
       .dbg_halted_o               (dbg_halted),
       .dbg_halted_reg_o           (dbg_halted_reg),
       .fault_svc_ex_o             (fault_svc_ex),
       .fault_dblfault_ex_o        (fault_dblfault_ex),
       .dpu_nxt_bfsr_o             (dpu_nxt_bfsr),
       .dpu_nxt_mfsr_o             (dpu_nxt_mfsr),
       .dpu_nxt_ufsr_o             (dpu_nxt_ufsr),
       .dpu_nxt_hfsr_o             (dpu_nxt_hfsr));

  cm3_dpu_status #(0, 0)
    u_cm3_dpu_status
      (// Inputs
       .hreset_n                   (hreset_n),
       .hclk                       (hclk),
       .rst_pc_valid_ex_i          (rst_pc_valid_ex),
       .instr_valid_de_i           (instr_valid_de),
       .instr_br_cond_de_i         (instr_br_cond_de),
       .instr_itctl_de_i           (instr_itctl_de),
       .instr_cond_code_de_i       (instr_cond_code_de),
       .instr_itfold_de_i          (instr_itfold_de),
       .instr_ls_allow_pline_de_i  (instr_ls_allow_pline_de),
       .instr_ls_single_adv_de_i   (instr_ls_single_adv_de),
       .instr_valid_ex_i           (instr_valid_ex),
       .instr_czb_ex_i             (instr_czb_ex),
       .instr_itfold_ex_i          (instr_itfold_ex),
       .instr_stall_ex_i           (instr_stall_ex),
       .set_instr_redo_ex_i        (set_instr_redo_ex),
       .instr_redo_ex_i            (instr_redo_ex),
       .instr_br_t_changer_ex_i    (instr_br_t_changer_ex),
       .instr_br_pflush_ex_i       (instr_br_pflush_ex),
       .lsu_flag_wr_ex_i           (lsu_flag_wr_ex),
       .lsu_psr_ex_i               (lsu_psr_ex),
       .lsu_it_valid_ex_i          (lsu_it_valid_ex),
       .lsu_it_ex_i                (lsu_it_ex),
       .alu_zero_res_ex_i          (alu_zero_res_ex),
       .alu_flag_wr_ex_i           (alu_flag_wr_ex),
       .alu_flag_res_ex_i          (alu_flag_res_ex),
       .alu_ge_res_ex_i            (alu_ge_res_ex),
       .alu_mul_flag_res_ex_i      (alu_mul_flag_res_ex),
       .e_mac_flag_wr_ex_i         (e_mac_flag_wr_ex),
       .e_mac_nz_ex_i              (e_mac_nz_ex),
       .e_mac_q_set_ex_i           (e_mac_q_set_ex),
       .e_simd_q_set_ex_i          (e_simd_q_set_ex),
       .e_simd_ge_wr_ex_i          (e_simd_ge_wr_ex),
       .e_simd_ge_res_ex_i         (e_simd_ge_res_ex),
       .lsu_dbl_fault_ex_i         (lsu_dbl_fault_ex),
       .fault_lsu_precise_ex_i     (fault_lsu_precise_ex),
       .fpu_psr_wr_ex_i            (fpu_psr_wr_ex),
       .fpu_wr_data_ex_i           (fpu_wr_data_ex),
       .rf_wr_d_data_erly_ex_i     (rf_wr_d_data_erly_ex),
       .int_stack_op_i             (int_stack_op),
       .nvic_int_invoke_i          (nvic_int_invoke_i),
       .int_entry_i                (int_entry),
       .lsu_stack_start_i          (lsu_stack_start),
       .fpu_lazy_stack_op_i        (fpu_lazy_stack_op),
       .dbg_halted_i               (dbg_halted),
       .instr_itblock_de_o         (instr_itblock_de),
       .instr_itccfail_de_o        (instr_itccfail_de),
       .instr_ccpass_de_o          (instr_ccpass_de),
       .instr_itblock_ex_o         (instr_itblock_ex),
       .instr_ccpass_ex_o          (instr_ccpass_ex),
       .psr_t_ex_o                 (psr_t_ex),
       .psr_ex_o                   (psr_ex));

  cm3_dpu_alu #(CLKGATE_PRESENT, RESET_ALL_REGS, 0, 0)
    u_cm3_dpu_alu
      (// Inputs
       .hreset_n                   (hreset_n),
       .hclk                       (hclk),
       .ext_cg_bypass_i            (ext_cg_bypass_i),
       .instr_alu_ctl_de_i         (instr_alu_ctl_de),
       .instr_mla_track_de_i       (instr_mla_track_de),
       .instr_immed_de_i           (instr_immed_de),
       .instr_rf_rd_c_addr_de_i    (instr_rf_rd_c_addr_de),
       .instr_rf_wr_d_en_de_i      (rf_wr_d_en_de),
       .instr_rf_wr_d_addr_de_i    (rf_wr_d_addr_de),
       .instr_de_2_ex_en_i         (instr_de_2_ex_en),
       .instr_ccpass_ex_i          (instr_ccpass_ex),
       .instr_immed_valid_ex_i     (instr_immed_valid_ex),
       .instr_immed_ex_i           (instr_immed_ex),
       .instr_data_size_ex_i       (instr_data_size_ex),
       .instr_algn_ex_i            (instr_algn_ex),
       .instr_sign_ex_i            (instr_sign_ex),
       .instr_exit_op_ex_i         (instr_exit_op_ex),
       .rf_rd_a_data_ex_i          (rf_rd_a_data_ex),
       .rf_rd_a_zero_ex_i          (rf_rd_a_zero_ex),
       .rf_rd_b_data_ex_i          (rf_rd_b_data_ex),
       .rf_rd_b_zero_ex_i          (rf_rd_b_zero_ex),
       .e_simd_res_ex_i            (e_simd_res_ex),
       .fpu_active_ex_i            (fpu_active_ex),
       .privileged_i               (privileged),
       .nvic_basepri_i             (nvic_basepri_i),
       .nvic_fmask_i               (nvic_fmask_i),
       .nvic_pmask_i               (nvic_pmask_i),
       .nvic_div_0_trp_i           (nvic_div_0_trp_i),
       .nvic_int_invoke_i          (nvic_int_invoke_i),
       .int_entry_i                (int_entry),
       .int_isr_ex_i               (int_isr_ex),
       .psr_ex_i                   (psr_ex),
       .process_sp_ex_i            (rf_sp_sel_ex),
       .user_thread_ex_i           (user_thread_ex),
       .instr_flag_wr_ex_o         (instr_flag_wr_ex),
       .instr_rf_wr_d_addr_ex_o    (instr_rf_wr_d_addr_ex),
       .alu_shift_res_ex_o         (/* not connected */),
       .alu_will_wr_rf_ex_o        (alu_will_wr_rf_ex),
       .alu_rf_rd_a_en_ex_o        (alu_rf_rd_a_en_ex),
       .alu_rf_rd_a_addr_ex_o      (alu_rf_rd_a_addr_ex),
       .alu_rf_wr_d_en_ex_o        (alu_rf_wr_d_en_ex),
       .alu_rf_wr_d_addr_ex_o      (alu_rf_wr_d_addr_ex),
       .alu_rf_wr_d_data_ex_o      (alu_rf_wr_d_data_ex),
       .alu_zero_res_ex_o          (alu_zero_res_ex),
       .alu_flag_wr_ex_o           (alu_flag_wr_ex),
       .alu_flag_res_ex_o          (alu_flag_res_ex),
       .alu_ge_res_ex_o            (alu_ge_res_ex),
       .alu_mul_flag_res_ex_o      (alu_mul_flag_res_ex),
       .alu_exit_valid_ex_o        (alu_exit_valid_ex),
       .alu_exit_code_ex_o         (alu_exit_code_ex),
       .alu_stall_ex_o             (alu_stall_ex),
       .alu_mcyc_invk_msk_ex_o     (alu_mcyc_invk_msk_ex),
       .alu_mcyc_ilock_ex_o        (alu_mcyc_ilock_ex),
       .fault_divby0_ex_o          (fault_divby0_ex));

  assign e_undef_de           = 2'b11;
  assign e_shft_inlinec_de    = 1'b0;
  assign e_rf_rd_a_en_de      = 1'b0;
  assign e_rf_rd_a_addr_de    = 4'b0000;
  assign e_rf_rd_b_en_de      = 1'b0;
  assign e_rf_rd_b_addr_de    = 4'b0000;
  assign e_rf_wr_d_en_de      = 1'b0;
  assign e_rf_wr_d_addr_de    = 4'b0000;
  assign e_rd_c_addr_de       = 4'b0000;
  assign rf_wr_z_en_de        = 1'b0;
  assign rf_wr_z_addr_de      = 4'b0000;
  assign rf_rd_x_addr_ex      = 4'b0000;
  assign rf_rd_y_addr_ex      = 4'b0000;
  assign e_rf_wr_z_data_ex    = {32{1'b0}};
  assign e_rf_wr_z_en_ex      = 1'b0;
  assign e_rf_wr_z_addr_ex    = 4'b0000;
  assign e_rf_wr_d_data_ex    = {32{1'b0}};
  assign e_mac_flag_wr_ex     = 5'b00000;
  assign e_mac_nz_ex          = 2'b00;
  assign e_mac_q_set_ex       = 1'b0;
  assign e_simd_res_ex        = {32{1'b0}};
  assign e_simd_q_set_ex      = 1'b0;
  assign e_simd_ge_wr_ex      = 1'b0;
  assign e_simd_ge_res_ex     = 4'b0000;

  assign fpu_enabled          = 1'b0;
  assign fpu_undef_de         = 1'b1;
  assign fpu_lazy_stall_de    = 1'b0;
  assign fpu_ici_invalid_de   = 1'b0;
  assign fpu_rf_rd_addr_de    = 4'b0000;
  assign fpu_rf_addr_ex       = 4'b0000;
  assign fpu_rf_wr_en_ex      = 1'b0;
  assign fpu_rf_rd_en_de      = 1'b0;
  assign fpu_rf_rd_en_erly_de = 1'b0;
  assign fpu_rf_rd_en_ex      = 1'b0;
  assign fpu_wr_data_ex       = {32{1'b0}};
  assign fpu_ls_valid_de      = 1'b0;
  assign fpu_ls_immed_de      = {8{1'b0}};
  assign fpu_lsm_immed_de     = {8{1'b0}};
  assign fpu_lsu_ctl_de       = {15{1'b0}};
  assign fpu_first_reg_de     = 5'b00000;
  assign fpu_busy_ex          = 1'b0;
  assign fpu_stall_ex         = 1'b0;
  assign fpu_interlock_de     = 1'b0;
  assign fpu_r14_ilock_de     = 1'b0;
  assign fpu_mcyc_de          = 1'b0;
  assign fpu_str_fwd_de       = 2'b00;
  assign fpu_psr_wr_ex        = 1'b0;
  assign fpu_lazy_start       = 1'b0;
  assign fpu_lazy_cancel      = 1'b0;
  assign fpu_flip_stack       = 1'b0;
  assign fpu_int_cp_fault     = 1'b0;
  assign fault_nocopro_fpu    = 1'b0;
  assign fpu_update_ctrl      = 2'b00;
  assign fpu_stack_ctl        = 2'b00;
  assign fpu_unstack_ctl      = 2'b00;
  assign int_ret_fpu          = 1'b0;
  assign fpu_tail_status      = 2'b00;
  assign fpu_lazy_done        = 1'b0;
  assign fpu_lazy_stack_op    = 1'b0;
  assign fpu_fpscr_wr_de      = 1'b0;

  assign nvic_fpccr           = {32{1'b0}};
  assign nvic_fpcar           = {32{1'b0}};
  assign nvic_no_lazy_stk     = 1'b0;

  cm3_dpu_lsu #(RESET_ALL_REGS, 0, 0, CONST_AHB_CTRL)
    u_cm3_dpu_lsu
      (// Inputs
       .hreset_n                   (hreset_n),
       .hclk                       (hclk),
       .instr_valid_de_i           (instr_valid_de),
       .instr_lsu_ctl_de_i         (instr_lsu_ctl_de),
       .instr_immed_de_i           (instr_immed_de),
       .instr_lsm_immed_de_i       (instr_lsm_immed_de),
       .instr_imm_valid_fast_de_i  (instr_imm_valid_fast_de),
       .instr_ccpass_de_i          (instr_ccpass_de),
       .instr_algn_de_i            (instr_algn_de),
       .instr_ls_allow_pline_de_i  (instr_ls_allow_pline_de),
       .instr_ls_single_adv_de_i   (instr_ls_single_adv_de),
       .instr_lsu_int_ilock_de_i   (instr_lsu_int_ilock_de),
       .instr_lsm_baseinlist_de_i  (instr_lsm_baseinlist_de),
       .instr_data_size_de_i       (instr_data_size_de),
       .instr_itblock_ex_i         (instr_itblock_ex),
       .instr_immed_valid_ex_i     (instr_immed_valid_ex),
       .instr_immed_ex_i           (instr_immed_ex),
       .instr_data_size_ex_i       (instr_data_size_ex),
       .instr_sign_ex_i            (instr_sign_ex),
       .instr_exit_op_ex_i         (instr_exit_op_ex),
       .instr_detect_exit_ex_i     (instr_detect_exit_ex),
       .instr_atbase_ex_i          (instr_atbase_ex),
       .psr_ex_i                   (psr_ex),
       .privileged_i               (privileged),
       .process_sp_ex_i            (rf_sp_sel_ex),
       .user_thread_ex_i           (user_thread_ex),
       .nvic_data_be8_i            (nvic_data_be8_i),
       .rf_rd_a_addr_de_i          (rf_rd_a_addr_de),
       .rf_rd_b_addr_de_i          (rf_rd_b_addr_de),
       .instr_rf_rd_c_addr_de_i    (instr_rf_rd_c_addr_de),
       .rf_wr_d_addr_de_i          (rf_wr_d_addr_de),
       .rf_rd_a_data_de_i          (rf_rd_a_data_de),
       .rf_rd_b_data_de_i          (rf_rd_b_data_de),
       .rf_rd_a_data_ex_i          (rf_rd_a_data_ex),
       .rf_rd_b_data_ex_i          (rf_rd_b_data_ex),
       .mtx_ahb_hreadyd_i          (mtx_ahb_hreadyd_i),
       .mtx_ahb_haddraccd_i        (mtx_ahb_haddraccd_i),
       .mtx_ahb_hrespd_i           (mtx_ahb_hrespd_i),
       .mpu_hrespd_i               (mpu_hrespd_i),
       .mtx_ahb_hrdatad_i          (mtx_ahb_hrdatad_i),
       .mtx_ahb_exrespd_i          (mtx_ahb_exrespd_i),
       .mpu_canceld_i              (mpu_canceld_i),
       .mpu_addrd_non_buf_i        (mpu_addrd_non_buf_i),
       .mtx_bm_active_i            (mtx_bm_active_i),
       .fpu_enabled_i              (fpu_enabled),
       .fpu_first_reg_de_i         (fpu_first_reg_de),
       .fpu_str_fwd_de_i           (fpu_str_fwd_de),
       .fpu_wr_data_ex_i           (fpu_wr_data_ex),
       .fpu_active_ex_i            (fpu_active_ex),
       .fpu_lazy_start_i           (fpu_lazy_start),
       .fpu_flip_stack_i           (fpu_flip_stack),
       .fpu_int_cp_fault_i         (fpu_int_cp_fault),
       .fpu_stack_ctl_i            (fpu_stack_ctl),
       .fpu_unstack_ctl_i          (fpu_unstack_ctl),
       .fpu_lazy_stack_op_i        (fpu_lazy_stack_op),
       .nvic_basepri_i             (nvic_basepri_i),
       .nvic_fmask_i               (nvic_fmask_i),
       .nvic_pmask_i               (nvic_pmask_i),
       .nvic_bfhfnmign_i           (nvic_bfhfnmign_i),
       .nvic_int_stk_algn_i        (nvic_int_stk_algn_i),
       .nvic_unalign_trp_i         (nvic_unalign_trp_i),
       .nvic_int_invoke_i          (nvic_int_invoke_i),
       .nvic_int_tail_i            (nvic_int_tail_i),
       .nvic_fpccr_i               (nvic_fpccr),
       .nvic_fpcar_i               (nvic_fpcar),
       .int_first_instr_valid_i    (int_first_instr_valid),
       .int_isr_ex_i               (int_isr_ex),
       .int_lr_exit_code_ex_i      (int_lr_exit_code_ex),
       .nvic_int_in_nmihf_i        (nvic_int_in_nmihf_i),
       .rst_pc_valid_ex_i          (rst_pc_valid_ex),
       .iflush_pflush_ex_i         (iflush_pflush_ex),
       .nvic_slp_asleep_i          (nvic_slp_asleep_i),
       .nvic_slp_sleeponexit_i     (nvic_slp_sleeponexit_i),
       .fault_dblfault_ex_i        (fault_dblfault_ex),
       .nvic_dbg_reg_addr_i        (nvic_dbg_reg_addr_i),
       .nvic_dbg_trans_i           (nvic_dbg_trans_i),
       .nvic_dbg_reg_wr_i          (nvic_dbg_reg_wr_i),
       .dbg_halt_set_i             (dbg_halt_set),
       .dbg_halted_i               (dbg_halted),
       .instr_excl_ex_o            (instr_excl_ex),
       .instr_lsu_ctl_ex_o         (instr_lsu_ctl_ex),
       .lsu_valid_ex_o             (lsu_valid_ex),
       .lsu_state_ex_o             (lsu_state_ex),
       .lsu_active_ex_o            (lsu_active_ex),
       .lsu_sp_wb_ex_o             (lsu_sp_wb_ex),
       .lsu_stall_ex_o             (lsu_stall_ex),
       .lsu_stall_late_ex_o        (lsu_stall_late_ex),
       .lsu_str_buf_imm_ex_o       (lsu_str_buf_imm_ex),
       .lsu_flag_wr_ex_o           (lsu_flag_wr_ex),
       .lsu_psr_ex_o               (lsu_psr_ex),
       .lsu_it_valid_ex_o          (lsu_it_valid_ex),
       .lsu_it_ex_o                (lsu_it_ex),
       .lsu_nxt_lsm_fpu_ex_o       (/* not connected */),
       .lsu_lsm_reg_ex_o           (/* not connected */),
       .lsu_lsm_last_ex_o          (/* not connected */),
       .lsu_lsm_list_valid_ex_o    (/* not connected */),
       .lsu_stackpush_rdy_ex_o     (lsu_stackpush_rdy_ex),
       .lsu_exit_code_ex_o         (lsu_exit_code_ex),
       .lsu_exit_valid_ex_o        (lsu_exit_valid_ex),
       .lsu_pflush_ex_o            (lsu_pflush_ex),
       .lsu_fix_pc_ex_o            (lsu_fix_pc_ex),
       .lsu_mcyc_invk_msk_ex_o     (lsu_mcyc_invk_msk_ex),
       .lsu_ahb_invk_msk_o         (lsu_ahb_invk_msk),
       .lsu_mcyc_ilock_ex_o        (lsu_mcyc_ilock_ex),
       .lsu_local_fault_ex_o       (lsu_local_fault_ex),
       .lsu_dbl_fault_ex_o         (lsu_dbl_fault_ex),
       .lsu_will_wr_rf_ex_o        (lsu_will_wr_rf_ex),
       .lsu_rf_rd_a_en_ex_o        (lsu_rf_rd_a_en_ex),
       .lsu_rf_rd_a_en_fast_ex_o   (lsu_rf_rd_a_en_fast_ex),
       .lsu_rf_rd_a_addr_ex_o      (lsu_rf_rd_a_addr_ex),
       .lsu_rf_wr_d_en_ex_o        (lsu_rf_wr_d_en_ex),
       .lsu_rf_wr_d_en_fast_ex_o   (lsu_rf_wr_d_en_fast_ex),
       .lsu_rf_wr_d_addr_ex_o      (lsu_rf_wr_d_addr_ex),
       .lsu_rf_wr_d_data_ex_o      (lsu_rf_wr_d_data_ex),
       .lsu_rf_wr_z_addr_ex_o      (lsu_rf_wr_z_addr_ex),
       .lsu_rf_wr_z_en_ex_o        (lsu_rf_wr_z_en_ex),
       .lsu_rf_wr_z_data_ex_o      (lsu_rf_wr_z_data_ex),
       .lsu_fpu_rd_data_ex_o       (/* not connected */),
       .lsu_fp_ls_rf_addr_ex_o     (/* not connected */),
       .lsu_nxt_fpcar_o            (/* not connected */),
       .lsu_main_sp_en_o           (lsu_main_sp_en),
       .lsu_real_sp_rd_o           (lsu_real_sp_rd),
       .lsu_ici_cont_o             (lsu_ici_cont),
       .lsu_stack_start_o          (lsu_stack_start),
       .lsu_addrd_non_buf_o        (lsu_addrd_non_buf),
       .ahb_htransd_o              (ahb_htransd),
       .ahb_hwrited_o              (ahb_hwrited),
       .ahb_hsized_o               (ahb_hsized),
       .ahb_haddrd_o               (ahb_haddrd),
       .ahb_hwdatad_o              (ahb_hwdatad),
       .ahb_hprotd_o               (ahb_hprotd),
       .ahb_exreqd_o               (ahb_exreqd),
       .dpu_addrd_valid_o          (dpu_addrd_valid),
       .int_entry_o                (int_entry),
       .int_exit_o                 (int_exit),
       .int_return_o               (int_return),
       .int_retisr_o               (int_retisr),
       .int_stack_op_o             (int_stack_op),
       .int_unstacking_o           (int_unstacking),
       .fault_lsu_precise_ex_o     (fault_lsu_precise_ex),
       .fault_lsu_ex_o             (fault_lsu_ex),
       .dbg_ctrl_wr_ex_o           (dbg_ctrl_wr_ex),
       .dbg_wr_isr_o               (dbg_wr_isr),
       .dbg_ready_o                (dbg_ready));

  cm3_dpu_regbank #(RESET_ALL_REGS, OBSERVATION)
    u_cm3_dpu_regbank
      (// Inputs
       .hreset_n                   (hreset_n),
       .hclk                       (hclk),
       .instr_valid_de_i           (instr_valid_de),
       .instr_used_word_de_i       (instr_used_word_de),
       .rf_rd_a_en_de_i            (rf_rd_a_en_de),
       .rf_rd_a_addr_de_i          (rf_rd_a_addr_de),
       .rf_rd_b_en_de_i            (rf_rd_b_en_de),
       .rf_rd_b_addr_de_i          (rf_rd_b_addr_de),
       .rf_sp_rd_de_i              (rf_sp_rd_de),
       .rf_wr_d_en_ex_i            (rf_wr_d_en_ex),
       .rf_wr_d_addr_ex_i          (rf_wr_d_addr_ex),
       .rf_wr_d_data_ex_i          (rf_wr_d_data_ex),
       .rf_wr_d_data_erly_ex_i     (rf_wr_d_data_erly_ex),
       .rf_sp_wr_ex_i              (rf_sp_wr_ex),
       .rf_sp_sel_ex_i             (rf_sp_sel_ex),
       .rf_pc_ctl_ex_i             (rf_pc_ctl_ex),
       .rf_inc_pc_ex_i             (rf_inc_pc_ex),
       .lsu_fix_pc_ex_i            (lsu_fix_pc_ex),
       .instr_link_ex_i            (instr_link_ex),
       .fault_lsu_precise_ex_i     (fault_lsu_precise_ex),
       .rf_rd_a_data_de_o          (rf_rd_a_data_de),
       .rf_rd_b_data_de_o          (rf_rd_b_data_de),
       .rf_rd_lr_de_o              (rf_rd_lr_de),
       .rf_rd_a_data_ex_o          (rf_rd_a_data_ex),
       .rf_rd_a_zero_ex_o          (rf_rd_a_zero_ex),
       .rf_rd_b_data_ex_o          (rf_rd_b_data_ex),
       .rf_rd_b_zero_ex_o          (rf_rd_b_zero_ex),
       .rf_pc_fwd_ex_o             (rf_pc_fwd_ex),
       .rf_observation_o           (rf_observation));

  assign rf_rd_x_data_ex = {32{1'b0}};
  assign rf_rd_y_data_ex = {32{1'b0}};

  cm3_dpu_etmintf
    u_cm3_dpu_etmintf
      (// Inputs
       .hreset_n                   (hreset_n),
       .hclk                       (hclk),
       .etm_ifen_i                 (etm_ifen_i),
       .etm_fifofull_i             (etm_fifofull_i),
       .etm_instr_valid_de_i       (etm_instr_valid_de),
       .instr_ext_pflush_fe_i      (instr_ext_pflush_fe),
       .instr_isb_de_i             (instr_isb_de),
       .instr_immed_valid_ex_i     (instr_immed_valid_ex),
       .instr_ccpass_ex_i          (instr_ccpass_ex),
       .instr_stall_ex_i           (instr_stall_ex),
       .instr_not_bkpt_ex_i        (instr_not_bkpt_ex),
       .instr_br_pflush_ex_i       (instr_br_pflush_ex),
       .instr_itfold_ex_i          (instr_itfold_ex),
       .instr_complete_ex_i        (instr_complete_ex),
       .lsu_valid_ex_i             (lsu_valid_ex),
       .lsu_stack_start_i          (lsu_stack_start),
       .lsu_dbl_fault_ex_i         (lsu_dbl_fault_ex),
       .fpu_lazy_stack_op_i        (fpu_lazy_stack_op),
       .nvic_lockup_i              (nvic_lockup_i),
       .nvic_int_curr_isr_i        (nvic_int_curr_isr_i),
       .nvic_int_nxt_isr_i         (nvic_int_nxt_isr_i),
       .nvic_int_invoke_i          (nvic_int_invoke_i),
       .int_stack_op_i             (int_stack_op),
       .int_entry_i                (int_entry),
       .int_exit_i                 (int_exit),
       .int_return_i               (int_return),
       .rst_pc_valid_ex_i          (rst_pc_valid_ex),
       .ahb_htransd_i              (ahb_htransd),
       .nvic_slp_asleep_i          (nvic_slp_asleep_i),
       .rf_pc_fwd_ex_i             (rf_pc_fwd_ex),
       .fault_lsu_precise_ex_i     (fault_lsu_precise_ex),
       .dbg_halted_i               (dbg_halted),
       .nvic_dbg_mon_req_i         (nvic_dbg_mon_req_i),
       .nvic_dbg_halt_req_i        (nvic_dbg_halt_req_i),
       .etm_ivalid_o               (etm_ivalid),
       .etm_ia_o                   (etm_ia),
       .etm_istall_o               (etm_istall),
       .etm_ibranch_o              (etm_ibranch),
       .etm_iindrbr_o              (etm_iindrbr),
       .etm_iccfail_o              (etm_iccfail),
       .etm_isb_o                  (etm_isb),
       .etm_dvalid_o               (etm_dvalid),
       .etm_pstat_o                (etm_pstat),
       .etm_fold_o                 (etm_fold),
       .etm_lsu_o                  (etm_lsu),
       .etm_cancel_o               (etm_cancel),
       .etm_intstat_o              (etm_intstat),
       .etm_intnum_o               (etm_intnum),
       .etm_flush_o                (etm_flush),
       .etm_findbr_o               (etm_findbr),
       .etm_stall_o                (etm_stall));

  assign dpu_ahb_haddri_o       = ahb_haddri;
  assign dpu_ahb_htransi_o      = ahb_htransi;
  assign dpu_ahb_hsizei_o       = ahb_hsizei;
  assign dpu_ahb_hproti_o       = ahb_hproti;
  assign dpu_ahb_haddrd_o       = ahb_haddrd;
  assign dpu_ahb_htransd_o      = ahb_htransd;
  assign dpu_ahb_hwrited_o      = ahb_hwrited;
  assign dpu_ahb_hsized_o       = ahb_hsized;
  assign dpu_ahb_hwdatad_o      = ahb_hwdatad;
  assign dpu_ahb_hprotd_o       = ahb_hprotd;
  assign dpu_ahb_exreqd_o       = ahb_exreqd;
  assign dpu_ahb_htransi_iss_o  = ahb_htransi_track;
  assign dpu_rst_pc_valid_o     = rst_pc_valid_ex;
  assign dpu_int_entry_o        = int_entry;
  assign dpu_int_exit_o         = int_exit;
  assign dpu_int_return_o       = int_return;
  assign dpu_int_retisr_o       = int_retisr;
  assign dpu_branch_stat_o      = instr_brchstat_de;
  assign dpu_ivalid_o           = instr_valid_de;
  assign dpu_retire_o           = instr_retire_ex;
  assign dpu_bkpt_o             = instr_bkpt_ex;
  assign dpu_nxt_bfsr_o         = dpu_nxt_bfsr;
  assign dpu_nxt_mfsr_o         = dpu_nxt_mfsr;
  assign dpu_nxt_ufsr_o         = dpu_nxt_ufsr;
  assign dpu_nxt_hfsr_o         = dpu_nxt_hfsr;
  assign dpu_basepri_we_o       = dpu_basepri_we;
  assign dpu_basepri_nxt_o      = dpu_basepri_ex;
  assign dpu_fmask_we_o         = dpu_fmask_we;
  assign dpu_fmask_nxt_o        = dpu_fmask_ex;
  assign dpu_pmask_we_o         = dpu_pmask_we;
  assign dpu_pmask_nxt_o        = dpu_pmask_ex;
  assign dpu_raisepri_o         = dpu_raisepri_ex;
  assign dpu_slp_txev_o         = dpu_slp_txev_ex;
  assign dpu_slp_ctl_o          = dpu_slp_ctl_ex;
  assign dpu_ahb_haddrd_valid_o = dpu_addrd_valid;
  assign dpu_mcyc_invk_msk_o    = dpu_mcyc_invk_msk;
  assign dpu_ahb_invk_msk_o     = lsu_ahb_invk_msk;
  assign dpu_force_non_buf_o    = lsu_addrd_non_buf;
  assign dpu_svc_o              = fault_svc_ex;
  assign dpu_obs_rf_o           = rf_observation;
  assign dpu_obs_instr_o        = instr_ex;
  assign dpu_dbg_halted_o       = dbg_halted;
  assign dpu_dbg_ready_o        = dbg_ready;
  assign dpu_dbg_wr_isr_o       = dbg_wr_isr;
  assign dpu_etm_ivalid_o       = etm_ivalid;
  assign dpu_etm_istall_o       = etm_istall;
  assign dpu_etm_ibranch_o      = etm_ibranch;
  assign dpu_etm_iindrbr_o      = etm_iindrbr;
  assign dpu_etm_iccfail_o      = etm_iccfail;
  assign dpu_etm_isb_o          = etm_isb;
  assign dpu_etm_ia_o           = etm_ia;
  assign dpu_etm_pstat_o        = etm_pstat;
  assign dpu_etm_fold_o         = etm_fold;
  assign dpu_etm_dvalid_o       = etm_dvalid;
  assign dpu_etm_lsu_o          = etm_lsu;
  assign dpu_etm_cancel_o       = etm_cancel;
  assign dpu_etm_intstat_o      = etm_intstat;
  assign dpu_etm_intnum_o       = etm_intnum;
  assign dpu_etm_flush_o        = etm_flush;
  assign dpu_etm_findbr_o       = etm_findbr;


`ifdef ARM_CM3_EASY_DEBUG

  cm3_dpu_debug_view
    u_cm3_dpu_debug_view
      (
       );

`endif

`include "cm3_dpu_undefs.vp"

endmodule
