`include "cm3_dpu_defs.vp"

module cm3_dpu_dec
  (// Inputs
   hreset_n, hclk, state_fe_i, fe_address_add_res_i, fe_buf_has_valid_instr_i,
   instr_word_present_fe_i, instr_stop_adv_fe_i, instr_valid_fe_i,
   instr_fault_fe_i, instr_de_i, instr_ccpass_de_i, instr_itccfail_de_i,
   instr_itblock_de_i, instr_valid_ex_i, instr_ccpass_ex_i, instr_stall_ex_i,
   instr_not_bkpt_ex_i, instr_16_mul_ex_i, instr_immed_valid_ex_i,
   instr_mcyc_ilock_ex_i, instr_lsu_ctl_ex_i, instr_flag_wr_ex_i,
   instr_atbase_ex_i, instr_detect_exit_ex_i, instr_dp_pflush_ex_i,
   instr_br_pflush_ex_i, instr_lr_ilock_ex_i, instr_rf_wr_d_addr_ex_i,
   instr_excl_reg_i, set_instr_redo_ex_i, alu_will_wr_rf_ex_i, lsu_valid_ex_i,
   lsu_stall_late_ex_i, lsu_flag_wr_ex_i, lsu_pflush_ex_i, lsu_will_wr_rf_ex_i,
   lsu_rf_wr_d_addr_ex_i, lsu_rf_wr_d_data_ex_i, lsu_ici_cont_i,
   lsu_stack_start_i, e_undef_de_i, e_shft_inlinec_de_i, e_rf_rd_a_en_de_i,
   e_rf_rd_a_addr_de_i, e_rf_rd_b_en_de_i, e_rf_rd_b_addr_de_i,
   e_rd_c_addr_de_i, e_rf_wr_d_en_de_i, e_rf_wr_d_addr_de_i, e_rf_wr_z_en_ex_i,
   e_rf_wr_z_addr_ex_i, fpu_enabled_i, fpu_lsu_ctl_de_i, fpu_ls_valid_de_i,
   fpu_ls_immed_de_i, fpu_lsm_immed_de_i, fpu_interlock_de_i, fpu_undef_de_i,
   fpu_lazy_stall_de_i, fpu_ici_invalid_de_i, fpu_r14_ilock_de_i,
   fpu_rf_rd_en_de_i, fpu_rf_rd_en_erly_de_i, fpu_rf_rd_addr_de_i,
   fpu_rf_rd_en_ex_i, fpu_rf_wr_en_ex_i, fpu_rf_addr_ex_i, fpu_mcyc_de_i,
   fpu_tail_status_i, fpu_lazy_done_i, fpu_lazy_cancel_i, psr_t_ex_i,
   privileged_i, mtx_bm_active_i, nvic_disfold_i, nvic_slp_asleep_i,
   nvic_aux_ctrl1_we_i, ext_iflush_i, mtx_ahb_hrespd_i, mtx_ahb_hreadyd_i,
   mtx_ahb_hreadyi_i, fe_haddracci_i, ahb_htransi_i, nvic_int_invoke_i,
   nvic_int_tail_i, int_entry_i, int_return_i, int_stack_op_i, int_ret_fpu_i,
   rf_rd_lr_de_i, rf_wr_z_en_de_i, rf_wr_z_addr_de_i, rf_rd_b_data_ex_i,
   rf_rd_b_zero_ex_i, rf_wr_d_addr_erly_ex_i, fault_dblfault_ex_i, dbg_halted_i,
   nvic_dbg_halt_req_i, nvic_dbg_mon_req_i, nvic_dbg_step_i, dbg_halted_reg_i,
   instr_valid_de_o, instr_valid_fpu_de_o, instr_use_word_de_o,
   instr_advance_de_o, instr_imm_valid_fast_de_o, instr_imm_valid_de_o,
   instr_immed_de_o, instr_lsm_immed_de_o, instr_has_shft_imm_de_o,
   instr_copro_de_o, instr_bkpt_de_o, instr_svc_de_o, instr_wfe_de_o,
   instr_wfi_de_o, instr_undef_de_o, instr_txev_de_o, instr_czb_de_o,
   instr_16_mul_valid_de_o, instr_barrier_de_o, instr_msr_ctl_de_o,
   instr_cps_ctl_de_o, instr_algn_de_o, instr_sign_de_o, instr_data_size_de_o,
   instr_mla_track_de_o, instr_lsm_baseinlist_de_o, instr_ls_allow_pline_de_o,
   instr_ls_single_adv_de_o, instr_cond_code_de_o, instr_itfold_de_o,
   instr_itctl_de_o, instr_sp_rd_de_o, instr_sp_wr_de_o, instr_pc_lr_de_o,
   instr_exit_op_de_o, instr_isb_de_o, instr_br_t_changer_de_o,
   instr_br_lr_sel_de_o, instr_br_cond_de_o, instr_br_imm_de_o,
   instr_br_ccpass_de_o, instr_brchstat_de_o, instr_de_br_det_de_o,
   instr_br_req_de_o, instr_br_pflush_fast_de_o, instr_br_pflush_de_o,
   instr_lr_ilock_de_o, instr_lsu_int_ilock_de_o, instr_all_ilock_de_o,
   instr_alu_ctl_de_o, instr_lsu_ctl_de_o, instr_de_2_ex_en_o,
   instr_br_imm_ex_o, instr_pflush_ex_o, instr_br_type_ex_o,
   instr_lsu_br_det_ex_o, instr_det_erly_br_trk_o, instr_det_erly_br_trk_v_o,
   etm_instr_valid_de_o, rf_pc_wr_data_de_o, rf_rd_a_en_de_o, rf_rd_a_addr_de_o,
   rf_rd_b_en_de_o, rf_rd_b_addr_de_o, instr_rf_rd_c_addr_de_o, rf_wr_d_en_de_o,
   rf_wr_d_addr_de_o, lazy_stall_erly_de_o, lazy_stall_de_o,
   fault_state_de_o, fault_ici_de_o, fault_fetch_de_o
  );

  parameter      EXT_PRESENT = 0;           // Extensions present if 1
  parameter      FPU_PRESENT = 0;           // FPU present if 1

  input          hreset_n;
  input          hclk;
  input [3:0]    state_fe_i;                // Fetch state
  input [31:1]   fe_address_add_res_i;      // Fetch address adder result
  input          fe_buf_has_valid_instr_i;  // Fetch buffer has valid instr
  input          instr_word_present_fe_i;   // Word present in fetch buffer
  input          instr_stop_adv_fe_i;       // Stop decode time advance
  input          instr_valid_fe_i;          // Instruction in fetch is valid
  input [1:0]    instr_fault_fe_i;          // Instruction in fetch has faulted
  input [31:0]   instr_de_i;                // Instruction in decode
  input          instr_ccpass_de_i;         // Condition code pass
  input          instr_itccfail_de_i;       // Condition code fail IT
  input          instr_itblock_de_i;        // In IT block
  input          instr_valid_ex_i;          // Instruction in execute is valid
  input          instr_ccpass_ex_i;         // Condition code pass
  input [3:0]    instr_stall_ex_i;          // Instruction stall information
  input          instr_not_bkpt_ex_i;       // Instruction is not a BKPT
  input          instr_16_mul_ex_i;         // Instruction is a T1 MUL
  input          instr_immed_valid_ex_i;    // Immediate valid
  input          instr_mcyc_ilock_ex_i;     // Multi-cycle op interlock
  input [15:0]   instr_lsu_ctl_ex_i;        // LSU control
  input          instr_flag_wr_ex_i;        // Instruction writes to the flags
  input          instr_atbase_ex_i;         // Core in thread
  input          instr_detect_exit_ex_i;    // ISR exit detected
  input          instr_dp_pflush_ex_i;      // DP op pipeline flush
  input [2:0]    instr_br_pflush_ex_i;      // Branch pipeline flush
  input          instr_lr_ilock_ex_i;       // LR interlock
  input [3:0]    instr_rf_wr_d_addr_ex_i;   // RF D port write address from instr
  input          instr_excl_reg_i;          // Instruction is an exclusive (reg)
  input          set_instr_redo_ex_i;       // Set redo instr
  input          alu_will_wr_rf_ex_i;       // ALU will write to RF
  input          lsu_valid_ex_i;            // LSU operation is valid
  input          lsu_flag_wr_ex_i;          // LSU flag result write enable
  input          lsu_pflush_ex_i;           // LSU pipe flush
  input          lsu_will_wr_rf_ex_i;       // LSU will write to RF imminently
  input [3:0]    lsu_rf_wr_d_addr_ex_i;     // LSU RF D port write address
  input [31:0]   lsu_rf_wr_d_data_ex_i;     // LSU RF D port write data
  input          lsu_stack_start_i;         // LSU stack op start
  input [3:0]    lsu_ici_cont_i;            // ICI bits from stack
  input          lsu_stall_late_ex_i;       // LSU very late stall
  input          e_undef_de_i;              // Undefined E extension instruction
  input          e_shft_inlinec_de_i;       // E unit requires inline carry shift
  input          e_rf_rd_a_en_de_i;         // E unit A port read enable
  input [3:0]    e_rf_rd_a_addr_de_i;       // E unit A port read address
  input          e_rf_rd_b_en_de_i;         // E unit B port read enable
  input [3:0]    e_rf_rd_b_addr_de_i;       // E unit B port read address
  input [3:0]    e_rd_c_addr_de_i;          // E unit secondary read address
  input          e_rf_wr_d_en_de_i;         // E unit D port write enable
  input [3:0]    e_rf_wr_d_addr_de_i;       // E unit D port write address
  input          e_rf_wr_z_en_ex_i;         // RF Z port write enable
  input [3:0]    e_rf_wr_z_addr_ex_i;       // RF Z port write address
  input [14:0]   fpu_lsu_ctl_de_i;          // FPU LSU control
  input          fpu_ls_valid_de_i;         // FPU LSU operation valid
  input [7:0]    fpu_ls_immed_de_i;         // FPU LSU immediate
  input [7:0]    fpu_lsm_immed_de_i;        // FPU fast LSM immediate
  input          fpu_enabled_i;             // FPU enabled
  input          fpu_mcyc_de_i;             // Multi-cycle FPU op in progress
  input          fpu_interlock_de_i;        // FPU interlock
  input          fpu_r14_ilock_de_i;        // FPU R14 interlock
  input          fpu_undef_de_i;            // FPU undefined instruction
  input          fpu_lazy_stall_de_i;       // FPU lazy stall
  input          fpu_ici_invalid_de_i;      // FPU LSM ICI not valid
  input          fpu_rf_rd_en_de_i;         // FPU RF read enable
  input          fpu_rf_rd_en_erly_de_i;    // FPU RF read enable (early)
  input [3:0]    fpu_rf_rd_addr_de_i;       // FPU RF read address
  input          fpu_rf_rd_en_ex_i;         // FPU RF read enable
  input          fpu_rf_wr_en_ex_i;         // FPU RF D port write enable
  input [3:0]    fpu_rf_addr_ex_i;          // FPU RF D port write address
  input [1:0]    fpu_tail_status_i;         // FPU int tail status
  input          fpu_lazy_cancel_i;         // Cancel lazy stack request
  input          fpu_lazy_done_i;           // FPU lazy stacking done
  input          psr_t_ex_i;                // T bit
  input          privileged_i;              // Privileged (vs user) mode
  input          mtx_bm_active_i;           // Bus-matrix active
  input          nvic_disfold_i;            // Disable IT folding
  input          nvic_slp_asleep_i;         // Core asleep
  input          nvic_aux_ctrl1_we_i;       // Auxiliary Ctrl write enable
  input          ext_iflush_i;              // IFLUSH request
  input [1:0]    mtx_ahb_hrespd_i;          // AHB D-side HRESP
  input          mtx_ahb_hreadyd_i;         // AHB D-side HREADY
  input          mtx_ahb_hreadyi_i;         // AHB I-side HREADY
  input          fe_haddracci_i;            // Modified I-side HADDRACC
  input [1:0]    ahb_htransi_i;             // AHB I-side HTRANS
  input          nvic_int_invoke_i;         // Interrupt stack request
  input          nvic_int_tail_i;           // Interrupt tail-chain request
  input          int_entry_i;               // ISR entry
  input          int_return_i;              // Unstacking complete
  input          int_stack_op_i;            // LSU is stacking/unstacking
  input          int_ret_fpu_i;             // Returned to FPU context active
  input [31:0]   rf_rd_lr_de_i;             // R14
  input          rf_wr_z_en_de_i;           // RF Z port write enable
  input [3:0]    rf_wr_z_addr_de_i;         // RF Z port write address
  input [31:0]   rf_rd_b_data_ex_i;         // RF B port read data
  input [1:0]    rf_rd_b_zero_ex_i;         // RF B port read data HW zero
  input [3:0]    rf_wr_d_addr_erly_ex_i;    // RF D port write address (early)
  input          fault_dblfault_ex_i;       // Double fault
  input          dbg_halted_i;              // Core halted
  input          nvic_dbg_halt_req_i;       // Core halt request
  input          nvic_dbg_mon_req_i;        // Core monitor request
  input          nvic_dbg_step_i;           // Debug step
  input          dbg_halted_reg_i;          // Core halted (registered)

  output         instr_valid_de_o;          // Instruction in decode is valid
  output         instr_valid_fpu_de_o;      // Instruction valid for FPU
  output         instr_use_word_de_o;       // Consumed 32 bits of instruction
  output         instr_advance_de_o;        // Advance instruction
  output         instr_imm_valid_fast_de_o; // Immediate valid (fast)
  output         instr_imm_valid_de_o;      // Immediate valid
  output [31:0]  instr_immed_de_o;          // Immediate
  output [31:0]  instr_lsm_immed_de_o;      // LSM immediate
  output         instr_has_shft_imm_de_o;   // Shifted immediate valid
  output         instr_copro_de_o;          // Instruction is a coprocessor instr
  output         instr_bkpt_de_o;           // Instruction is BKPT
  output         instr_svc_de_o;            // Instruction is SVC
  output         instr_wfe_de_o;            // Instruction is WFE
  output         instr_wfi_de_o;            // Instruction is WFI
  output         instr_undef_de_o;          // Instruction is an UNDEF
  output         instr_txev_de_o;           // Instruction is SEV
  output         instr_czb_de_o;            // Instruction is CZB
  output         instr_16_mul_valid_de_o;   // Instruction is a T1 MUL
  output [1:0]   instr_barrier_de_o;        // Instruction is a barrier
  output [4:0]   instr_msr_ctl_de_o;        // MSR control
  output [2:0]   instr_cps_ctl_de_o;        // CPS control
  output         instr_algn_de_o;           // Align data
  output         instr_sign_de_o;           // Signed operation or sign extend
  output [1:0]   instr_data_size_de_o;      // Data size
  output         instr_mla_track_de_o;      // MLA instr in progress
  output         instr_lsm_baseinlist_de_o; // LSM has base in list
  output         instr_ls_allow_pline_de_o; // Allow LSS to overlap
  output         instr_ls_single_adv_de_o;  // Advance LSS to data-phase
  output [3:0]   instr_cond_code_de_o;      // Instruction condition code
  output [3:0]   instr_br_cond_de_o;        // Branch condition code
  output         instr_itfold_de_o;         // IT fold
  output [9:0]   instr_itctl_de_o;          // IT control
  output [1:0]   instr_sp_rd_de_o;          // SP read control
  output [1:0]   instr_sp_wr_de_o;          // SP write control
  output [1:0]   instr_pc_lr_de_o;          // Link LR into PC
  output         instr_exit_op_de_o;        // Valid exit instruction in decode
  output         instr_isb_de_o;            // ISB instruction for ETM
  output         instr_br_t_changer_de_o;   // Branch changes T bit
  output         instr_br_lr_sel_de_o;      // Select LR for BLX and MOV PC LR
  output [31:0]  instr_br_imm_de_o;         // Branch immediate offset
  output         instr_br_ccpass_de_o;      // Branch passed condition code
  output [3:0]   instr_brchstat_de_o;       // Branch status information
  output         instr_de_br_det_de_o;      // Detected a branch in decode
  output         instr_br_req_de_o;         // Branch fetch request
  output [1:0]   instr_br_pflush_fast_de_o; // Branch pipeline flush (fast)
  output [1:0]   instr_br_pflush_de_o;      // Branch pipeline flush
  output         instr_lr_ilock_de_o;       // LR interlock
  output         instr_lsu_int_ilock_de_o;  // Interrupt interlock
  output         instr_all_ilock_de_o;      // All interlocks
  output [20:0]  instr_alu_ctl_de_o;        // ALU control
  output [15:0]  instr_lsu_ctl_de_o;        // LSU control
  output         instr_de_2_ex_en_o;        // Decode -> execute advance
  output [31:0]  instr_br_imm_ex_o;         // Branch immediate offset
  output         instr_pflush_ex_o;         // Pipeline flush due to instr
  output [1:0]   instr_br_type_ex_o;        // Type of branch in execute
  output         instr_lsu_br_det_ex_o;     // LSU branch detected
  output         instr_det_erly_br_trk_o;   // Early branch detected
  output         instr_det_erly_br_trk_v_o; // Validated early branch detected
  output         etm_instr_valid_de_o;      // ETM instruction valid
  output [31:1]  rf_pc_wr_data_de_o;        // RF PC write data
  output         rf_rd_a_en_de_o;           // RF A port read enable
  output [3:0]   rf_rd_a_addr_de_o;         // RF A port read address
  output         rf_rd_b_en_de_o;           // RF B port read enable
  output [3:0]   rf_rd_b_addr_de_o;         // RF B port read address
  output [3:0]   instr_rf_rd_c_addr_de_o;   // RF secondary read address
  output         rf_wr_d_en_de_o;           // RF D port write enable
  output [3:0]   rf_wr_d_addr_de_o;         // RF D port write address
  output         lazy_stall_erly_de_o;      // Early stall for lazy stack
  output         lazy_stall_de_o;           // Stall for lazy stack
  output         fault_state_de_o;          // T bit fault
  output         fault_ici_de_o;            // ICI fault
  output [1:0]   fault_fetch_de_o;          // Fetch fault

  wire           opt_ext_en;                // Master enable for extensions
  wire           opt_fpu_en;                // Master enable for FPU logic
  wire           instr_dec_rdy_de;          // Ready for decode
  wire           instr_valid_de;            // Instruction in decode is valid
  wire           instr_dec_rdy_fpu_de;      // Ready for FPU decode
  wire           instr_valid_fpu_de;        // Instruction valid for FPU
  wire           instr_use_word_de;         // Consumed 32 bits of instruction
  wire           etm_instr_valid_de;        // ETM instruction valid
  wire           instr_privileged_de;       // Decode time privilege
  wire           dbg_stop_req;              // Debug stop request
  wire           instr_16_alu_1_cyc_de;     // ALU operation will take 1 cycle
  wire           instr_16_algn_de;          // Align data
  wire           instr_16_mul_ilock_de;     // Multiply interlock
  wire           instr_16_mul_de;           // Multiply decoded
  wire [1:0]     instr_16_ls_allow_skid_de; // LS pipeline/advance controls
  wire [31:0]    instr_16_immed_de;         // Immediate value
  wire [31:0]    instr_16_lsm_immed_de;     // LSM immediate value
  wire           instr_16_imm_valid_de;     // Immediate valid
  wire [1:0]     instr_16_data_size_de;     // Data size
  wire           instr_16_sign_de;          // Signed operation or sign extend
  wire           instr_16_exit_op_de;       // Valid exit instruction
  wire           instr_16_wfe_de;           // Instruction is WFE
  wire           instr_16_wfi_de;           // Instruction is WFI
  wire           instr_16_undef_de;         // Instruction is an UNDEF
  wire           instr_16_txev_de;          // Instruction is SEV
  wire [1:0]     instr_16_pc_lr_de;         // Link LR into PC
  wire           instr_16_br_t_changer_de;  // Branch changes T bit
  wire           instr_16_noncc_br_de;      // Non-conditional branch
  wire           instr_16_flg_set_de;       // Can set flags in IT
  wire           instr_16_it_de;            // Instruction is IT
  wire [2:0]     instr_16_cps_ctl_de;       // CPS control
  wire           instr_16_czb_de;           // Instruction is CZB
  wire           instr_16_bkpt_de;          // Instruction is BKPT
  wire           instr_16_svc_de;           // Instruction is SVC
  wire [3:0]     instr_16_cond_code_de;     // Condition code
  wire [20:0]    instr_16_alu_ctl_de;       // ALU control
  wire [14:0]    instr_16_lsu_ctl_de;       // LSU control
  wire [3:0]     instr_16_lsu_rd_a_addr_de; // RF A port read address for LSU
  wire [3:0]     instr_16_lsu_rd_b_addr_de; // RF A port read address for LSU
  wire           instr_16_rd_a_en_de;       // RF A port read enable
  wire [3:0]     instr_16_rd_a_addr_de;     // RF A port read address
  wire           instr_16_rd_b_en_de;       // RF B port read enable
  wire [3:0]     instr_16_rd_b_addr_de;     // RF B port read address
  wire           instr_16_wr_d_en_de;       // RF D port write enable
  wire [3:0]     instr_16_wr_d_addr_de;     // RF D port write address
  wire           instr_size_de;             // 32 bit thumb decode
  wire [31:0]    instr_32_de;               // Mask non-32 bit instructions
  wire           instr_32_alu_1_cyc_de;     // ALU operation will take 1 cycle
  wire           instr_32_algn_de;          // Align data
  wire           instr_32_mla_de;           // Instruction is MLA
  wire           instr_32_mul_ilock_de;     // Multiply interlock
  wire           instr_32_ls_single_wb_de;  // Load/store single has writeback
  wire [1:0]     instr_32_ls_allow_skid_de; // LS pipeline/advance controls
  wire           instr_32_lsd_baseinlist_de;// LSD has base in list
  wire [31:0]    instr_32_immed_de;         // Immediate value
  wire [31:0]    instr_32_lsm_immed_de;     // LSM immediate value
  wire           instr_32_imm_valid_de;     // Immediate valid
  wire [1:0]     instr_32_data_size_de;     // Data size
  wire           instr_32_sign_de;          // Signed operation or sign extend
  wire           instr_32_exit_op_de;       // Valid exit instruction
  wire           instr_32_undef_de;         // Instruction is an UNDEF
  wire           instr_32_txev_de;          // Instruction is SEV
  wire [1:0]     instr_32_pc_lr_de;         // Link LR into PC
  wire           instr_32_br_t_changer_de;  // Branch changes T bit
  wire           instr_32_noncc_br_de;      // Non-conditional branch
  wire           instr_32_flg_set_de;       // Can set flags in IT
  wire [4:0]     instr_32_msr_ctl_de;       // MSR control
  wire [1:0]     instr_32_barrier_de;       // Barrier control
  wire [3:0]     instr_32_cond_code_de;     // Condition code
  wire           instr_32_copro_de;         // Coprocessor instruction
  wire           instr_32_wfe_de;           // Instruction is WFE
  wire           instr_32_wfi_de;           // Instruction is WFI
  wire           instr_32_isb_de;           // Instruction is ISB
  wire           instr_32_has_shft_imm_de;  // Instruction has immediate shift
  wire [20:0]    instr_32_alu_ctl_de;       // ALU control
  wire [14:0]    instr_32_lsu_ctl_de;       // LSU control
  wire [1:0]     instr_32_sp_rd_de;         // SP read control
  wire [1:0]     instr_32_sp_wr_de;         // SP write control
  wire [3:0]     instr_32_lsu_rd_a_addr_de; // RF A port read address for LSU
  wire [3:0]     instr_32_lsu_rd_b_addr_de; // RF B port read address for LSU
  wire           instr_32_rd_a_en_de;       // RF A port read enable
  wire [3:0]     instr_32_rd_a_addr_de;     // RF A port read address
  wire           instr_32_rd_b_en_de;       // RF B port read enable
  wire [3:0]     instr_32_rd_b_addr_de;     // RF B port read address
  wire [3:0]     instr_32_rd_c_addr_de;     // RF secondary read address
  wire           instr_32_wr_d_en_de;       // RF D port write enable
  wire [3:0]     instr_32_wr_d_addr_de;     // RF D port write address
  wire           instr_br_lr_sel_de;        // Select LR for BLX and MOV PC LR
  wire [3:0]     instr_br_cond_de;          // Condition code of branch
  wire           instr_br_ccpass_de;        // Branch passed condition code
  wire [31:0]    instr_br_imm_de;           // Branch immediate offset
  wire           instr_br_req_de;           // Branch fetch request
  wire [1:0]     instr_br_pflush_fast_de;   // Branch pipeline flush (fast)
  wire [1:0]     instr_br_pflush_de;        // Branch pipeline flush
  wire [3:0]     instr_brchstat_de;         // Branch status information
  wire           instr_de_br_det_de;        // Detected a branch in decode
  wire [31:0]    instr_br_imm_ex;           // Branch immediate offset
  wire [1:0]     instr_br_type_ex;          // Type of branch in execute
  wire           instr_pflush_ex;           // Pipeline flush due to instr
  wire           instr_lsu_br_det_ex;       // LSU branch detected
  wire           instr_det_erly_br_trk;     // Early branch detected
  wire           instr_det_erly_br_trk_v;   // Validated early branch detected
  wire [31:1]    rf_pc_wr_data_de;          // PC write data
  wire [31:0]    instr_immed_de;            // Immediate
  wire [31:0]    instr_lsm_immed_de;        // LSM immediate
  wire [20:0]    instr_alu_ctl_de;          // ALU control
  wire           instr_mla_track_de;        // MLA instr in progress
  wire           instr_16_mul_valid_de;     // Instruction is a T1 MUL
  wire           instr_has_shft_imm_de;     // Instruction has immediate shift
  wire [15:0]    instr_lsu_ctl_fast_de;     // LSU control (fast)
  wire [15:0]    instr_lsu_ctl_de;          // LSU control
  wire           instr_ls_single_ex;        // Load/store single
  wire           instr_lsu_isld_ex;         // Load (versus store)
  wire           instr_lsu_wb_valid_ex;     // Writeback valid
  wire           instr_lsu_excl_ex;         // Exclusive operation
  wire [5:0]     instr_lsu_busy_de;         // LSU busy (types)
  wire [1:0]     instr_ls_allow_skid_de;    // Allow LSU instructions to skid
  wire           instr_ls_allow_pline_de;   // Allow LSS to overlap
  wire           instr_ls_single_adv_de;    // Advance LSS to data-phase
  wire           instr_ls_isld_de;          // Load (versus store)
  wire           instr_lsm_baseinlist_de;   // LSM has base in list
  wire           instr_bkpt_de;             // Instruction is BKPT
  wire           instr_copro_de;            // Instruction is a coprocessor instr
  wire           instr_svc_de;              // Instruction is SVC
  wire           instr_wfe_de;              // Instruction is WFE
  wire           instr_wfi_de;              // Instruction is WFI
  wire           instr_undef_de;            // Instruction is an UNDEF
  wire           instr_txev_de;             // Instruction is SEV
  wire [1:0]     instr_pc_lr_de;            // Link LR into PC
  wire           instr_br_t_changer_de;     // Branch changes T bit
  wire           instr_czb_de;              // Instruction is CZB
  wire           instr_imm_valid_fast_de;   // Immediate valid (fast)
  wire           instr_imm_valid_de;        // Immediate valid
  wire           instr_allow_itfold_de;     // Allow IT folding
  wire           instr_upper_it_de;         // IT in upper half
  wire           instr_itfold_de;           // IT fold
  wire [9:0]     instr_itctl_de;            // IT control
  wire [1:0]     instr_sp_rd_de;            // SP read control
  wire [1:0]     instr_sp_wr_de;            // SP write control
  wire [4:0]     instr_msr_ctl_de;          // MSR control
  wire [2:0]     instr_cps_ctl_de;          // CPS control
  wire [1:0]     instr_data_size_de;        // Data size
  wire           instr_sign_de;             // Signed operation or sign extend
  wire           instr_exit_op_de;          // Valid exit instruction in decode
  wire           instr_algn_de;             // Align data
  wire [1:0]     instr_barrier_de;          // Instruction is a barrier
  wire [3:0]     instr_cond_code_de;        // Instruction condition code
  wire           sel_16_lsu_reg_de;         // Select 16 bit instr for LSU reg
  wire           sel_32_lsu_reg_de;         // Select 32 bit instr for LSU reg
  wire           sel_fp_lsu_reg_de;         // Select FPU    instr for LSU reg
  wire [3:0]     lsu_rf_rd_a_addr_de;       // RF A port read enable for LSU
  wire [3:0]     lsu_rf_rd_b_addr_de;       // RF B port read enable for LSU
  wire           rf_rd_a_en_fast_de;        // RF A port read enable (fast)
  wire           rf_rd_a_en_de;             // RF A port read enable
  wire           rf_rd_b_en_fast_de;        // RF B port read enable (fast)
  wire           rf_rd_b_en_de;             // RF B port read enable
  wire           rf_wr_d_en_fast_de;        // RF D port write enable (fast)
  wire           rf_wr_d_en_de;             // RF D port write enable
  wire           rf_rd_use_fpa;             // Use FPU for RF A addr
  wire           rf_rd_use_fpb;             // Use FPU for RF B addr
  wire           rf_rd_use_ext;             // Use extensions for RF addr
  wire           rf_rd_use_dec;             // Use decoded instr for RF addr
  wire [3:0]     rf_rd_a_addr_de;           // RF A port read address
  wire [3:0]     rf_rd_b_addr_de;           // RF B port read address
  wire [3:0]     instr_rf_rd_c_addr_de;     // RF secondary read address
  wire [3:0]     rf_wr_d_addr_de;           // RF D port write address
  wire           instr_advance_de;          // Advance instruction
  wire           instr_de_2_ex_en;          // Decode -> execute advance
  wire           fault_state_de;            // T bit fault
  wire           instr_ici_invalid_de;      // ICI not valid
  wire           fault_ici_de;              // ICI fault
  wire [1:0]     fault_fetch_de;            // Fetch fault
  wire           instr_dbg_ilock_de;        // Debug interlock
  wire           instr_int_ilock_de;        // Interrupt interlock
  wire           ilock_wr_d_check_de;       // D port interlock check
  wire [3:0]     ilock_wr_d_addr_ex;        // D port interlock write address
  wire           instr_lsu_d_ilock_de;      // D port interlock
  wire           ilock_wr_z_check_de;       // Z port interlock check
  wire [3:0]     ilock_wr_z_addr_ex;        // Z port interlock write address
  wire           instr_lsu_z_ilock_de;      // Z port interlock
  wire           instr_lsu_fpu_ilock_de;    // D/Z port interlock for FPU
  wire           instr_lsu_ilock_de;        // LSU interlock
  wire           instr_mul_ilock_de;        // Multiplier interlock
  wire           instr_lsu_int_ilock_de;    // LSU interrupt interlock
  wire           rf_a_addr_lr_de;           // RF A read address is r14
  wire           rf_b_addr_lr_de;           // RF B read address is r14
  wire           rf_c_addr_lr_de;           // RF C read address is r14
  wire           rf_d_addr_lr_de;           // RF D read address is r14
  wire           instr_lr_ilock_de;         // LR interlock
  wire           instr_all_ilock_de;        // All interlocks
  wire           instr_stop_pipe_de;        // Stop the pipe
  wire           instr_stop_pipe_fpu_de;    // Stop the FPU pipe
  wire           instr_fpu_de;              // FPU instruction in decode
  wire           lazy_stall_erly_de;        // Lazy stall for decode (early)
  wire           lazy_stall_de;             // Lazy stall for decode

`ifdef ARM_DSM

  wire           dsm_fpu_present;

  assign opt_fpu_en = dsm_fpu_present    ? 1'b1 : 1'b0;

`else

  assign opt_fpu_en = (FPU_PRESENT == 1) ? 1'b1 : 1'b0;

`endif

  assign opt_ext_en = (EXT_PRESENT == 1) ? 1'b1 : 1'b0;


  assign instr_fpu_de         = ((instr_de_i[15:10] == 6'b111011) &
                                 ~(instr_de_i[9:8] == 2'b11) &
                                 (instr_de_i[27:25] == 3'b101)) & opt_fpu_en;

  assign lazy_stall_erly_de   = (fpu_lazy_stall_de_i & instr_valid_fe_i &
                                 ~fpu_lazy_done_i & ~fpu_lazy_cancel_i &
                                 ~(|instr_fault_fe_i) & psr_t_ex_i &
                                 ~fpu_ici_invalid_de_i & ~int_ret_fpu_i &
                                 ~dbg_stop_req);

  assign lazy_stall_de        = lazy_stall_erly_de & instr_dec_rdy_de;



  assign instr_dec_rdy_de     = (instr_valid_fe_i & ~instr_stop_pipe_de &
                                 ~lsu_stall_late_ex_i &
                                 ((~(|instr_br_pflush_ex_i[1:0]) &
                                   ~nvic_int_invoke_i) |
                                  int_entry_i | int_return_i));

  assign instr_valid_de       = (instr_dec_rdy_de & ~(|instr_fault_fe_i) &
                                 psr_t_ex_i & ~lazy_stall_erly_de &
                                 ~(instr_fpu_de ? fpu_ici_invalid_de_i :
                                                  instr_ici_invalid_de));

  assign instr_dec_rdy_fpu_de = (instr_valid_fe_i & ~instr_stop_pipe_fpu_de &
                                 ~lsu_stall_late_ex_i &
                                 ((~(|instr_br_pflush_ex_i[1:0]) &
                                   ~nvic_int_invoke_i) |
                                  int_entry_i | int_return_i));

  assign instr_valid_fpu_de   = (instr_dec_rdy_fpu_de & ~(|instr_fault_fe_i) &
                                 ~lazy_stall_erly_de & psr_t_ex_i &
                                 ~fpu_ici_invalid_de_i);

  assign instr_use_word_de    = ((instr_valid_fe_i & instr_size_de) |
                                 instr_itfold_de);

  assign etm_instr_valid_de   = (instr_dec_rdy_de & ~lazy_stall_erly_de &
                                 (~instr_16_bkpt_de   |
                                  (|instr_fault_fe_i) |
                                  ~psr_t_ex_i         |
                                  (instr_fpu_de ? fpu_ici_invalid_de_i :
                                                  instr_ici_invalid_de)));

  assign instr_privileged_de  = nvic_int_invoke_i | privileged_i;

  assign dbg_stop_req         = nvic_dbg_halt_req_i | nvic_dbg_mon_req_i;

  assign instr_size_de = ((instr_de_i[15:13] == 3'b111) &
                          (instr_de_i[12:11] != 2'b00));

  assign instr_32_de   = {32{instr_size_de}} & instr_de_i;

  cm3_dpu_16bit_dec #(EXT_PRESENT)
    u_cm3_dpu_16bit_dec
      (// Inputs
       .hclk                         (hclk),
       .hreset_n                     (hreset_n),
       .instr_de_i                   (instr_de_i),
       .instr_valid_de_i             (instr_valid_de),
       .instr_size_de_i              (instr_size_de),
       .instr_16_alu_1_cyc_de_o      (instr_16_alu_1_cyc_de),
       .instr_16_algn_de_o           (instr_16_algn_de),
       .instr_16_mul_ilock_de_o      (instr_16_mul_ilock_de),
       .instr_16_mul_de_o            (instr_16_mul_de),
       .instr_16_ls_allow_skid_de_o  (instr_16_ls_allow_skid_de),
       .instr_16_immed_de_o          (instr_16_immed_de),
       .instr_16_lsm_immed_de_o      (instr_16_lsm_immed_de),
       .instr_16_imm_valid_de_o      (instr_16_imm_valid_de),
       .instr_16_data_size_de_o      (instr_16_data_size_de),
       .instr_16_sign_de_o           (instr_16_sign_de),
       .instr_16_exit_op_de_o        (instr_16_exit_op_de),
       .instr_16_wfe_de_o            (instr_16_wfe_de),
       .instr_16_wfi_de_o            (instr_16_wfi_de),
       .instr_16_undef_de_o          (instr_16_undef_de),
       .instr_16_txev_de_o           (instr_16_txev_de),
       .instr_16_pc_lr_de_o          (instr_16_pc_lr_de),
       .instr_16_br_t_changer_de_o   (instr_16_br_t_changer_de),
       .instr_16_noncc_br_de_o       (instr_16_noncc_br_de),
       .instr_16_flg_set_de_o        (instr_16_flg_set_de),
       .instr_16_it_de_o             (instr_16_it_de),
       .instr_16_cps_ctl_de_o        (instr_16_cps_ctl_de),
       .instr_16_czb_de_o            (instr_16_czb_de),
       .instr_16_bkpt_de_o           (instr_16_bkpt_de),
       .instr_16_svc_de_o            (instr_16_svc_de),
       .instr_16_cond_code_de_o      (instr_16_cond_code_de),
       .instr_16_alu_ctl_de_o        (instr_16_alu_ctl_de),
       .instr_16_lsu_ctl_de_o        (instr_16_lsu_ctl_de),
       .instr_16_lsu_rd_a_addr_de_o  (instr_16_lsu_rd_a_addr_de),
       .instr_16_lsu_rd_b_addr_de_o  (instr_16_lsu_rd_b_addr_de),
       .instr_16_rd_a_en_de_o        (instr_16_rd_a_en_de),
       .instr_16_rd_a_addr_de_o      (instr_16_rd_a_addr_de),
       .instr_16_rd_b_en_de_o        (instr_16_rd_b_en_de),
       .instr_16_rd_b_addr_de_o      (instr_16_rd_b_addr_de),
       .instr_16_wr_d_en_de_o        (instr_16_wr_d_en_de),
       .instr_16_wr_d_addr_de_o      (instr_16_wr_d_addr_de));

  cm3_dpu_32bit_dec #(EXT_PRESENT)
    u_cm3_dpu_32bit_dec
      (// Inputs
       .hclk                         (hclk),
       .hreset_n                     (hreset_n),
       .instr_valid_de_i             (instr_valid_de),
       .instr_32_de_i                (instr_32_de),
       .instr_privileged_de_i        (instr_privileged_de),
       .e_shft_inlinec_de_i          (e_shft_inlinec_de_i),
       .instr_32_alu_1_cyc_de_o      (instr_32_alu_1_cyc_de),
       .instr_32_algn_de_o           (instr_32_algn_de),
       .instr_32_mla_de_o            (instr_32_mla_de),
       .instr_32_mul_ilock_de_o      (instr_32_mul_ilock_de),
       .instr_32_ls_single_wb_de_o   (instr_32_ls_single_wb_de),
       .instr_32_ls_allow_skid_de_o  (instr_32_ls_allow_skid_de),
       .instr_32_lsd_baseinlist_de_o (instr_32_lsd_baseinlist_de),
       .instr_32_immed_de_o          (instr_32_immed_de),
       .instr_32_lsm_immed_de_o      (instr_32_lsm_immed_de),
       .instr_32_imm_valid_de_o      (instr_32_imm_valid_de),
       .instr_32_data_size_de_o      (instr_32_data_size_de),
       .instr_32_sign_de_o           (instr_32_sign_de),
       .instr_32_exit_op_de_o        (instr_32_exit_op_de),
       .instr_32_undef_de_o          (instr_32_undef_de),
       .instr_32_txev_de_o           (instr_32_txev_de),
       .instr_32_pc_lr_de_o          (instr_32_pc_lr_de),
       .instr_32_br_t_changer_de_o   (instr_32_br_t_changer_de),
       .instr_32_noncc_br_de_o       (instr_32_noncc_br_de),
       .instr_32_flg_set_de_o        (instr_32_flg_set_de),
       .instr_32_msr_ctl_de_o        (instr_32_msr_ctl_de),
       .instr_32_barrier_de_o        (instr_32_barrier_de),
       .instr_32_cond_code_de_o      (instr_32_cond_code_de),
       .instr_32_copro_de_o          (instr_32_copro_de),
       .instr_32_wfe_de_o            (instr_32_wfe_de),
       .instr_32_wfi_de_o            (instr_32_wfi_de),
       .instr_32_isb_de_o            (instr_32_isb_de),
       .instr_32_has_shft_imm_de_o   (instr_32_has_shft_imm_de),
       .instr_32_alu_ctl_de_o        (instr_32_alu_ctl_de),
       .instr_32_lsu_ctl_de_o        (instr_32_lsu_ctl_de),
       .instr_32_sp_rd_de_o          (instr_32_sp_rd_de),
       .instr_32_sp_wr_de_o          (instr_32_sp_wr_de),
       .instr_32_lsu_rd_a_addr_de_o  (instr_32_lsu_rd_a_addr_de),
       .instr_32_lsu_rd_b_addr_de_o  (instr_32_lsu_rd_b_addr_de),
       .instr_32_rd_a_en_de_o        (instr_32_rd_a_en_de),
       .instr_32_rd_a_addr_de_o      (instr_32_rd_a_addr_de),
       .instr_32_rd_b_en_de_o        (instr_32_rd_b_en_de),
       .instr_32_rd_b_addr_de_o      (instr_32_rd_b_addr_de),
       .instr_32_rd_c_addr_de_o      (instr_32_rd_c_addr_de),
       .instr_32_wr_d_en_de_o        (instr_32_wr_d_en_de),
       .instr_32_wr_d_addr_de_o      (instr_32_wr_d_addr_de));

  cm3_dpu_br_dec
    u_cm3_dpu_br_dec
      (// Inputs
       .hclk                         (hclk),
       .hreset_n                     (hreset_n),
       .state_fe_i                   (state_fe_i),
       .fe_buf_has_valid_instr_i     (fe_buf_has_valid_instr_i),
       .fe_address_add_res_i         (fe_address_add_res_i),
       .instr_de_i                   (instr_de_i),
       .instr_valid_de_i             (instr_valid_de),
       .instr_ccpass_de_i            (instr_ccpass_de_i),
       .instr_itblock_de_i           (instr_itblock_de_i),
       .instr_use_word_de_i          (instr_use_word_de),
       .instr_16_mul_ex_i            (instr_16_mul_ex_i),
       .instr_lr_ilock_ex_i          (instr_lr_ilock_ex_i),
       .instr_br_pflush_ex_i         (instr_br_pflush_ex_i),
       .instr_detect_exit_ex_i       (instr_detect_exit_ex_i),
       .set_instr_redo_ex_i          (set_instr_redo_ex_i),
       .ahb_htransi_i                (ahb_htransi_i),
       .mtx_ahb_hreadyi_i            (mtx_ahb_hreadyi_i),
       .fe_haddracci_i               (fe_haddracci_i),
       .nvic_slp_asleep_i            (nvic_slp_asleep_i),
       .ext_iflush_i                 (ext_iflush_i),
       .nvic_int_invoke_i            (nvic_int_invoke_i),
       .nvic_int_tail_i              (nvic_int_tail_i),
       .lsu_flag_wr_ex_i             (lsu_flag_wr_ex_i),
       .lsu_pflush_ex_i              (lsu_pflush_ex_i),
       .lsu_rf_wr_d_data_ex_i        (lsu_rf_wr_d_data_ex_i),
       .rf_rd_lr_de_i                (rf_rd_lr_de_i),
       .rf_rd_b_data_ex_i            (rf_rd_b_data_ex_i),
       .rf_rd_b_zero_ex_i            (rf_rd_b_zero_ex_i),
       .fault_dblfault_ex_i          (fault_dblfault_ex_i),
       .dbg_halted_i                 (dbg_halted_i),
       .instr_br_lr_sel_de_o         (instr_br_lr_sel_de),
       .instr_br_cond_de_o           (instr_br_cond_de),
       .instr_br_ccpass_de_o         (instr_br_ccpass_de),
       .instr_br_imm_de_o            (instr_br_imm_de),
       .instr_br_req_de_o            (instr_br_req_de),
       .instr_br_pflush_fast_de_o    (instr_br_pflush_fast_de),
       .instr_br_pflush_de_o         (instr_br_pflush_de),
       .instr_brchstat_de_o          (instr_brchstat_de),
       .instr_de_br_det_de_o         (instr_de_br_det_de),
       .instr_br_imm_ex_o            (instr_br_imm_ex),
       .instr_br_type_ex_o           (instr_br_type_ex),
       .instr_pflush_ex_o            (instr_pflush_ex),
       .instr_lsu_br_det_ex_o        (instr_lsu_br_det_ex),
       .instr_det_erly_br_trk_o      (instr_det_erly_br_trk),
       .instr_det_erly_br_trk_v_o    (instr_det_erly_br_trk_v),
       .rf_pc_wr_data_de_o           (rf_pc_wr_data_de));


  assign instr_immed_de        = (instr_16_immed_de | instr_32_immed_de |
                                  {{22{1'b0}}, fpu_ls_immed_de_i, 2'b00 });

  assign instr_lsm_immed_de    = (instr_16_lsm_immed_de |
                                  instr_32_lsm_immed_de |
                                  {{22{1'b0}}, fpu_lsm_immed_de_i, 2'b00 });

  assign instr_alu_ctl_de      = ((instr_32_alu_ctl_de | instr_16_alu_ctl_de) &
                                  {21{instr_valid_de}});

  assign instr_mla_track_de = (instr_valid_fe_i & ~(|instr_fault_fe_i) &
                               instr_32_mla_de & ~dbg_stop_req &
                               ~nvic_int_invoke_i & ~instr_itccfail_de_i &
                               ~instr_mcyc_ilock_ex_i &
                               (rf_wr_d_addr_erly_ex_i == instr_32_de[31:28]) &
                               (rf_wr_d_addr_erly_ex_i != instr_32_de[19:16]) &
                               (rf_wr_d_addr_erly_ex_i != instr_32_de[3:0]));

  assign instr_16_mul_valid_de = instr_valid_de & instr_16_mul_de;

  assign instr_has_shft_imm_de = instr_32_has_shft_imm_de;

  assign instr_lsu_ctl_fast_de = { fpu_lsu_ctl_de_i[0] & opt_fpu_en,
                                   (instr_32_lsu_ctl_de |
                                    instr_16_lsu_ctl_de |
                                    (fpu_lsu_ctl_de_i & {15{opt_fpu_en}}))};
  assign instr_lsu_ctl_de      = instr_lsu_ctl_fast_de & {16{instr_valid_de}};

  assign instr_ls_single_ex    = (instr_ccpass_ex_i & instr_lsu_ctl_ex_i[3] &
                                  lsu_valid_ex_i);

  assign instr_lsu_isld_ex     = instr_lsu_ctl_ex_i[6] & lsu_valid_ex_i;
  assign instr_lsu_wb_valid_ex = (instr_lsu_ctl_ex_i[9] & instr_ccpass_ex_i &
                                  lsu_valid_ex_i);
  assign instr_lsu_excl_ex     = (instr_lsu_ctl_ex_i[13] & instr_ccpass_ex_i &
                                  lsu_valid_ex_i);


  assign sel_16_lsu_reg_de   = ~instr_size_de;
  assign sel_32_lsu_reg_de   = (instr_size_de &
                                (~instr_fpu_de | ~opt_fpu_en));
  assign sel_fp_lsu_reg_de   = instr_size_de & instr_fpu_de & opt_fpu_en;

  assign lsu_rf_rd_a_addr_de = (({4{sel_16_lsu_reg_de}} & instr_16_lsu_rd_a_addr_de) |
                                ({4{sel_32_lsu_reg_de}} & instr_32_lsu_rd_a_addr_de) |
                                ({4{sel_fp_lsu_reg_de}} & fpu_rf_rd_addr_de_i));

  assign lsu_rf_rd_b_addr_de = (({4{sel_16_lsu_reg_de}} & instr_16_lsu_rd_b_addr_de) |
                                ({4{sel_32_lsu_reg_de}} & instr_32_lsu_rd_b_addr_de));

  assign instr_lsu_busy_de = {// E.opcode LDR and D.opcode uses E.opcode.destination
                              ((instr_lsu_isld_ex | instr_lsu_excl_ex) &
                               ( (lsu_rf_rd_a_addr_de==rf_wr_d_addr_erly_ex_i) |
                                ((lsu_rf_rd_b_addr_de==rf_wr_d_addr_erly_ex_i) &
                                 ~instr_imm_valid_fast_de))),
                              (~instr_lsu_isld_ex & ~instr_immed_valid_ex_i),
                              instr_32_ls_single_wb_de &
                              ~(opt_ext_en & ~instr_lsu_excl_ex),
                              (instr_lsu_isld_ex & instr_ccpass_ex_i &
                               (rf_wr_d_addr_erly_ex_i==4'b1101)),
                              (instr_lsu_isld_ex &
                               (rf_wr_d_addr_erly_ex_i==4'b1111)),
                              (instr_lsu_d_ilock_de | instr_lsu_z_ilock_de)};

  assign instr_ls_allow_skid_de  = {// next opcode not taken
                                    (instr_itccfail_de_i & ~instr_flag_wr_ex_i &
                                     instr_16_ls_allow_skid_de[1]),
                                    (instr_16_ls_allow_skid_de[0] |
                                     instr_32_ls_allow_skid_de[0])};

  assign instr_ls_allow_pline_de = (instr_valid_fe_i & ~(|instr_fault_fe_i) &
                                    ~nvic_int_invoke_i & ~dbg_stop_req &
                                    ~fpu_lazy_stall_de_i &
                                    ~fpu_interlock_de_i &
                                    instr_lsu_ctl_fast_de[3] &
                                    ~(|instr_lsu_busy_de));

  assign instr_ls_single_adv_de = (instr_valid_fe_i & ~(|instr_fault_fe_i) &
                                   ~nvic_int_invoke_i & ~dbg_stop_req &
                                   ~lazy_stall_erly_de & ~fpu_interlock_de_i &
                                   ~(~instr_size_de & instr_upper_it_de) &
                                   (rf_wr_d_addr_erly_ex_i!=4'b1101) &
                                   (rf_wr_d_addr_erly_ex_i!=4'b1111) &
                                   ((instr_ls_allow_skid_de[1] &
                                     (instr_lsu_isld_ex |
                                      instr_immed_valid_ex_i)) |
                                    instr_ls_allow_skid_de[0]));

  assign instr_ls_isld_de       = instr_lsu_ctl_de[6];

  assign instr_lsm_baseinlist_de = (instr_valid_de &
                                    ((instr_lsu_ctl_fast_de[5] &
                                      ~fpu_lsu_ctl_de_i[0] &
                                      instr_lsm_immed_de[{1'b0,rf_rd_a_addr_de}]) |
                                     instr_32_lsd_baseinlist_de));

  assign instr_bkpt_de   = (instr_valid_de & ~instr_dp_pflush_ex_i &
                            instr_16_bkpt_de);

  assign instr_copro_de  = (instr_valid_de & ~instr_dp_pflush_ex_i &
                            (instr_fpu_de ?
                             (~fpu_enabled_i | ~opt_fpu_en) : instr_32_copro_de));

  assign instr_svc_de    = (instr_valid_de & ~instr_dp_pflush_ex_i &
                            instr_16_svc_de);

  assign instr_wfe_de    = (instr_valid_de & ~instr_dp_pflush_ex_i &
                            (instr_16_wfe_de | instr_32_wfe_de));

  assign instr_wfi_de    = (instr_valid_de & ~instr_dp_pflush_ex_i &
                            (instr_16_wfi_de | instr_32_wfi_de));

  assign instr_undef_de  = (instr_valid_de & ~instr_dp_pflush_ex_i &
                            instr_16_undef_de & e_undef_de_i &
                            (instr_fpu_de ?
                             (fpu_enabled_i & opt_fpu_en & fpu_undef_de_i) :
                             instr_32_undef_de));

  assign instr_txev_de   = (instr_valid_de & ~instr_dp_pflush_ex_i &
                            (instr_16_txev_de | instr_32_txev_de));

  assign instr_pc_lr_de  = ({2{instr_valid_de}} &
                            (instr_16_pc_lr_de | instr_32_pc_lr_de));

  assign instr_br_t_changer_de = (instr_valid_de &
                                  (instr_16_br_t_changer_de |
                                   instr_32_br_t_changer_de));

  assign instr_czb_de            = instr_valid_de & instr_16_czb_de;

  assign instr_imm_valid_fast_de = (instr_16_imm_valid_de |
                                    instr_32_imm_valid_de |
                                    fpu_lsu_ctl_de_i[0]);

  assign instr_imm_valid_de      = instr_valid_de & instr_imm_valid_fast_de;

  assign instr_allow_itfold_de   = (// one entry in buffer and word aligned,
                                    instr_word_present_fe_i &
                                    instr_16_alu_1_cyc_de &
                                    ~instr_itblock_de_i &
                                    ~nvic_dbg_step_i &
                                    ~nvic_disfold_i &
                                    (instr_16_wr_d_addr_de != 4'b1101));

  assign instr_upper_it_de   = ((instr_de_i[31:24] == 8'b10111111) &
                                (instr_de_i[19:16] != 4'b0000));

  assign instr_itfold_de     = (// Allow folding
                                instr_allow_itfold_de & instr_valid_de &
                                instr_upper_it_de);

  assign instr_itctl_de[9:2] = (instr_itfold_de ? instr_de_i[23:16] :
                                                  instr_de_i[7:0]);
  assign instr_itctl_de[1]   = instr_16_flg_set_de | instr_32_flg_set_de;
  assign instr_itctl_de[0]   = instr_16_it_de | instr_itfold_de;

  assign instr_sp_rd_de = instr_32_sp_rd_de & {1'b1, instr_valid_fe_i};

  assign instr_sp_wr_de = ({2{instr_valid_de & instr_ccpass_de_i}} &
                           instr_32_sp_wr_de);

  assign instr_msr_ctl_de = ({5{instr_valid_de & instr_ccpass_de_i}} &
                             instr_32_msr_ctl_de);

  assign instr_cps_ctl_de = ({3{instr_valid_de & instr_ccpass_de_i}} &
                             instr_16_cps_ctl_de);


  assign instr_data_size_de = ({2{instr_valid_de}} &
                               (instr_16_data_size_de | instr_32_data_size_de |
                                {fpu_lsu_ctl_de_i[0], 1'b0}));

  assign instr_sign_de      = (instr_valid_de &
                               (instr_16_sign_de | instr_32_sign_de));

  assign instr_exit_op_de   = (instr_valid_de & instr_ccpass_de_i &
                               (int_entry_i | ~instr_atbase_ex_i) &
                               (instr_16_exit_op_de | instr_32_exit_op_de));

  assign instr_algn_de      = (instr_16_algn_de | instr_32_algn_de |
                               ((&fpu_rf_rd_addr_de_i) & fpu_ls_valid_de_i));

  assign instr_barrier_de   = ({2{instr_valid_de & instr_ccpass_de_i}} &
                               instr_32_barrier_de);

  assign instr_cond_code_de = (({4{instr_valid_de}} &
                                (instr_32_cond_code_de | instr_16_cond_code_de)) |
                               ({4{~instr_valid_de |
                                   ~(instr_16_noncc_br_de |
                                     instr_32_noncc_br_de)}} & 4'b1110));

  assign rf_rd_a_en_fast_de = (instr_16_rd_a_en_de | instr_32_rd_a_en_de |
                               e_rf_rd_a_en_de_i);

  assign rf_rd_b_en_fast_de = (instr_16_rd_b_en_de | instr_32_rd_b_en_de |
                               e_rf_rd_b_en_de_i);

  assign rf_rd_a_en_de      = (instr_valid_de &
                               (rf_rd_a_en_fast_de | fpu_rf_rd_en_de_i) &
                               (instr_ccpass_de_i | instr_czb_de));

  assign rf_rd_b_en_de      = ((instr_valid_de &
                                (rf_rd_b_en_fast_de | fpu_rf_rd_en_de_i) &
                                (instr_ccpass_de_i | instr_czb_de)) |
                               fpu_rf_rd_en_ex_i);

  assign rf_wr_d_en_fast_de = (instr_16_wr_d_en_de | instr_32_wr_d_en_de |
                               (e_rf_wr_d_en_de_i &
                                (instr_32_de[27:24]!=4'b1111)));

  assign rf_wr_d_en_de      = instr_valid_de & rf_wr_d_en_fast_de;





  assign rf_rd_use_fpa   = fpu_rf_rd_en_erly_de_i &  fpu_lsu_ctl_de_i[0];
  assign rf_rd_use_fpb   = fpu_rf_rd_en_erly_de_i & ~fpu_lsu_ctl_de_i[0];
  assign rf_rd_use_ext   = ~fpu_rf_rd_en_erly_de_i;
  assign rf_rd_use_dec   = e_undef_de_i & ~fpu_rf_rd_en_erly_de_i;


  assign rf_rd_a_addr_de = (({4{rf_rd_use_fpa}} & fpu_rf_rd_addr_de_i)     |
                            ({4{rf_rd_use_dec}} & (instr_16_rd_a_addr_de |
                                                   instr_32_rd_a_addr_de)) |
                            ({4{rf_rd_use_ext}} & e_rf_rd_a_addr_de_i));

  assign rf_rd_b_addr_de = (({4{rf_rd_use_fpb}} &  fpu_rf_rd_addr_de_i)    |
                            ({4{rf_rd_use_dec}} & (instr_16_rd_b_addr_de |
                                                   instr_32_rd_b_addr_de)) |
                            ({4{rf_rd_use_ext}} & e_rf_rd_b_addr_de_i));

  assign instr_rf_rd_c_addr_de = instr_32_rd_c_addr_de | e_rd_c_addr_de_i;

  assign rf_wr_d_addr_de       = (instr_16_wr_d_addr_de |
                                  instr_32_wr_d_addr_de |
                                  e_rf_wr_d_addr_de_i);



  assign instr_advance_de = (instr_not_bkpt_ex_i & ~(|fault_fetch_de) &
                             ~(instr_ls_single_ex &
                               (instr_ls_single_adv_de |
                                instr_ls_allow_pline_de)) &
                             ~mtx_ahb_hrespd_i[0] & ~nvic_dbg_halt_req_i &
                             ~lazy_stall_erly_de & ~fault_ici_de &
                             ~fault_state_de & ~instr_undef_de &
                             ~((instr_stop_adv_fe_i | nvic_aux_ctrl1_we_i) &
                               fpu_mcyc_de_i & opt_fpu_en) &
                             (// Next opcode !CC
                              (instr_valid_de & ~instr_ccpass_de_i &
                               ~instr_16_bkpt_de) |
                              (~instr_valid_de & psr_t_ex_i &
                               ~instr_stop_pipe_de & ~dbg_halted_i &
                               ~lsu_stack_start_i & ~lsu_stall_late_ex_i) |
                              (instr_valid_de &
                               (~e_undef_de_i         | instr_16_it_de        |
                                instr_16_alu_1_cyc_de | instr_32_alu_1_cyc_de))));

  assign instr_de_2_ex_en = (// Set if opcode decoded
                             (instr_valid_de | instr_valid_ex_i) &
                             (// clear if core stops
                              (dbg_halted_i & ~dbg_halted_reg_i) |
                              ~((|instr_stall_ex_i[2:0]) | lsu_stall_late_ex_i) |
                              lsu_stack_start_i |
                              fault_dblfault_ex_i));

  assign fault_state_de = (instr_valid_fe_i & ~(|instr_fault_fe_i) &
                           ~psr_t_ex_i & ~instr_dp_pflush_ex_i &
                           ~instr_stop_pipe_de);

  assign instr_ici_invalid_de = ((|lsu_ici_cont_i) &
                                 ~(instr_lsu_ctl_fast_de[5] &
                                   instr_lsm_immed_de[lsu_ici_cont_i]));

  assign fault_ici_de = (instr_valid_fe_i & ~(|instr_fault_fe_i) &
                         (instr_fpu_de ? fpu_ici_invalid_de_i :
                                         instr_ici_invalid_de) &
                         ~instr_stop_pipe_de);

  assign fault_fetch_de = {2{instr_valid_fe_i &
                             ~instr_dp_pflush_ex_i &
                             ~instr_stop_pipe_de}} & instr_fault_fe_i[1:0];

  assign instr_dbg_ilock_de = (// Halting debug
                               (nvic_dbg_halt_req_i &
                                ((mtx_bm_active_i & ~nvic_int_invoke_i) |
                                 ~mtx_ahb_hreadyd_i)) |
                               (nvic_dbg_mon_req_i & ~nvic_dbg_halt_req_i &
                                (int_stack_op_i | ~nvic_int_invoke_i)));

  assign instr_int_ilock_de = (nvic_int_invoke_i & ~mtx_ahb_hreadyd_i &
                               ~int_stack_op_i);


  assign ilock_wr_d_check_de = (alu_will_wr_rf_ex_i |
                                fpu_rf_wr_en_ex_i   |
                                (lsu_will_wr_rf_ex_i &
                                 instr_lsu_ctl_fast_de[0] &
                                 (instr_lsu_excl_ex |
                                  instr_excl_reg_i |
                                  instr_lsu_wb_valid_ex)));

  assign ilock_wr_d_addr_ex = (({4{alu_will_wr_rf_ex_i}} & instr_rf_wr_d_addr_ex_i) |
                               ({4{lsu_will_wr_rf_ex_i}} & lsu_rf_wr_d_addr_ex_i)   |
                               ({4{fpu_rf_wr_en_ex_i}}   & fpu_rf_addr_ex_i));

  assign instr_lsu_d_ilock_de = (ilock_wr_d_check_de & instr_lsu_ctl_fast_de[0] &
                                 ((lsu_rf_rd_a_addr_de==ilock_wr_d_addr_ex) |
                                  ((lsu_rf_rd_b_addr_de==ilock_wr_d_addr_ex) &
                                   ~instr_imm_valid_fast_de)));

  assign ilock_wr_z_check_de = (e_rf_wr_z_en_ex_i |
                                (lsu_will_wr_rf_ex_i &
                                 instr_lsu_ctl_fast_de[0] &
                                 (instr_lsu_excl_ex |
                                  instr_excl_reg_i |
                                  instr_lsu_wb_valid_ex)));

  assign ilock_wr_z_addr_ex = (({4{e_rf_wr_z_en_ex_i}} & e_rf_wr_z_addr_ex_i[3:0]) |
                               ({4{lsu_will_wr_rf_ex_i}} & lsu_rf_wr_d_addr_ex_i));

  assign instr_lsu_z_ilock_de = ((ilock_wr_z_check_de & instr_lsu_ctl_fast_de[0] &
                                  ((lsu_rf_rd_a_addr_de==ilock_wr_z_addr_ex) |
                                   ((lsu_rf_rd_b_addr_de==ilock_wr_z_addr_ex[3:0]) &
                                    ~instr_imm_valid_fast_de))) & opt_ext_en);

  assign instr_lsu_fpu_ilock_de = (fpu_ls_valid_de_i & opt_fpu_en &
                                   ((alu_will_wr_rf_ex_i &
                                     (fpu_rf_rd_addr_de_i==instr_rf_wr_d_addr_ex_i)) |
                                    (e_rf_wr_z_en_ex_i   &
                                     (fpu_rf_rd_addr_de_i==ilock_wr_z_addr_ex))));

  assign instr_lsu_ilock_de = (instr_valid_fe_i & ~dbg_stop_req &
                               instr_valid_ex_i & ~nvic_int_invoke_i &
                               (instr_flag_wr_ex_i | ~instr_itccfail_de_i) &
                               (instr_lsu_d_ilock_de |
                                instr_lsu_z_ilock_de |
                                instr_lsu_fpu_ilock_de) &
                               ~(|instr_br_pflush_ex_i[1:0]));

  assign instr_mul_ilock_de = (instr_valid_fe_i & instr_16_mul_ex_i &
                               (instr_16_mul_ilock_de | instr_32_mul_ilock_de) &
                               ~dbg_stop_req &
                               ~(nvic_int_invoke_i & instr_valid_ex_i));

  assign instr_lsu_int_ilock_de = (int_stack_op_i & instr_lsu_ctl_fast_de[0] &
                                   psr_t_ex_i & ~(|instr_fault_fe_i) &
                                   instr_valid_fe_i &
                                   (((rf_rd_a_en_fast_de | fpu_lsu_ctl_de_i[0]) &
                                     (rf_rd_a_addr_de==4'b1110)) |
                                    (rf_rd_b_en_fast_de &
                                     (rf_rd_b_addr_de==4'b1110))));


  assign rf_a_addr_lr_de = (rf_rd_a_addr_de==4'b1110);
  assign rf_b_addr_lr_de = (rf_rd_b_addr_de==4'b1110);
  assign rf_c_addr_lr_de = (instr_rf_rd_c_addr_de==4'b1110);
  assign rf_d_addr_lr_de = (rf_wr_d_addr_de==4'b1110);

  assign instr_lr_ilock_de = (// Interrupt
                              lsu_stack_start_i |
                              fpu_r14_ilock_de_i |
                              (instr_valid_de &
                               (// ALU
                                (instr_ccpass_de_i & rf_wr_d_en_fast_de &
                                 (rf_wr_d_addr_de==4'b1110)) |
                                (instr_ccpass_de_i & rf_wr_d_en_fast_de &
                                 (instr_rf_rd_c_addr_de==4'b1110) &
                                 ((instr_alu_ctl_de[17:13] == 5'b11001) |
                                  (instr_alu_ctl_de[17:13] == 5'b11010))) |
                                (instr_ccpass_de_i & rf_wr_z_en_de_i &
                                 (rf_wr_z_addr_de_i==4'b1110)) |
                                (instr_ccpass_de_i & instr_lsu_ctl_de[13] &
                                 ~instr_ls_isld_de & rf_c_addr_lr_de) |
                                (instr_ccpass_de_i & instr_lsu_ctl_de[3] &
                                 instr_lsu_ctl_de[9] & rf_a_addr_lr_de) |
                                (instr_ccpass_de_i & instr_lsu_ctl_de[3] &
                                 instr_ls_isld_de & rf_d_addr_lr_de) |
                                (instr_ccpass_de_i & instr_lsu_ctl_de[4] &
                                 instr_lsu_ctl_de[9] & rf_a_addr_lr_de) |
                                (instr_ccpass_de_i & instr_lsu_ctl_de[4] &
                                 instr_ls_isld_de & rf_b_addr_lr_de) |
                                (instr_ccpass_de_i & instr_lsu_ctl_de[4] &
                                 instr_ls_isld_de & rf_d_addr_lr_de) |
                                (instr_ccpass_de_i & instr_lsu_ctl_de[5] &
                                 instr_lsu_ctl_de[9] & rf_a_addr_lr_de) |
                                (instr_ccpass_de_i & instr_lsu_ctl_de[5] &
                                 instr_ls_isld_de & instr_lsm_immed_de[14]) |
                                (instr_lr_ilock_ex_i & instr_ls_single_ex &
                                 ((instr_ls_allow_pline_de |
                                   instr_ls_single_adv_de))))));

  assign instr_all_ilock_de     = (instr_dbg_ilock_de  | instr_int_ilock_de    |
                                   instr_lsu_ilock_de  | instr_mul_ilock_de);

  assign instr_stop_pipe_de     = ((|instr_stall_ex_i) | instr_all_ilock_de    |
                                   dbg_stop_req        | instr_mcyc_ilock_ex_i |
                                   fpu_interlock_de_i);

  assign instr_stop_pipe_fpu_de = ((|instr_stall_ex_i[3:2]) |
                                   instr_stall_ex_i[0] | instr_all_ilock_de    |
                                   dbg_stop_req        | instr_mcyc_ilock_ex_i);

  assign instr_valid_de_o            = instr_valid_de;
  assign instr_valid_fpu_de_o        = opt_fpu_en & instr_valid_fpu_de;
  assign instr_use_word_de_o         = instr_use_word_de;
  assign instr_advance_de_o          = instr_advance_de;
  assign instr_imm_valid_fast_de_o   = instr_imm_valid_fast_de;
  assign instr_imm_valid_de_o        = instr_imm_valid_de;
  assign instr_immed_de_o            = instr_immed_de;
  assign instr_lsm_immed_de_o        = instr_lsm_immed_de;
  assign instr_has_shft_imm_de_o     = instr_has_shft_imm_de;
  assign instr_copro_de_o            = instr_copro_de;
  assign instr_bkpt_de_o             = instr_bkpt_de;
  assign instr_svc_de_o              = instr_svc_de;
  assign instr_wfe_de_o              = instr_wfe_de;
  assign instr_wfi_de_o              = instr_wfi_de;
  assign instr_undef_de_o            = instr_undef_de;
  assign instr_txev_de_o             = instr_txev_de;
  assign instr_czb_de_o              = instr_czb_de;
  assign instr_16_mul_valid_de_o     = instr_16_mul_valid_de;
  assign instr_barrier_de_o          = instr_barrier_de;
  assign instr_msr_ctl_de_o          = instr_msr_ctl_de;
  assign instr_cps_ctl_de_o          = instr_cps_ctl_de;
  assign instr_algn_de_o             = instr_algn_de;
  assign instr_sign_de_o             = instr_sign_de;
  assign instr_data_size_de_o        = instr_data_size_de;
  assign instr_mla_track_de_o        = instr_mla_track_de;
  assign instr_lsm_baseinlist_de_o   = instr_lsm_baseinlist_de;
  assign instr_ls_allow_pline_de_o   = instr_ls_allow_pline_de;
  assign instr_ls_single_adv_de_o    = instr_ls_single_adv_de;
  assign instr_cond_code_de_o        = instr_cond_code_de;
  assign instr_br_cond_de_o          = instr_br_cond_de;
  assign instr_itfold_de_o           = instr_itfold_de;
  assign instr_itctl_de_o            = instr_itctl_de;
  assign instr_sp_rd_de_o            = instr_sp_rd_de;
  assign instr_sp_wr_de_o            = instr_sp_wr_de;
  assign instr_pc_lr_de_o            = instr_pc_lr_de;
  assign instr_exit_op_de_o          = instr_exit_op_de;
  assign instr_isb_de_o              = instr_32_isb_de;
  assign instr_br_t_changer_de_o     = instr_br_t_changer_de;
  assign instr_br_lr_sel_de_o        = instr_br_lr_sel_de;
  assign instr_br_imm_de_o           = instr_br_imm_de;
  assign instr_br_ccpass_de_o        = instr_br_ccpass_de;
  assign instr_brchstat_de_o         = instr_brchstat_de;
  assign instr_de_br_det_de_o        = instr_de_br_det_de;
  assign instr_br_req_de_o           = instr_br_req_de;
  assign instr_br_pflush_fast_de_o   = instr_br_pflush_fast_de;
  assign instr_br_pflush_de_o        = instr_br_pflush_de;
  assign instr_lr_ilock_de_o         = instr_lr_ilock_de;
  assign instr_lsu_int_ilock_de_o    = instr_lsu_int_ilock_de;
  assign instr_all_ilock_de_o        = instr_all_ilock_de;
  assign instr_alu_ctl_de_o          = instr_alu_ctl_de;
  assign instr_lsu_ctl_de_o          = instr_lsu_ctl_de;
  assign instr_de_2_ex_en_o          = instr_de_2_ex_en;
  assign instr_br_imm_ex_o           = instr_br_imm_ex;
  assign instr_pflush_ex_o           = instr_pflush_ex;
  assign instr_br_type_ex_o          = instr_br_type_ex;
  assign instr_lsu_br_det_ex_o       = instr_lsu_br_det_ex;
  assign instr_det_erly_br_trk_o     = instr_det_erly_br_trk;
  assign instr_det_erly_br_trk_v_o   = instr_det_erly_br_trk_v;
  assign etm_instr_valid_de_o        = etm_instr_valid_de;
  assign rf_pc_wr_data_de_o          = rf_pc_wr_data_de;
  assign rf_rd_a_en_de_o             = rf_rd_a_en_de;
  assign rf_rd_a_addr_de_o           = rf_rd_a_addr_de;
  assign rf_rd_b_en_de_o             = rf_rd_b_en_de;
  assign rf_rd_b_addr_de_o           = rf_rd_b_addr_de;
  assign instr_rf_rd_c_addr_de_o     = instr_rf_rd_c_addr_de;
  assign rf_wr_d_en_de_o             = rf_wr_d_en_de;
  assign rf_wr_d_addr_de_o           = rf_wr_d_addr_de;
  assign lazy_stall_erly_de_o        = lazy_stall_erly_de;
  assign lazy_stall_de_o             = lazy_stall_de;
  assign fault_state_de_o            = fault_state_de;
  assign fault_ici_de_o              = fault_ici_de;
  assign fault_fetch_de_o            = fault_fetch_de;


`ifdef ARM_ASSERT_ON

  assert_never #(0,0,
                 "Decode must not precede without fetch, or under interrupt")
    ovl_decode_enable(hclk, hreset_n, (instr_valid_de &
                                       ~(instr_valid_fe_i |
                                         int_entry_i      |
                                         int_return_i)));

  assert_zero_one_hot #(0,5,0,"Load/Store operation must be exclusive")
    ovl_ldstcode_excl(hclk, hreset_n,
                      {5{~instr_lsu_ctl_de[0]}} & instr_lsu_ctl_de[5:1]);

  assert_never #(0,0,
                 "Register enables should not be active when pipeline stalled")
    ovl_regfile_en(hclk, hreset_n, (((|instr_stall_ex_i[3:2]) |
                                     instr_stall_ex_i[0]) &
                                    (rf_rd_b_en_de |
                                     rf_wr_d_en_de)));

  assert_never #(0,0,
                 "Operations that write the register file must have sources")
    ovl_reg_d_en(hclk, hreset_n, (rf_wr_d_en_de & instr_ccpass_de_i &
                                  ~(instr_imm_valid_de |
                                    rf_rd_a_en_de      |
                                    rf_rd_b_en_de)));

  assert_never #(0,0,
                 "instr valid must not be asserted when starting int is set")
    ovl_starting_int_check(hclk, hreset_n, instr_valid_de & lsu_stack_start_i);

  assert_next #(0,1,0,0,0,"int_handling_actv must be pulsed")
    ovl_lsu_starting_int_pulsed(hclk, hreset_n,
                                lsu_stack_start_i, ~lsu_stack_start_i);

  assert_never #(0,0,"instr_itfold_de must not be 1 when nvic_disfold is set")
    ovl_instr_itfold_de_check(hclk, hreset_n, nvic_disfold_i & instr_itfold_de);

  assert_never #(0,0,"ALU/LSU D write port controls should be exclusive")
    ovl_wport_check_d(hclk, hreset_n, alu_will_wr_rf_ex_i & lsu_will_wr_rf_ex_i);

  assert_never #(0,0,"ALU/LSU Z Write Port controls should be exclusive")
    ovl_wport_check_z(hclk, hreset_n, e_rf_wr_z_en_ex_i & lsu_will_wr_rf_ex_i);

  assert_never_unknown #(0,1,0,"X propagate protect valid signal")
    ovl_default_x(hclk, hreset_n, 1'b1, instr_valid_de);

`endif

`include "cm3_dpu_undefs.vp"

endmodule
