`include "cm3_dpu_defs.vp"

module cm3_dpu_exec
  (// Inputs
   hreset_n, hclk, instr_valid_fe_i, instr_ext_pflush_fe_i, instr_de_i,
   instr_valid_de_i, instr_ccpass_de_i, instr_immed_de_i, instr_imm_valid_de_i,
   instr_algn_de_i, instr_barrier_de_i, instr_br_t_changer_de_i,
   instr_czb_de_i, instr_used_word_de_i, instr_sign_de_i, instr_data_size_de_i,
   instr_exit_op_de_i, instr_msr_ctl_de_i, instr_cps_ctl_de_i, instr_svc_de_i,
   instr_wfe_de_i, instr_wfi_de_i, instr_undef_de_i, instr_txev_de_i,
   instr_bkpt_de_i, instr_copro_de_i, instr_16_mul_valid_de_i,
   instr_has_shft_imm_de_i, instr_alu_ctl_de_i, instr_lsu_ctl_de_i,
   instr_itfold_de_i, instr_sp_rd_de_i, instr_sp_wr_de_i, instr_pc_lr_de_i,
   instr_advance_de_i, instr_lr_ilock_de_i, instr_all_ilock_de_i,
   instr_de_2_ex_en_i, instr_ccpass_ex_i, instr_excl_ex_i, lsu_active_ex_i,
   lsu_sp_wb_ex_i, lsu_stall_ex_i, lsu_psr_ex_i, lsu_main_sp_en_i,
   lsu_real_sp_rd_i, lsu_stall_late_ex_i, lsu_exit_code_ex_i,
   lsu_exit_valid_ex_i, lsu_mcyc_ilock_ex_i, lsu_mcyc_invk_msk_ex_i,
   lsu_rf_rd_a_en_ex_i, lsu_rf_rd_a_en_fast_ex_i, lsu_rf_rd_a_addr_ex_i,
   lsu_rf_wr_d_en_ex_i, lsu_rf_wr_d_en_fast_ex_i, lsu_rf_wr_d_addr_ex_i,
   lsu_rf_wr_d_data_ex_i, lsu_rf_wr_z_addr_ex_i, lsu_rf_wr_z_en_ex_i,
   lsu_rf_wr_z_data_ex_i, lsu_stack_start_i, alu_stall_ex_i,
   alu_exit_valid_ex_i, alu_exit_code_ex_i, alu_mcyc_ilock_ex_i,
   alu_mcyc_invk_msk_ex_i, alu_rf_rd_a_en_ex_i, alu_rf_rd_a_addr_ex_i,
   alu_rf_wr_d_en_ex_i, alu_rf_wr_d_addr_ex_i, alu_rf_wr_d_data_ex_i,
   e_rf_wr_z_en_ex_i, e_rf_wr_z_addr_ex_i, e_rf_wr_z_data_ex_i, e_undef_de_i,
   e_rf_wr_d_data_ex_i, lazy_stall_erly_de_i, fpu_fpscr_wr_de_i, fpu_busy_ex_i,
   fpu_stall_ex_i, fpu_rf_wr_en_ex_i, fpu_rf_addr_ex_i, fpu_wr_data_ex_i,
   fpu_update_ctrl_i, fpu_lazy_start_i, fpu_lazy_stack_op_i, fpu_interlock_de_i,
   mtx_ahb_hreadyd_i, mtx_bm_active_i, nvic_pmask_i, nvic_basepri_i,
   nvic_nonbasethrden_i, nvic_bfhfnmign_i, nvic_dismcycint_i,
   nvic_no_lazy_stk_i, nvic_int_curr_isr_i, int_stack_op_i, nvic_int_invoke_i,
   int_entry_i, int_return_i, int_retisr_i, nvic_int_stk_actv_i,
   nvic_int_in_nmihf_i, int_vector_fault_i, instr_rf_rd_a_en_de_i,
   instr_rf_rd_a_addr_de_i, instr_rf_rd_b_en_de_i, instr_rf_rd_b_addr_de_i,
   instr_rf_rd_c_addr_de_i, rf_wr_d_en_fe_i, rf_wr_d_addr_fe_i,
   rf_wr_d_data_fe_i, rf_wr_d_addr_de_i, rf_rd_b_data_ex_i, fault_fetch_de_i,
   fault_state_de_i, fault_ici_de_i, fault_lsu_ex_i, fault_divby0_ex_i,
   fault_nocopro_fpu_i, nvic_dbg_halt_req_i, nvic_dbg_mon_req_i,
   dbg_ctrl_wr_ex_i, nvic_dbg_reg_addr_i, dbg_wr_isr_i,
   rst_pc_valid_ex_o, iflush_pflush_ex_o, instr_ex_o, instr_stall_ex_o,
   instr_valid_ex_o, instr_immed_ex_o, instr_immed_valid_ex_o, instr_algn_ex_o,
   instr_link_ex_o, instr_sign_ex_o, instr_data_size_ex_o, instr_exit_op_ex_o,
   instr_16_mul_ex_o, instr_czb_ex_o, instr_bkpt_ex_o, instr_not_bkpt_ex_o,
   instr_retire_ex_o, instr_complete_ex_o, instr_advance_ex_o,
   instr_itfold_ex_o, instr_detect_exit_ex_o, instr_atbase_ex_o,
   instr_lr_ilock_ex_o, instr_mcyc_ilock_ex_o, instr_br_t_changer_ex_o,
   instr_dp_pflush_ex_o, instr_br_pflush_ex_o, set_instr_redo_ex_o,
   instr_redo_ex_o, instr_excl_reg_o, privileged_o, user_thread_ex_o,
   rf_sp_rd_de_o, rf_sp_wr_ex_o, rf_sp_sel_ex_o, rf_pc_ctl_ex_o,
   rf_inc_pc_ex_o, rf_rd_a_en_de_o, rf_rd_a_addr_de_o, rf_rd_b_en_de_o,
   rf_rd_b_addr_de_o, rf_wr_d_en_ex_o, rf_wr_d_addr_erly_ex_o,
   rf_wr_d_addr_ex_o, rf_wr_d_data_erly_ex_o, rf_wr_d_data_ex_o,
   rf_wr_z_en_ex_o, rf_wr_z_addr_ex_o, rf_wr_z_data_ex_o,
   dpu_mcyc_invk_msk_o, dpu_slp_ctl_ex_o, dpu_slp_txev_ex_o, dpu_basepri_we_o,
   dpu_basepri_ex_o, dpu_fmask_we_o, dpu_fmask_ex_o, dpu_pmask_we_o,
   dpu_pmask_ex_o, dpu_raisepri_ex_o, fpu_active_ex_o, frc_context_ex_o,
   int_lr_exit_code_ex_o, int_isr_ex_o, dbg_halt_set_o, dbg_halted_o,
   dbg_halted_reg_o, fault_svc_ex_o, fault_dblfault_ex_o, dpu_nxt_bfsr_o,
   dpu_nxt_mfsr_o, dpu_nxt_ufsr_o, dpu_nxt_hfsr_o
   );

  parameter      RESET_ALL_REGS = 0;       // Reset all registers if 1
  parameter      OBSERVATION    = 0;       // Allow internal observation if 1
  parameter      EXT_PRESENT    = 0;       // Extensions present if 1
  parameter      FPU_PRESENT    = 0;       // FPU present if 1

  input          hreset_n;
  input          hclk;
  input          instr_valid_fe_i;         // Instruction in fetch is valid
  input          instr_ext_pflush_fe_i;    // Pipeline flush for external event
  input [31:0]   instr_de_i;               // Instruction in decode
  input          instr_valid_de_i;         // Instruction in decode is valid
  input          instr_ccpass_de_i;        // Condition code pass
  input [31:0]   instr_immed_de_i;         // Immediate value
  input          instr_imm_valid_de_i;     // Immediate valid
  input          instr_algn_de_i;          // Align data
  input [1:0]    instr_barrier_de_i;       // Instruction is a barrier
  input          instr_br_t_changer_de_i;  // Branch changes T bit
  input          instr_czb_de_i;           // Instruction is CZB
  input          instr_used_word_de_i;     // Consumed 32 bits of instruction
  input          instr_sign_de_i;          // Signed operation or sign extend
  input [1:0]    instr_data_size_de_i;     // Data size
  input          instr_exit_op_de_i;       // Valid exit instruction in execute
  input [4:0]    instr_msr_ctl_de_i;       // MSR control
  input [2:0]    instr_cps_ctl_de_i;       // CPS control
  input          instr_svc_de_i;           // Instruction is SVC
  input          instr_wfe_de_i;           // Instruction is WFE
  input          instr_wfi_de_i;           // Instruction is WFI
  input          instr_undef_de_i;         // Instruction is an UNDEF
  input          instr_txev_de_i;          // Instruction is SEV
  input          instr_bkpt_de_i;          // Instruction is BKPT
  input          instr_copro_de_i;         // Instruction is a coprocessor instr
  input          instr_16_mul_valid_de_i;  // Instruction is a T1 MUL
  input          instr_has_shft_imm_de_i;  // Shifted immediate valid
  input [20:0]   instr_alu_ctl_de_i;       // ALU control
  input [15:0]   instr_lsu_ctl_de_i;       // LSU control (De)
  input          instr_itfold_de_i;        // IT folded
  input [1:0]    instr_sp_rd_de_i;         // SP read control
  input [1:0]    instr_sp_wr_de_i;         // SP write control
  input [1:0]    instr_pc_lr_de_i;         // Link LR into PC
  input          instr_advance_de_i;       // Advance instruction
  input          instr_lr_ilock_de_i;      // LR interlock
  input          instr_all_ilock_de_i;     // All interlocks
  input          instr_de_2_ex_en_i;       // Decode -> execute advance
  input          instr_ccpass_ex_i;        // Condition code pass
  input          instr_excl_ex_i;          // Instruction is an exclusive
  input          lsu_active_ex_i;          // LSU is active
  input          lsu_sp_wb_ex_i;           // LSU SP WB
  input          lsu_stall_ex_i;           // LSU stall pipe
  input [31:0]   lsu_psr_ex_i;             // LSU PSR write value
  input          lsu_main_sp_en_i;         // Force r13 to be main SP
  input          lsu_real_sp_rd_i;         // Force r13 read to be real SP
  input          lsu_stall_late_ex_i;      // LSU very late stall
  input [4:0]    lsu_exit_code_ex_i;       // LSU ISR exit code
  input          lsu_exit_valid_ex_i;      // LSU operation is an ISR exit
  input          lsu_mcyc_ilock_ex_i;      // LSU multi-cycle op interlock
  input          lsu_mcyc_invk_msk_ex_i;   // LSU multi-cycle op interrupt mask
  input          lsu_rf_rd_a_en_ex_i;      // LSU RF A port read enable
  input          lsu_rf_rd_a_en_fast_ex_i; // LSU RF A port read enable (fast)
  input [3:0]    lsu_rf_rd_a_addr_ex_i;    // LSU RF A port read address
  input          lsu_rf_wr_d_en_ex_i;      // LSU RF D port write enable
  input          lsu_rf_wr_d_en_fast_ex_i; // LSU RF D port write enable (fast)
  input [3:0]    lsu_rf_wr_d_addr_ex_i;    // LSU RF D port write address
  input [31:0]   lsu_rf_wr_d_data_ex_i;    // LSU RF D port write data
  input [3:0]    lsu_rf_wr_z_addr_ex_i;    // LSU RF Z port write address
  input          lsu_rf_wr_z_en_ex_i;      // LSU RF Z port write enable
  input [31:0]   lsu_rf_wr_z_data_ex_i;    // LSU RF Z port write data
  input          lsu_stack_start_i;        // LSU stack op start
  input          alu_stall_ex_i;           // ALU operation requires stall
  input [4:0]    alu_exit_code_ex_i;       // ALU ISR exit code
  input          alu_mcyc_ilock_ex_i;      // ALU multi-cycle op interlock
  input          alu_mcyc_invk_msk_ex_i;   // ALU multi-cycle op interrupt mask
  input          alu_exit_valid_ex_i;      // ALU operation is an ISR exit
  input          alu_rf_rd_a_en_ex_i;      // ALU RF A port read enable
  input [3:0]    alu_rf_rd_a_addr_ex_i;    // ALU RF A port read address
  input          alu_rf_wr_d_en_ex_i;      // ALU RF D port write enable
  input [3:0]    alu_rf_wr_d_addr_ex_i;    // ALU RF D port write address
  input [31:0]   alu_rf_wr_d_data_ex_i;    // ALU RF D port write data
  input          e_rf_wr_z_en_ex_i;        // E RF Z port write enable
  input [3:0]    e_rf_wr_z_addr_ex_i;      // E RF Z port write address
  input [31:0]   e_rf_wr_z_data_ex_i;      // E RF Z port write data
  input          e_undef_de_i;             // Undefined E extension instruction
  input [31:0]   e_rf_wr_d_data_ex_i;      // E low result late to D port
  input          lazy_stall_erly_de_i;     // Early lazy stall
  input          fpu_fpscr_wr_de_i;        // FPU will write to FPSCR
  input          fpu_busy_ex_i;            // FPU has an operation busy in ex
  input          fpu_stall_ex_i;           // FPU requires a stall
  input          fpu_interlock_de_i;       // FPU interlock
  input          fpu_rf_wr_en_ex_i;        // FPU RF -> Int RF write enable
  input [3:0]    fpu_rf_addr_ex_i;         // FPU RF -> Int RF write address
  input [31:0]   fpu_wr_data_ex_i;         // FPU RF -> Int RF write data
  input [1:0]    fpu_update_ctrl_i;        // Write enable to CONTROL[2]
  input          fpu_lazy_start_i;         // Start lazy stack op
  input          fpu_lazy_stack_op_i;      // Lazy stack in progress
  input          mtx_ahb_hreadyd_i;        // AHB D-side HREADY
  input          mtx_bm_active_i;          // Bus-matrix active
  input          nvic_pmask_i;             // PRIMASK value
  input [7:0]    nvic_basepri_i;           // BASEPRI value
  input          nvic_nonbasethrden_i;     // NONBASETHRDENA value
  input          nvic_bfhfnmign_i;         // Ignore BF in NMI and HF ISR
  input          nvic_dismcycint_i;        // Disable interrupt multi-cycle ops
  input          nvic_no_lazy_stk_i;       // Disable lazy stacking
  input [8:0]    nvic_int_curr_isr_i;      // NVIC current ISR number
  input          int_stack_op_i;           // LSU is stacking/unstacking
  input          nvic_int_invoke_i;        // Interrupt stack request
  input          int_entry_i;              // Interrupt ISR entered
  input          int_return_i;             // Unstacking complete
  input [8:0]    int_retisr_i;             // Returned to ISR number
  input          nvic_int_stk_actv_i;      // Stack is active
  input [2:0]    nvic_int_in_nmihf_i;      // In NMI/HF ISR
  input          int_vector_fault_i;       // Vector fetch fault
  input          instr_rf_rd_a_en_de_i;    // RF A port read enable
  input [3:0]    instr_rf_rd_a_addr_de_i;  // RF A port read address
  input          instr_rf_rd_b_en_de_i;    // RF B port read enable
  input [3:0]    instr_rf_rd_b_addr_de_i;  // RF B port read address
  input [3:0]    instr_rf_rd_c_addr_de_i;  // RF secondary read address
  input          rf_wr_d_en_fe_i;          // RF D port write enable
  input [3:0]    rf_wr_d_addr_fe_i;        // RF D port write address
  input [31:0]   rf_wr_d_data_fe_i;        // RF D port write data
  input [3:0]    rf_wr_d_addr_de_i;        // RF D port write address
  input [31:0]   rf_rd_b_data_ex_i;        // RF B port read data
  input [1:0]    fault_fetch_de_i;         // Fetch fault
  input          fault_state_de_i;         // T bit fault
  input          fault_ici_de_i;           // ICI fault
  input [10:0]   fault_lsu_ex_i;           // Collection of LSU faults
  input          fault_divby0_ex_i;        // DIV causes a divide by 0 fault
  input          fault_nocopro_fpu_i;      // FPU NOCP fault
  input          nvic_dbg_halt_req_i;      // Core halt request
  input          nvic_dbg_mon_req_i;       // Core monitor request
  input          dbg_ctrl_wr_ex_i;         // Debug control register write
  input [6:0]    nvic_dbg_reg_addr_i;      // Debug register transfer reg num
  input          dbg_wr_isr_i;             // Debug ISR number write

  output         rst_pc_valid_ex_o;        // PC reset vector fetch completed
  output         iflush_pflush_ex_o;       // Pipline flush due to IFLUSH
  output [31:0]  instr_ex_o;               // Instruction in execute
  output [3:0]   instr_stall_ex_o;         // Instruction stall information
  output         instr_valid_ex_o;         // Instruction in execute is valid
  output [31:0]  instr_immed_ex_o;         // Immediate value
  output         instr_immed_valid_ex_o;   // Immediate valid
  output         instr_algn_ex_o;          // Align data
  output [1:0]   instr_link_ex_o;          // Link LR to PC
  output         instr_sign_ex_o;          // Signed operation or sign extend
  output [1:0]   instr_data_size_ex_o;     // Data size
  output         instr_exit_op_ex_o;       // Valid exit instruction in execute
  output         instr_16_mul_ex_o;        // Instruction is a T1 MUL
  output         instr_czb_ex_o;           // Instruction is CZB
  output         instr_bkpt_ex_o;          // Instruction is BKPT
  output         instr_not_bkpt_ex_o;      // Instruction is not a BKPT
  output         instr_retire_ex_o;        // Instruction has retired
  output         instr_complete_ex_o;      // Instruction has completed
  output         instr_advance_ex_o;       // Advance instruction
  output         instr_itfold_ex_o;        // IT folded
  output         instr_detect_exit_ex_o;   // ISR exit detected
  output         instr_atbase_ex_o;        // In thread
  output         instr_lr_ilock_ex_o;      // LR interlock
  output         instr_mcyc_ilock_ex_o;    // Multicycle operation interlock
  output         instr_br_t_changer_ex_o;  // Branch changes T bit
  output         instr_dp_pflush_ex_o;     // DP op pipeline flush
  output [2:0]   instr_br_pflush_ex_o;     // Branch pipeline flush
  output         set_instr_redo_ex_o;      // Set redo instr
  output         instr_redo_ex_o;          // Redo instr
  output         instr_excl_reg_o;         // Instruction is an exclusive (reg)
  output         privileged_o;             // Privileged (vs user) mode
  output         user_thread_ex_o;         // Thread is (or will be) user mode
  output [1:0]   rf_sp_rd_de_o;            // SP read control
  output [1:0]   rf_sp_wr_ex_o;            // SP write control
  output [1:0]   rf_sp_sel_ex_o;           // SP selection
  output [1:0]   rf_pc_ctl_ex_o;           // PC control
  output         rf_inc_pc_ex_o;           // Increment PC
  output         rf_rd_a_en_de_o;          // RF A port read enable
  output [3:0]   rf_rd_a_addr_de_o;        // RF A port read address
  output         rf_rd_b_en_de_o;          // RF B port read enable
  output [3:0]   rf_rd_b_addr_de_o;        // RF B port read address
  output         rf_wr_d_en_ex_o;          // RF D port write enable
  output [3:0]   rf_wr_d_addr_erly_ex_o;   // RF D port write address (early)
  output [3:0]   rf_wr_d_addr_ex_o;        // RF D port write address
  output [31:0]  rf_wr_d_data_erly_ex_o;   // RF D port write data (early)
  output [31:0]  rf_wr_d_data_ex_o;        // RF D port write data
  output         rf_wr_z_en_ex_o;          // RF Z port write enable
  output [3:0]   rf_wr_z_addr_ex_o;        // RF Z port write address
  output [31:0]  rf_wr_z_data_ex_o;        // RF Z port write data
  output         dpu_mcyc_invk_msk_o;      // Multi-cycle interrupt mask to NVIC
  output [1:0]   dpu_slp_ctl_ex_o;         // Sleep control
  output         dpu_slp_txev_ex_o;        // SEV transmit event
  output         dpu_basepri_we_o;         // BASEPRI write enable
  output [7:0]   dpu_basepri_ex_o;         // Next BASEPRI value
  output         dpu_fmask_we_o;           // FAULTMASK write enable
  output         dpu_fmask_ex_o;           // Next FAULTMASK value
  output         dpu_pmask_we_o;           // PRIMASK write enable
  output         dpu_pmask_ex_o;           // Next PRIMASK value
  output         dpu_raisepri_ex_o;        // Operation will raise priority
  output         fpu_active_ex_o;          // FPU has valid current context
  output         frc_context_ex_o;         // Forced FPU context
  output [4:0]   int_lr_exit_code_ex_o;    // Generated exit code for LR
  output [8:0]   int_isr_ex_o;             // Current ISR number
  output         dbg_halt_set_o;           // Core halt set
  output         dbg_halted_o;             // Core halted
  output         dbg_halted_reg_o;         // Core halted (registered)
  output         fault_svc_ex_o;           // SVC fault
  output         fault_dblfault_ex_o;      // Double fault
  output [5:0]   dpu_nxt_bfsr_o;           // Next BFSR value
  output [4:0]   dpu_nxt_mfsr_o;           // Next MFSR value
  output [9:0]   dpu_nxt_ufsr_o;           // Next UFSR value
  output         dpu_nxt_hfsr_o;           // Next HFSR value

  wire           full_hreset_n;            // Always reset signal
  wire [31:0]    opt_instr_ex;             // Optimised instruction in execute
  wire           opt_ext_en;               // Ext logic removal
  wire           opt_fpu_en;               // FPU logic removal
  wire           opt_obs_en;               // Observation logic removal
  wire [2:0]     instr_br_pflush_ex;       // Branch pipeline flush
  wire           instr_dp_pflush_ex;       // DP op pipeline flush
  wire           rst_pc_valid_ex_we;       // PC reset vector fetch write enable
  reg            rst_pc_valid_ex;          // PC reset vector fetch completed
  reg            instr_algn_ex;            // Align data
  reg  [1:0]     instr_barrier_ex;         // Instruction is a barrier
  reg            instr_br_t_changer_ex;    // Branch changes T bit
  reg            instr_czb_ex;             // Instruction is CZB
  reg            instr_itfold_ex;          // IT folded
  reg            instr_excl_reg;           // Instruction is an exclusive (reg)
  reg  [1:0]     instr_pc_lr_ex;           // Link LR into PC
  reg            instr_immed_valid_ex;     // Immediate valid
  reg            instr_sign_ex;            // Signed operation or sign extend
  reg            instr_exit_op_ex;         // Valid exit instruction in execute
  reg  [1:0]     instr_sp_wr_ex;           // SP write control
  reg  [4:0]     instr_msr_ctl_ex;         // MSR control
  reg  [2:0]     instr_cps_ctl_ex;         // CPS control
  reg  [1:0]     instr_data_size_ex;       // Data size
  reg            instr_16_mul_ex;          // Instruction is a T1 MUL
  wire           instr_immed_we;           // Immediate value write enable
  reg  [31:0]    instr_immed_ex;           // Immediate value
  reg  [31:0]    instr_ex;                 // Instruction in execute
  wire           user_thread_we;           // Next thread is user write enable
  wire           nxt_user_thread_ex;       // Next thread is user mode
  reg            user_thread_ex;           // Thread is (or will be) user mode
  wire           privileged;               // Privileged (vs user) mode
  wire           nxt_instr_valid_ex;       // Next instr in execute is valid
  reg            instr_valid_ex;           // Instruction in execute is valid
  wire           instr_not_bkpt_we;        // Instr not a BKPT write enable
  reg            instr_not_bkpt_ex;        // Instruction is not a BKPT
  wire           instr_bkpt_we;            // BKPT instruction write enable
  reg            instr_bkpt_ex;            // Instruction is BKPT
  wire           instr_copro_we;           // Coprocessor instr write enable
  reg            instr_copro_ex;           // Instruction is a coprocessor instr
  wire           instr_svc_we;             // SVC instruction write enable
  reg            instr_svc_ex;             // Instruction is SVC
  wire           instr_undef_we;           // UNDEF instruction write enable
  reg            instr_undef_ex;           // Instruction is an UNDEF
  wire           instr_txev_ex_we;         // SEV instruction write enable
  reg            instr_txev_ex;            // Instruction is SEV
  wire           dpu_slp_txev_ex;          // SEV transmit event
  wire           instr_wfe_we;             // WFE instruction write enable
  reg            instr_wfe_ex;             // Instruction is WFE
  wire           instr_wfi_we;             // WFI instruction write enable
  reg            instr_wfi_ex;             // Instruction is WFI
  wire           instr_slp_valid_ex;       // Sleep instruction is valid
  wire           proc_active_ex;           // lsu, dpu or fpu is active
  wire           instr_slp_ctl_valid_ex;   // Sleep control signals are valid
  wire [1:0]     dpu_slp_ctl_ex;           // Sleep control signals
  wire [2:0]     instr_raisepri_ex;        // Instruction will raise priority
  wire           dpu_raisepri_ex;          // Operation will raise priority
  wire           dpu_basepri_we;           // BASEPRI write enable
  wire [7:0]     dpu_basepri_ex;           // Next BASEPRI value
  wire           dpu_fmask_clr_ex;         // FAULTMASK clear
  wire           dpu_fmask_we;             // FAULTMASK write enable
  wire           dpu_fmask_ex;             // Next FAULTMASK value
  wire           dpu_pmask_we;             // PRIMASK write enable
  wire           dpu_pmask_ex;             // Next PRIMASK value
  wire           instr_detect_exit_ex;     // ISR exit detected
  wire [8:0]     int_isr_ex;               // Current ISR number
  wire           int_isr_exit_ex;          // Detect handler exit versus thread
  wire [4:0]     int_exit_code_ex;         // Exit codes from LSU and ALU
  wire           instr_atbase_we;          // Core in thread write enable
  wire           nxt_instr_atbase_ex;      // Next core in thread or handler
  reg            instr_atbase_ex;          // Core in thread
  wire           int_lr_exit_code_we;      // Exit code for LR write enable
  wire [4:0]     nxt_int_lr_exit_code_ex;  // Next exit code for LR
  reg  [4:0]     int_lr_exit_code_ex;      // Generated exit code for LR
  reg            int_sp_used;              // SP used for stacking
  reg            instr_advance_ex;         // Advance instruction
  wire           instr_complete_ex;        // Instruction has completed
  wire           instr_retire_ex;          // Instruction has retired
  wire [1:0]     instr_link_ex;            // Link LR to PC
  wire           iflush_pflush_ex;         // Pipline flush due to IFLUSH
  wire           clr_rf_pc_ctl0_ex;        // Clear PC inc [0]
  wire           rf_pc_ctl0_we;            // PC inc [0] write enable
  reg            rf_pc_ctl0_ex;            // PC inc [0]
  wire [1:0]     nxt_rf_pc_ctl1_ex;        // Next PC inc [1]
  reg  [1:0]     rf_pc_ctl1_ex;            // PC inc [1]
  wire [1:0]     rf_pc_ctl_ex;             // PC control
  wire           rf_inc_pc_ex;             // Increment PC
  wire           rf_rd_a_en_de;            // RF A port read enable
  wire [3:0]     rf_rd_a_addr_de;          // RF A port read address
  wire           rf_rd_b_en_de;            // RF B port read enable
  wire [3:0]     rf_rd_b_addr_de;          // RF B port read address
  wire           rf_wr_d_en_ex;            // RF D port write enable
  wire [3:0]     rf_wr_d_addr_ex;          // RF D port write address
  wire [31:0]    rf_wr_d_data_erly_ex;     // RF D port write data (early)
  wire [31:0]    rf_wr_d_data_ex;          // RF D port write data
  wire [3:0]     nxt_rf_wr_d_addr_erly_ex; // Next D port write address (early)
  reg  [3:0]     rf_wr_d_addr_erly_ex;     // RF D port write address (early)
  wire           rf_wr_z_en_ex;            // RF Z port write enable
  wire [3:0]     rf_wr_z_addr_ex;          // RF Z port write address
  wire [31:0]    rf_wr_z_data_ex;          // RF Z port write data
  wire [1:0]     rf_sp_rd_de;              // SP read control
  wire [1:0]     rf_sp_wr_ex;              // SP write control
  wire           process_sp_we;            // SP main vs process write enable
  wire           nxt_process_sp_ex;        // Next SP process vs main select
  reg            process_sp_ex;            // SP process vs main select
  wire [1:0]     rf_sp_sel_ex;             // SP selection
  wire           dbg_halt_set;             // Core halt set
  wire           dbg_halt_clr;             // Core halt clear
  wire           dbg_halt_we;              // Core halt write enable
  reg            dbg_halted;               // Core halted
  wire           dbg_halted_reg_we;        // Registered dbg_halted write enable
  reg            dbg_halted_reg;           // Core halted (registered)
  wire           instr_lr_ilock_we;        // LR interlock write enable
  reg            instr_lr_ilock_ex;        // LR interlock
  wire           bkpt_stall_set;           // BKPT stall set
  wire           bkpt_stall_clr;           // BKPT stall clear
  wire           bkpt_stall_we;            // BKPT stall write enable
  reg            bkpt_stall_ex;            // BKPT stall
  wire           nxt_svc_stall_ex;         // Next SVC stall
  wire           svc_stall_we;             // SVC stall write enable
  reg            svc_stall_ex;             // SVC stall
  reg            svc_stall_reg;            // SVC stall registered
  wire           barrier_stall_ex;         // Barrier stall
  wire           msr_stall_reg_we;         // MSR stall write enable
  wire           nxt_msr_stall_reg;        // Next MSR stall
  reg            msr_stall_reg;            // MSR stall
  wire           msr_stall_ex;             // MSR stall
  wire           sleep_stall_ex;           // Sleep stall
  wire           dbg_stall;                // Debug stall
  wire           fault_stall_ex;           // Fault stall
  wire           non_instr_stall;          // Non instruction based stall
  wire [3:0]     instr_stall_ex;           // Instruction based stall
  wire           instr_mcyc_ilock_ex;      // Multicycle operation interlock
  wire           dpu_mcyc_invk_msk;        // Multi-cycle interrupt mask to NVIC
  wire           fault_undef_ex;           // Undefined instruction fault
  wire           fault_nocopro_ex;         // Coprocessor instruction fault
  wire           fault_svc_ex;             // SVC fault
  wire           fault_state_we;           // T bit fault write enable
  reg            fault_state_ex;           // T bit fault
  wire           fault_fetch_we;           // Fetch fault write enable
  reg  [1:0]     fault_fetch_ex;           // Fetch fault
  wire           fault_ici_we;             // ICI fault write enable
  reg            fault_ici_ex;             // ICI fault
  wire           nxt_int_exit_err_ex;      // Next ISR exit error
  wire           int_exit_err_we;          // ISR exit error write enable
  reg            int_exit_err_ex;          // ISR exit error
  reg            int_exit_err_reg;         // ISR exit error (registered)
  wire [1:0]     fault_exit_ex;            // ISR exit fault
  wire           fault_dblfault_ex;        // Double fault
  wire [1:0]     nxt_fault_detected_ex;    // Next fault detected
  wire           fault_detected_we;        // Fault detected write enable
  reg  [1:0]     fault_detected_ex;        // Fault detected
  wire           set_instr_redo_ex;        // Set instr_redo_ex
  wire           instr_redo_we;            // instr_redo_ex write enable
  reg            instr_redo_ex;            // Instruction will be redone
  wire [5:0]     dpu_nxt_bfsr;             // Next BFSR value
  wire [4:0]     dpu_nxt_mfsr;             // Next MFSR value
  wire [9:0]     dpu_nxt_ufsr;             // Next UFSR value
  wire           dpu_nxt_hfsr;             // Next HFSR value
  wire           fpu_ctrl_we;              // update_ctrl with CC info
  wire           fpu_active_ex;            // CONTROL[2] - FPU active
  wire           fpu_active_we;            // CONTROL[2] write enable
  wire           nxt_fpu_active_ex;        // Next value for CONTROL[2]
  reg            fpu_active_int;           // FPU context valid
  wire           frc_context_we;           // frc_context_ex write enable
  reg            frc_context_ex;           // Force valid FPU context

`ifdef ARM_DSM

  wire          dsm_reset_all_regs;
  wire          dsm_observation;
  wire          dsm_fpu_present;

  assign full_hreset_n = dsm_reset_all_regs    ? hreset_n : 1'b1;

  assign opt_instr_ex  = dsm_observation       ? instr_ex : {32{1'b0}};
  assign opt_obs_en    = dsm_observation       ? 1'b1     : 1'b0;
  assign opt_fpu_en    = dsm_fpu_present       ? 1'b1     : 1'b0;

`else

  assign full_hreset_n = (RESET_ALL_REGS == 1) ? hreset_n : 1'b1;

  assign opt_instr_ex  = (OBSERVATION == 1)    ? instr_ex : {32{1'b0}};
  assign opt_obs_en    = (OBSERVATION == 1)    ? 1'b1     : 1'b0;
  assign opt_fpu_en    = (FPU_PRESENT == 1)    ? 1'b1     : 1'b0;

`endif

  assign opt_ext_en    = (EXT_PRESENT == 1)    ? 1'b1     : 1'b0;


  assign instr_br_pflush_ex = {(rf_wr_d_en_fe_i          & (&rf_wr_d_addr_fe_i)),
                               (lsu_rf_wr_d_en_fast_ex_i & (&lsu_rf_wr_d_addr_ex_i)),
                               (alu_rf_wr_d_en_ex_i      & (&alu_rf_wr_d_addr_ex_i))};

  assign instr_dp_pflush_ex = ((|instr_br_pflush_ex[1:0]) &
                               ~int_stack_op_i);


  assign rst_pc_valid_ex_we = instr_br_pflush_ex[2] & ~rst_pc_valid_ex;

  always @(posedge hclk or negedge hreset_n)
    if (!hreset_n)
      rst_pc_valid_ex <= 1'b0;
    else if (rst_pc_valid_ex_we)
      rst_pc_valid_ex <= 1'b1;


  always @ (posedge hclk or negedge hreset_n)
    if (!hreset_n)
      begin
        instr_algn_ex            <= 1'b0;
        instr_barrier_ex         <= 2'b00;
        instr_br_t_changer_ex    <= 1'b0;
        instr_czb_ex             <= 1'b0;
        instr_itfold_ex          <= 1'b0;
        instr_excl_reg           <= 1'b0;
        instr_pc_lr_ex           <= 2'b00;
        instr_immed_valid_ex     <= 1'b0;
        instr_sign_ex            <= 1'b0;
        instr_exit_op_ex         <= 1'b0;
        instr_sp_wr_ex           <= 2'b00;
        instr_data_size_ex       <= 2'b00;
        instr_16_mul_ex          <= 1'b0;
        instr_msr_ctl_ex         <= 5'b00000;
        instr_cps_ctl_ex         <= 3'b000;
      end
    else if (instr_de_2_ex_en_i)
      begin
        instr_algn_ex            <= instr_algn_de_i;
        instr_barrier_ex         <= instr_barrier_de_i;
        instr_br_t_changer_ex    <= instr_br_t_changer_de_i;
        instr_czb_ex             <= instr_czb_de_i;
        instr_itfold_ex          <= instr_itfold_de_i;
        instr_excl_reg           <= instr_excl_ex_i;
        instr_pc_lr_ex           <= instr_pc_lr_de_i;
        instr_immed_valid_ex     <= instr_imm_valid_de_i;
        instr_sign_ex            <= instr_sign_de_i;
        instr_exit_op_ex         <= instr_exit_op_de_i;
        instr_sp_wr_ex           <= instr_sp_wr_de_i;
        instr_data_size_ex       <= instr_data_size_de_i;
        instr_16_mul_ex          <= instr_16_mul_valid_de_i;
        instr_msr_ctl_ex         <= instr_msr_ctl_de_i;
        instr_cps_ctl_ex         <= instr_cps_ctl_de_i;
      end


  assign instr_immed_we = ((instr_valid_de_i &
                            (instr_imm_valid_de_i | instr_has_shft_imm_de_i)) |
                           lsu_stack_start_i);

  always @ (posedge hclk or negedge full_hreset_n)
    if (!full_hreset_n)
      instr_immed_ex <= {32{1'b0}};
    else if (instr_immed_we)
      instr_immed_ex <= instr_immed_de_i;

  always @ (posedge hclk or negedge hreset_n)
    if (!hreset_n)
      instr_ex <= {32{1'b0}};
    else if (opt_obs_en)
      instr_ex <= instr_de_i[31:0];


  assign user_thread_we     = (// MSR
                               (instr_msr_ctl_ex[4] & privileged &
                                ~msr_stall_reg & ~nvic_int_invoke_i) |
                               dbg_ctrl_wr_ex_i);

  assign nxt_user_thread_ex = (instr_msr_ctl_ex[4] ?
                               rf_rd_b_data_ex_i[0] :
                               lsu_psr_ex_i[24]);

  always @ (posedge hclk or negedge hreset_n)
    if (!hreset_n)
      user_thread_ex <= 1'b0;
    else if (user_thread_we)
      user_thread_ex <= nxt_user_thread_ex;

  assign privileged = ~(instr_atbase_ex & user_thread_ex);


  assign fpu_ctrl_we       = ((fpu_update_ctrl_i[0] & ~instr_ccpass_de_i) |
                              (fpu_update_ctrl_i[1] &  instr_ccpass_de_i));

  assign fpu_active_we     = (opt_fpu_en &
                              (// MSR
                               (instr_msr_ctl_ex[4] & privileged &
                                ~msr_stall_reg & ~nvic_int_invoke_i) |
                               dbg_ctrl_wr_ex_i |
                               fpu_ctrl_we));

  assign nxt_fpu_active_ex = ((instr_msr_ctl_ex[4]  & rf_rd_b_data_ex_i[2]) |
                              (dbg_ctrl_wr_ex_i     & lsu_psr_ex_i[26])     |
                              ((|fpu_update_ctrl_i) & ~fpu_active_ex));

  always @ (posedge hclk or negedge hreset_n)
    if (!hreset_n)
      fpu_active_int <= 1'b0;
    else if (fpu_active_we)
      fpu_active_int <= nxt_fpu_active_ex;

  assign frc_context_we = (opt_fpu_en & ~lsu_sp_wb_ex_i & ~fpu_fpscr_wr_de_i &
                           (nvic_no_lazy_stk_i != frc_context_ex) &
                           (int_entry_i | ~nvic_int_invoke_i));

  always @ (posedge hclk or negedge hreset_n)
    if (!hreset_n)
      frc_context_ex <= 1'b0;
    else if (frc_context_we)
      frc_context_ex <= nvic_no_lazy_stk_i;

  assign fpu_active_ex = opt_fpu_en & (fpu_active_int | frc_context_ex);


  assign nxt_instr_valid_ex = instr_valid_de_i & ~instr_bkpt_de_i;

  always @ (posedge hclk or negedge hreset_n)
    if (!hreset_n)
      instr_valid_ex <= 1'b0;
    else if (instr_de_2_ex_en_i)
      instr_valid_ex <= nxt_instr_valid_ex;



  assign instr_not_bkpt_we = (// Set
                              nxt_instr_valid_ex |
                              (instr_not_bkpt_ex &
                               (instr_bkpt_de_i   | dbg_halt_set |
                                lsu_stack_start_i | fpu_lazy_start_i)));

  always @ (posedge hclk or negedge hreset_n)
    if (!hreset_n)
      instr_not_bkpt_ex <= 1'b1;
    else if (instr_not_bkpt_we)
      instr_not_bkpt_ex <= nxt_instr_valid_ex;


  assign instr_bkpt_we = instr_bkpt_de_i ^ instr_bkpt_ex;

  always @ (posedge hclk or negedge hreset_n)
    if (!hreset_n)
      instr_bkpt_ex <= 1'b0;
    else if (instr_bkpt_we)
      instr_bkpt_ex <= instr_bkpt_de_i;


  assign instr_copro_we = instr_copro_de_i ^ instr_copro_ex;

  always @ (posedge hclk or negedge hreset_n)
    if (!hreset_n)
      instr_copro_ex <= 1'b0;
    else if (instr_copro_we)
      instr_copro_ex <= instr_copro_de_i;


  assign instr_svc_we = instr_svc_de_i ^ instr_svc_ex;

  always @ (posedge hclk or negedge hreset_n)
    if (!hreset_n)
      instr_svc_ex <= 1'b0;
    else if (instr_svc_we)
      instr_svc_ex <= instr_svc_de_i;


  assign instr_undef_we = instr_undef_de_i ^ instr_undef_ex;

  always @ (posedge hclk or negedge hreset_n)
    if (!hreset_n)
      instr_undef_ex <= 1'b0;
    else if (instr_undef_we)
      instr_undef_ex <= instr_undef_de_i;


  assign instr_txev_ex_we = instr_txev_de_i ^ instr_txev_ex;

  always @ (posedge hclk or negedge hreset_n)
    if (!hreset_n)
      instr_txev_ex <= 1'b0;
    else if (instr_txev_ex_we)
      instr_txev_ex <= instr_txev_de_i;

  assign dpu_slp_txev_ex = instr_txev_ex & instr_ccpass_ex_i;


  assign instr_wfe_we = (instr_wfe_de_i |
                         (instr_wfe_ex &
                          (nvic_int_invoke_i | nvic_dbg_halt_req_i |
                           ~instr_ccpass_ex_i | ~proc_active_ex)));

  always @ (posedge hclk or negedge hreset_n)
    if (!hreset_n)
      instr_wfe_ex <= 1'b0;
    else if (instr_wfe_we)
      instr_wfe_ex <= instr_wfe_de_i;


  assign instr_wfi_we = (instr_wfi_de_i |
                         (instr_wfi_ex &
                          (nvic_int_invoke_i | nvic_dbg_halt_req_i |
                           ~instr_ccpass_ex_i | ~proc_active_ex)));

  always @ (posedge hclk or negedge hreset_n)
    if (!hreset_n)
      instr_wfi_ex <= 1'b0;
    else if (instr_wfi_we)
      instr_wfi_ex <= instr_wfi_de_i;


  assign instr_slp_valid_ex     = (instr_ccpass_ex_i & ~nvic_int_invoke_i &
                                   ~nvic_dbg_halt_req_i);

  assign proc_active_ex         = (mtx_bm_active_i |
                                   lsu_active_ex_i |
                                   fpu_busy_ex_i);

  assign instr_slp_ctl_valid_ex = (instr_slp_valid_ex & ~proc_active_ex);

  assign dpu_slp_ctl_ex         = ({ instr_wfe_ex, instr_wfi_ex } &
                                   {2{instr_slp_ctl_valid_ex}});


  assign instr_raisepri_ex  = {// PRIMASK:
                               ((instr_msr_ctl_ex[0] & rf_rd_b_data_ex_i[0] &
                                 ~nvic_pmask_i) |
                                (instr_cps_ctl_ex[2] & instr_cps_ctl_ex[0] &
                                 ~nvic_pmask_i)),
                               (instr_msr_ctl_ex[3] & rf_rd_b_data_ex_i[0] &
                                ~(|nvic_int_in_nmihf_i[1:0])) |
                               (instr_cps_ctl_ex[1] & instr_cps_ctl_ex[0] &
                                ~(|nvic_int_in_nmihf_i[1:0])),
                               ((|instr_msr_ctl_ex[2:1]) &
                                (|rf_rd_b_data_ex_i[7:0]) &
                                (~(|nvic_basepri_i) |
                                 (rf_rd_b_data_ex_i[7:0] < nvic_basepri_i)))};

  assign dpu_raisepri_ex   = (|instr_raisepri_ex);

  assign dpu_basepri_we    = ((// MSR
                               privileged & ~msr_stall_reg &
                               (~nvic_int_invoke_i | ~instr_raisepri_ex[0]) &
                               (instr_msr_ctl_ex[1] |
                                (instr_msr_ctl_ex[2] & instr_raisepri_ex[0]))) |
                              dbg_ctrl_wr_ex_i);

  assign dpu_basepri_ex    = ((|instr_msr_ctl_ex[2:1]) ?
                              rf_rd_b_data_ex_i[7:0] :
                              lsu_psr_ex_i[15:8]);

  assign dpu_fmask_clr_ex  = (// MSR
                              (instr_msr_ctl_ex[3] & ~rf_rd_b_data_ex_i[0]) |
                              (instr_cps_ctl_ex[1] & ~instr_cps_ctl_ex[0]));

  assign dpu_fmask_we      = ((// MSR/CPS
                               privileged & ~msr_stall_reg &
                               ((instr_raisepri_ex[1] & ~nvic_int_invoke_i) |
                                dpu_fmask_clr_ex) &
                               (instr_msr_ctl_ex[3] | instr_cps_ctl_ex[1])) |
                              dbg_ctrl_wr_ex_i |
                              (int_vector_fault_i & ~rst_pc_valid_ex));

  assign dpu_fmask_ex      = (// RF data for MSR
                              (instr_msr_ctl_ex[3] & rf_rd_b_data_ex_i[0]) |
                              (instr_cps_ctl_ex[1] & instr_cps_ctl_ex[0])  |
                              (dbg_ctrl_wr_ex_i    & lsu_psr_ex_i[16])     |
                              (int_vector_fault_i  & ~rst_pc_valid_ex));

  assign dpu_pmask_we      = ((// MSR/CPS
                               privileged & ~msr_stall_reg &
                               ((instr_raisepri_ex[2] & ~nvic_int_invoke_i) |
                                ~instr_raisepri_ex[2]) &
                               (instr_msr_ctl_ex[0] | instr_cps_ctl_ex[2])) |
                              dbg_ctrl_wr_ex_i);

  assign dpu_pmask_ex      = (// RF data for MSR
                              (instr_msr_ctl_ex[0] & rf_rd_b_data_ex_i[0]) |
                              (instr_cps_ctl_ex[2] & instr_cps_ctl_ex[0])  |
                              (dbg_ctrl_wr_ex_i    & lsu_psr_ex_i[0]));


  assign instr_detect_exit_ex = (alu_exit_valid_ex_i | lsu_exit_valid_ex_i);

  assign int_isr_exit_ex      = (instr_detect_exit_ex & (|int_isr_ex) &
                                 ~fault_dblfault_ex);

  assign int_exit_code_ex     = (({5{lsu_exit_valid_ex_i}} & lsu_exit_code_ex_i) |
                                 ({5{alu_exit_valid_ex_i}} & alu_exit_code_ex_i));


  assign instr_atbase_we      = (int_isr_exit_ex | int_entry_i |
                                 int_return_i    | dbg_wr_isr_i);

  assign nxt_instr_atbase_ex  = (// Exit to base
                                 (int_isr_exit_ex & int_exit_code_ex[3]) |
                                 ((int_return_i | dbg_wr_isr_i) &
                                  ~(|int_retisr_i)));

  always @ (posedge hclk or negedge hreset_n)
    if (!hreset_n)
      instr_atbase_ex <= 1'b1;
    else if (instr_atbase_we)
      instr_atbase_ex <= nxt_instr_atbase_ex;


  assign int_lr_exit_code_we     = instr_detect_exit_ex | lsu_stack_start_i;

  assign nxt_int_lr_exit_code_ex = (instr_detect_exit_ex ?
                                    int_exit_code_ex :
                                    {((~fpu_active_ex & ~fpu_update_ctrl_i[0]) |
                                      ~opt_fpu_en),
                                     instr_atbase_ex,
                                     rf_sp_sel_ex[0] & instr_atbase_ex,
                                     1'b0,
                                     1'b1});

  always @ (posedge hclk or negedge hreset_n)
    if (!hreset_n)
      int_lr_exit_code_ex <= 5'b00000;
    else if (int_lr_exit_code_we)
      int_lr_exit_code_ex <= nxt_int_lr_exit_code_ex;



  always @ (posedge hclk or negedge hreset_n)
    if (!hreset_n)
      int_sp_used <= 1'b0;
    else if (lsu_stack_start_i & opt_fpu_en)
      int_sp_used <= rf_sp_sel_ex[0];

  assign int_isr_ex = instr_atbase_ex ? {9{1'b0}} : nvic_int_curr_isr_i;


  always @ (posedge hclk or negedge hreset_n)
    if (!hreset_n)
      instr_advance_ex <= 1'b0;
    else
      instr_advance_ex <= instr_advance_de_i;

  assign instr_complete_ex = (instr_valid_ex & ~(|instr_stall_ex[2:0]) &
                              ~lsu_stall_late_ex_i);

  assign instr_retire_ex   = (instr_complete_ex |
                              lsu_stack_start_i |
                              fault_dblfault_ex);


  assign instr_link_ex     = instr_pc_lr_ex & {2{instr_ccpass_ex_i}};

  assign iflush_pflush_ex  = (instr_ext_pflush_fe_i & ~(|instr_stall_ex[2:0]) &
                              ~(nvic_int_invoke_i & ~int_entry_i) &
                              ~nvic_dbg_mon_req_i & ~nvic_dbg_halt_req_i &
                              ~instr_detect_exit_ex);


  assign clr_rf_pc_ctl0_ex = (((|instr_br_pflush_ex[1:0]) | fpu_lazy_stack_op_i) &
                              rf_pc_ctl0_ex);

  assign rf_pc_ctl0_we     = (// Clear
                              clr_rf_pc_ctl0_ex |
                              (instr_valid_de_i & ~rf_pc_ctl0_ex));

  always @ (posedge hclk or negedge hreset_n)
    if (!hreset_n)
      rf_pc_ctl0_ex <= 1'b0;
    else if (rf_pc_ctl0_we)
      rf_pc_ctl0_ex <= instr_valid_de_i;

  assign nxt_rf_pc_ctl1_ex = { rf_pc_ctl1_ex[0] & ~clr_rf_pc_ctl0_ex,
                               instr_used_word_de_i };

  always @ (posedge hclk or negedge hreset_n)
    if (!hreset_n)
      rf_pc_ctl1_ex <= 2'b00;
    else if (instr_valid_de_i)
      rf_pc_ctl1_ex <= nxt_rf_pc_ctl1_ex;

  assign rf_pc_ctl_ex = { rf_pc_ctl1_ex[1], rf_pc_ctl0_ex };

  assign rf_inc_pc_ex = (rf_pc_ctl0_ex & ~(|instr_br_pflush_ex[1:0]) &
                         ~(|instr_stall_ex) & ~instr_all_ilock_de_i &
                         ~lsu_stall_late_ex_i &
                         ((instr_valid_fe_i & ~lazy_stall_erly_de_i &
                           ~(instr_mcyc_ilock_ex | fpu_interlock_de_i)) |
                          lsu_stack_start_i |
                          instr_ext_pflush_fe_i |
                          (nvic_dbg_halt_req_i & mtx_ahb_hreadyd_i &
                           ~mtx_bm_active_i & ~dbg_halted)));


  assign rf_rd_a_en_de   = (lsu_rf_rd_a_en_ex_i |
                            alu_rf_rd_a_en_ex_i |
                            instr_rf_rd_a_en_de_i);

  assign rf_rd_a_addr_de = (lsu_rf_rd_a_en_fast_ex_i ?
                            lsu_rf_rd_a_addr_ex_i :
                            (alu_rf_rd_a_en_ex_i ?
                             alu_rf_rd_a_addr_ex_i :
                             instr_rf_rd_a_addr_de_i));

  assign rf_rd_b_en_de   = instr_rf_rd_b_en_de_i;

  assign rf_rd_b_addr_de = instr_rf_rd_b_addr_de_i;

  assign rf_wr_d_en_ex   = (alu_rf_wr_d_en_ex_i | lsu_rf_wr_d_en_ex_i |
                            rf_wr_d_en_fe_i     | fpu_rf_wr_en_ex_i);

  assign rf_wr_d_addr_ex = (// ALU
                            ({4{alu_rf_wr_d_en_ex_i}} & alu_rf_wr_d_addr_ex_i) |
                            ({4{~fpu_rf_wr_en_ex_i}}  & lsu_rf_wr_d_addr_ex_i) |
                            ({4{rf_wr_d_en_fe_i}}     & rf_wr_d_addr_fe_i)     |
                            ({4{fpu_rf_wr_en_ex_i}}   & fpu_rf_addr_ex_i));

  assign rf_wr_d_data_erly_ex = (// ALU
                                 ({32{alu_rf_wr_d_en_ex_i}} & alu_rf_wr_d_data_ex_i) |
                                 ({32{lsu_rf_wr_d_en_ex_i}} & lsu_rf_wr_d_data_ex_i) |
                                 ({32{rf_wr_d_en_fe_i}}     & rf_wr_d_data_fe_i)     |
                                 ({32{fpu_rf_wr_en_ex_i}}   & fpu_wr_data_ex_i));

  assign rf_wr_d_data_ex      = rf_wr_d_data_erly_ex | e_rf_wr_d_data_ex_i;

  assign nxt_rf_wr_d_addr_erly_ex  = ((instr_lsu_ctl_de_i[13] &
                                       ~instr_lsu_ctl_de_i[6]) ?
                                      instr_rf_rd_c_addr_de_i :
                                      rf_wr_d_addr_de_i);

  always @ (posedge hclk or negedge hreset_n)
    if (!hreset_n)
      rf_wr_d_addr_erly_ex <= 4'b0000;
    else if (instr_valid_de_i)
      rf_wr_d_addr_erly_ex <= nxt_rf_wr_d_addr_erly_ex;

  assign rf_wr_z_en_ex     = (e_rf_wr_z_en_ex_i | lsu_rf_wr_z_en_ex_i);

  assign rf_wr_z_addr_ex   = (// E
                              ({4{ e_rf_wr_z_en_ex_i}} & e_rf_wr_z_addr_ex_i) |
                              ({4{~e_rf_wr_z_en_ex_i}} & lsu_rf_wr_z_addr_ex_i));

  assign rf_wr_z_data_ex   = lsu_rf_wr_z_data_ex_i | e_rf_wr_z_data_ex_i;

  assign rf_sp_rd_de       = (dbg_halted ?
                              { nvic_dbg_reg_addr_i[1],
                                (|nvic_dbg_reg_addr_i[1:0]) &
                                nvic_dbg_reg_addr_i[4] } :
                              ((lsu_real_sp_rd_i & opt_fpu_en) ?
                               ({ int_sp_used, 1'b1 }) :
                               (instr_sp_rd_de_i &
                                ~{1'b0,
                                  alu_rf_rd_a_en_ex_i |
                                  lsu_rf_rd_a_en_fast_ex_i})));

  assign rf_sp_wr_ex       = (dbg_halted ?
                              { nvic_dbg_reg_addr_i[1],
                                (|nvic_dbg_reg_addr_i[1:0]) &
                                nvic_dbg_reg_addr_i[4] } :
                              instr_sp_wr_ex);

  assign process_sp_we     = (// MSR from thread
                              (instr_msr_ctl_ex[4] & instr_atbase_ex &
                               privileged & ~msr_stall_reg &
                               ~nvic_int_invoke_i) |
                              int_isr_exit_ex |
                              dbg_ctrl_wr_ex_i |
                              lsu_main_sp_en_i);

  assign nxt_process_sp_ex = (// MSR update
                              (instr_msr_ctl_ex[4] & rf_rd_b_data_ex_i[1]) |
                              (int_isr_exit_ex     & int_exit_code_ex[2])  |
                              (dbg_ctrl_wr_ex_i    & lsu_psr_ex_i[25]));

  always @ (posedge hclk or negedge hreset_n)
    if (!hreset_n)
      process_sp_ex <= 1'b0;
    else if (process_sp_we)
      process_sp_ex <= nxt_process_sp_ex;

  assign rf_sp_sel_ex = { ((instr_detect_exit_ex & (|int_isr_ex)) ?
                           int_exit_code_ex[2] : process_sp_ex),
                          process_sp_ex };


  assign dbg_halt_set  = (nvic_dbg_halt_req_i & ~dbg_halted & mtx_ahb_hreadyd_i &
                          ~mtx_bm_active_i & ~fault_dblfault_ex &
                          ~(|instr_stall_ex[2:0]) & ~lsu_stall_late_ex_i &
                          ~instr_detect_exit_ex &
                          ~(nvic_int_invoke_i & ~int_entry_i));

  assign dbg_halt_clr  = (dbg_halted &
                          ~(nvic_dbg_halt_req_i |
                            lsu_stall_ex_i      |
                            lsu_stall_late_ex_i));

  assign dbg_halt_we   = dbg_halt_set | dbg_halt_clr;

  always @ (posedge hclk or negedge hreset_n)
    if (!hreset_n)
      dbg_halted <= 1'b0;
    else if (dbg_halt_we)
      dbg_halted <= dbg_halt_set;

  assign dbg_halted_reg_we = dbg_halted_reg ^ dbg_halted;

  always @ (posedge hclk or negedge hreset_n)
    if (!hreset_n)
      dbg_halted_reg <= 1'b0;
    else if (dbg_halted_reg_we)
      dbg_halted_reg <= dbg_halted;


  assign instr_lr_ilock_we = lsu_stack_start_i | instr_valid_de_i;

  always @ (posedge hclk or negedge hreset_n)
    if (!hreset_n)
      instr_lr_ilock_ex <= 1'b0;
    else if (instr_lr_ilock_we)
      instr_lr_ilock_ex <= instr_lr_ilock_de_i;

  assign bkpt_stall_set = (instr_bkpt_ex & ~non_instr_stall &
                           ~((|nvic_int_in_nmihf_i[1:0]) & ~nvic_int_invoke_i));
  assign bkpt_stall_clr = bkpt_stall_ex &  non_instr_stall;
  assign bkpt_stall_we  = bkpt_stall_set | bkpt_stall_clr;

  always @ (posedge hclk or negedge hreset_n)
    if (!hreset_n)
      bkpt_stall_ex <= 1'b0;
    else if (bkpt_stall_we)
      bkpt_stall_ex <= bkpt_stall_set;

  assign nxt_svc_stall_ex = fault_svc_ex & ~nvic_int_invoke_i;
  assign svc_stall_we     = nxt_svc_stall_ex | svc_stall_ex | svc_stall_reg;

  always @ (posedge hclk or negedge hreset_n)
    if (!hreset_n)
      begin
        svc_stall_ex  <= 1'b0;
        svc_stall_reg <= 1'b0;
      end
    else if (svc_stall_we)
      begin
        svc_stall_ex  <= nxt_svc_stall_ex;
        svc_stall_reg <= svc_stall_ex;
      end

  assign barrier_stall_ex = (|(instr_barrier_ex &
                               ({2{mtx_bm_active_i}} |
                                {1'b0,lsu_active_ex_i})) &
                             ~nvic_int_invoke_i);

  assign msr_stall_ex = (// Interrupt abandoned
                         (msr_stall_reg & nvic_int_invoke_i &
                          ~instr_msr_ctl_ex[4]) |
                         ~msr_stall_reg & privileged &
                         (// ThreadIsUser
                          instr_msr_ctl_ex[4] |
                          dpu_raisepri_ex));

  assign msr_stall_reg_we  = msr_stall_reg | nxt_msr_stall_reg;
  assign nxt_msr_stall_reg = msr_stall_ex & ~nvic_int_invoke_i;

  always @ (posedge hclk or negedge hreset_n)
    if (!hreset_n)
      msr_stall_reg <= 1'b0;
    else if (msr_stall_reg_we)
      msr_stall_reg <= nxt_msr_stall_reg;

  assign sleep_stall_ex   = (instr_wfe_ex | instr_wfi_ex) & instr_slp_valid_ex;

  assign dbg_stall        = dbg_halted | instr_bkpt_ex | bkpt_stall_ex;

  assign fault_stall_ex   = (nxt_fault_detected_ex[1] | (|fault_detected_ex) |
                             nxt_svc_stall_ex |
                             (svc_stall_ex & ~nvic_int_invoke_i));

  assign non_instr_stall  = (mtx_ahb_hreadyd_i &
                             (// Interrupt
                              (nvic_int_invoke_i   & ~int_entry_i) |
                              (nvic_dbg_halt_req_i & ~mtx_bm_active_i)));

  assign instr_stall_ex   = { // Debug
                              dbg_stall,
                              fault_stall_ex,
                              fpu_stall_ex_i & opt_fpu_en,
                              (alu_stall_ex_i | barrier_stall_ex |
                               lsu_stall_ex_i | msr_stall_ex     |
                               sleep_stall_ex) };

  assign instr_mcyc_ilock_ex = ((lsu_mcyc_ilock_ex_i | alu_mcyc_ilock_ex_i) &
                                nvic_dismcycint_i);

  assign dpu_mcyc_invk_msk   = lsu_mcyc_invk_msk_ex_i | alu_mcyc_invk_msk_ex_i;


  assign fault_undef_ex   = (// UNDEF
                             (instr_undef_ex & instr_ccpass_ex_i) |
                             (instr_svc_ex & instr_ccpass_ex_i &
                              (|nvic_int_in_nmihf_i[1:0])));

  assign fault_nocopro_ex = ((instr_copro_ex & instr_ccpass_ex_i) |
                             fault_nocopro_fpu_i);

  assign fault_svc_ex     = (instr_svc_ex & instr_ccpass_ex_i &
                             ~(|nvic_int_in_nmihf_i[1:0]));

  assign fault_state_we   = (fault_state_de_i | fault_state_ex);

  always @ (posedge hclk or negedge hreset_n)
    if (!hreset_n)
      fault_state_ex <= 1'b0;
    else if (fault_state_we)
      fault_state_ex <= fault_state_de_i;

  assign fault_fetch_we   = ((fault_fetch_de_i &
                              {2{~lsu_stall_late_ex_i & ~svc_stall_reg}}) !=
                             fault_fetch_ex);

  always @ (posedge hclk or negedge hreset_n)
    if (!hreset_n)
      fault_fetch_ex <= 2'b00;
    else if (fault_fetch_we)
      fault_fetch_ex <= fault_fetch_de_i;

  assign fault_ici_we     = fault_ici_de_i | fault_ici_ex;

  always @ (posedge hclk or negedge hreset_n)
    if (!hreset_n)
      fault_ici_ex <= 1'b0;
    else if (fault_ici_we)
      fault_ici_ex <= fault_ici_de_i;

  assign nxt_int_exit_err_ex = (instr_detect_exit_ex &
                                (// Bad exit code
                                 ~((int_exit_code_ex[3:0]==4'b0001) |
                                   (int_exit_code_ex[3:0]==4'b1001) |
                                   (int_exit_code_ex[3:0]==4'b1101)) |
                                 ((int_exit_code_ex[3:0]==4'b0001) &
                                  (&nvic_int_in_nmihf_i[1:0]) &
                                  ~nvic_int_stk_actv_i)              |
                                 (int_exit_code_ex[3] & nvic_int_stk_actv_i &
                                  ~nvic_nonbasethrden_i)));

  assign int_exit_err_we = (// Set
                            nxt_int_exit_err_ex |
                            int_exit_err_ex     |
                            int_exit_err_reg);

  always @ (posedge hclk or negedge hreset_n)
    if (!hreset_n)
      begin
        int_exit_err_ex  <= 1'b0;
        int_exit_err_reg <= 1'b0;
      end
    else if (int_exit_err_we)
      begin
        int_exit_err_ex  <= nxt_int_exit_err_ex;
        int_exit_err_reg <= int_exit_err_ex;
      end

  assign fault_exit_ex     = { int_exit_err_reg, nxt_int_exit_err_ex };

  assign fault_dblfault_ex = ((|nvic_int_in_nmihf_i[1:0]) &
                              ~(int_stack_op_i | fpu_lazy_stack_op_i) &
                              (// Bus fault
                               (fault_lsu_ex_i[0] &
                                ~((|nvic_int_in_nmihf_i[1:0]) &
                                  nvic_bfhfnmign_i)) |
                               fault_fetch_ex[0]    |
                               (|dpu_nxt_ufsr[9:3]) |
                               (|dpu_nxt_ufsr[1:0]) |
                               (|dpu_nxt_mfsr[1:0]) |
                               ((&nvic_int_in_nmihf_i[1:0]) & fault_exit_ex[0]) |
                               instr_bkpt_ex));

  assign nxt_fault_detected_ex = { (~(int_stack_op_i | fpu_lazy_stack_op_i) &
                                    ((fault_lsu_ex_i[0] &
                                      ~((|nvic_int_in_nmihf_i[1:0]) &
                                        nvic_bfhfnmign_i)) |
                                     fault_fetch_ex[0]    |
                                     (|dpu_nxt_mfsr[2:0]) |
                                     (|dpu_nxt_ufsr[1:0]) |
                                     (|dpu_nxt_ufsr[9:3]))),
                                   fault_detected_ex[1] };

  assign fault_detected_we     = ((nxt_fault_detected_ex[1] &
                                   ~((|nvic_int_in_nmihf_i[1:0]) &
                                     ~nvic_int_invoke_i)) |
                                  fault_detected_ex[1] |
                                  (fault_detected_ex[0] & non_instr_stall));

  always @ (posedge hclk or negedge hreset_n)
    if (!hreset_n)
      fault_detected_ex <= 2'b00;
    else if (fault_detected_we)
      fault_detected_ex <= nxt_fault_detected_ex;

  assign set_instr_redo_ex = (// Stack faults
                              (((|dpu_nxt_mfsr[3:2]) | (|dpu_nxt_bfsr[4:3])) &
                               ~nvic_int_invoke_i) |
                              ((fault_lsu_ex_i[0] &
                                ~((|nvic_int_in_nmihf_i[1:0]) &
                                  nvic_bfhfnmign_i)) |
                               (dpu_nxt_mfsr[1]) |
                               (|dpu_nxt_ufsr[1:0]) |
                               (|dpu_nxt_ufsr[9:3]) |
                               instr_bkpt_ex));

  assign instr_redo_we     = (set_instr_redo_ex |
                              (instr_redo_ex & ~dbg_halted &
                               (lsu_stack_start_i | instr_valid_de_i)));

  always @ (posedge hclk or negedge hreset_n)
    if (!hreset_n)
      instr_redo_ex <= 1'b0;
    else if (instr_redo_we)
      instr_redo_ex <= set_instr_redo_ex;


  assign dpu_nxt_bfsr  = { fault_lsu_ex_i[4:0],
                           fault_fetch_ex[0] };

  assign dpu_nxt_mfsr  = { fault_lsu_ex_i[7:5],
                           fault_lsu_ex_i[8],
                           fault_fetch_ex[1] };

  assign dpu_nxt_ufsr  = { fault_divby0_ex_i,
                           fault_lsu_ex_i[9],
                           4'b0000,
                           fault_nocopro_ex,
                           (fault_exit_ex[1] | fault_lsu_ex_i[10]),
                           (fault_state_ex | fault_ici_ex),
                           fault_undef_ex };

  assign dpu_nxt_hfsr  = int_vector_fault_i;

  assign rst_pc_valid_ex_o       = rst_pc_valid_ex;
  assign iflush_pflush_ex_o      = iflush_pflush_ex;
  assign instr_ex_o              = opt_instr_ex;
  assign instr_stall_ex_o        = instr_stall_ex;
  assign instr_valid_ex_o        = instr_valid_ex;
  assign instr_immed_ex_o        = instr_immed_ex;
  assign instr_immed_valid_ex_o  = instr_immed_valid_ex;
  assign instr_algn_ex_o         = instr_algn_ex;
  assign instr_link_ex_o         = instr_link_ex;
  assign instr_sign_ex_o         = instr_sign_ex;
  assign instr_data_size_ex_o    = instr_data_size_ex;
  assign instr_exit_op_ex_o      = instr_exit_op_ex;
  assign instr_16_mul_ex_o       = instr_16_mul_ex;
  assign instr_czb_ex_o          = instr_czb_ex;
  assign instr_bkpt_ex_o         = instr_bkpt_ex;
  assign instr_not_bkpt_ex_o     = instr_not_bkpt_ex;
  assign instr_retire_ex_o       = instr_retire_ex;
  assign instr_complete_ex_o     = instr_complete_ex;
  assign instr_advance_ex_o      = instr_advance_ex;
  assign instr_itfold_ex_o       = instr_itfold_ex;
  assign instr_detect_exit_ex_o  = instr_detect_exit_ex;
  assign instr_atbase_ex_o       = instr_atbase_ex;
  assign instr_lr_ilock_ex_o     = instr_lr_ilock_ex;
  assign instr_mcyc_ilock_ex_o   = instr_mcyc_ilock_ex;
  assign instr_br_t_changer_ex_o = instr_br_t_changer_ex;
  assign instr_dp_pflush_ex_o    = instr_dp_pflush_ex;
  assign instr_br_pflush_ex_o    = instr_br_pflush_ex;
  assign set_instr_redo_ex_o     = set_instr_redo_ex;
  assign instr_redo_ex_o         = instr_redo_ex;
  assign instr_excl_reg_o        = instr_excl_reg;
  assign privileged_o            = privileged;
  assign user_thread_ex_o        = user_thread_ex;
  assign rf_sp_rd_de_o           = rf_sp_rd_de;
  assign rf_sp_wr_ex_o           = rf_sp_wr_ex;
  assign rf_sp_sel_ex_o          = rf_sp_sel_ex;
  assign rf_pc_ctl_ex_o          = rf_pc_ctl_ex;
  assign rf_inc_pc_ex_o          = rf_inc_pc_ex;
  assign rf_rd_a_en_de_o         = rf_rd_a_en_de;
  assign rf_rd_a_addr_de_o       = rf_rd_a_addr_de;
  assign rf_rd_b_en_de_o         = rf_rd_b_en_de;
  assign rf_rd_b_addr_de_o       = rf_rd_b_addr_de;
  assign rf_wr_d_en_ex_o         = rf_wr_d_en_ex;
  assign rf_wr_d_addr_erly_ex_o  = rf_wr_d_addr_erly_ex;
  assign rf_wr_d_addr_ex_o       = rf_wr_d_addr_ex;
  assign rf_wr_d_data_erly_ex_o  = rf_wr_d_data_erly_ex;
  assign rf_wr_d_data_ex_o       = rf_wr_d_data_ex;
  assign rf_wr_z_en_ex_o         = opt_ext_en & rf_wr_z_en_ex;
  assign rf_wr_z_addr_ex_o       = {4{opt_ext_en}} & rf_wr_z_addr_ex;
  assign rf_wr_z_data_ex_o       = {32{opt_ext_en}} & rf_wr_z_data_ex;
  assign dpu_mcyc_invk_msk_o     = dpu_mcyc_invk_msk;
  assign dpu_slp_ctl_ex_o        = dpu_slp_ctl_ex;
  assign dpu_slp_txev_ex_o       = dpu_slp_txev_ex;
  assign dpu_basepri_we_o        = dpu_basepri_we;
  assign dpu_basepri_ex_o        = dpu_basepri_ex;
  assign dpu_fmask_we_o          = dpu_fmask_we;
  assign dpu_fmask_ex_o          = dpu_fmask_ex;
  assign dpu_pmask_we_o          = dpu_pmask_we;
  assign dpu_pmask_ex_o          = dpu_pmask_ex;
  assign dpu_raisepri_ex_o       = dpu_raisepri_ex;
  assign fpu_active_ex_o         = opt_fpu_en & fpu_active_ex;
  assign frc_context_ex_o        = opt_fpu_en & frc_context_ex;
  assign int_lr_exit_code_ex_o   = int_lr_exit_code_ex;
  assign int_isr_ex_o            = int_isr_ex;
  assign dbg_halt_set_o          = dbg_halt_set;
  assign dbg_halted_o            = dbg_halted;
  assign dbg_halted_reg_o        = dbg_halted_reg;
  assign fault_svc_ex_o          = fault_svc_ex;
  assign fault_dblfault_ex_o     = fault_dblfault_ex;
  assign dpu_nxt_bfsr_o          = dpu_nxt_bfsr;
  assign dpu_nxt_mfsr_o          = dpu_nxt_mfsr;
  assign dpu_nxt_ufsr_o          = dpu_nxt_ufsr;
  assign dpu_nxt_hfsr_o          = dpu_nxt_hfsr;


`ifdef ARM_ASSERT_ON

  wire [3:0]     ovl_idle_ex;
  reg            ovl_idle_state_we;
  reg  [2:0]     ovl_idle_state;
  reg            ovl_exec_state_we;
  reg  [2:0]     ovl_nxt_exec_state;
  reg  [2:0]     ovl_exec_state;


  assign ovl_idle_ex = {(// Exit -> unstacking
                         (instr_detect_exit_ex & ~fault_dblfault_ex) |
                         (nvic_int_invoke_i & mtx_ahb_hreadyd_i &
                          ~int_entry_i & ~dbg_halted)),
                        dbg_halt_set,
                        instr_lsu_ctl_de_i[0],
                        ((|instr_alu_ctl_de_i[17:13]) |
                         instr_alu_ctl_de_i[3]) |
                        (instr_valid_de_i & ~e_undef_de_i)};

  always @ (ovl_exec_state or ovl_idle_ex or instr_detect_exit_ex or
            fault_dblfault_ex)
    case (ovl_idle_ex)
      4'b1100,                4'b1101,                4'b1110,
      4'b1000,                4'b1001,                4'b1010 :
        begin
          ovl_idle_state_we = 1'b1;
          ovl_idle_state    = `CORE_ST_INT;
        end
      4'b0100,                4'b0101,                4'b0110 :
        begin
          ovl_idle_state_we = 1'b1;
          ovl_idle_state    = ((instr_detect_exit_ex & ~fault_dblfault_ex) ?
                               `CORE_ST_INT : `CORE_ST_DBG);
        end
      4'b0010 :
        begin
          ovl_idle_state_we = 1'b1;
          ovl_idle_state    = `CORE_ST_LSU;
        end
      4'b0001 :
        begin
          ovl_idle_state_we = 1'b1;
          ovl_idle_state    = `CORE_ST_ARITH;
        end
      4'b0000 :
        begin
          ovl_idle_state_we = (ovl_exec_state!=`CORE_ST_IDLE);
          ovl_idle_state    = `CORE_ST_IDLE;
        end
      4'b0011,                4'b0111,                4'b1011,
      4'b1111 :
        begin
          ovl_idle_state_we = 1'b0;
          ovl_idle_state    = 3'b000;
        end
      default :
        begin
          ovl_idle_state_we = 1'b0;
          ovl_idle_state    = 3'bxxx;
        end
    endcase

  always @ (ovl_exec_state or instr_br_pflush_ex or ovl_idle_state_we or
            ovl_idle_state or alu_stall_ex_i or lsu_stall_ex_i or
            nvic_dbg_halt_req_i or lsu_stack_start_i or fault_dblfault_ex or
            nvic_int_invoke_i or int_entry_i or int_return_i)
    begin
      case (ovl_exec_state)
        `CORE_ST_RST : begin
          ovl_exec_state_we  = instr_br_pflush_ex[2];
          ovl_nxt_exec_state = `CORE_ST_IDLE;
        end
        `CORE_ST_IDLE : begin
          ovl_exec_state_we  = ovl_idle_state_we;
          ovl_nxt_exec_state = ovl_idle_state;
        end
        `CORE_ST_ARITH : begin
          ovl_exec_state_we  = (~alu_stall_ex_i   |
                                lsu_stack_start_i |
                                fault_dblfault_ex);
          ovl_nxt_exec_state = ovl_idle_state;
        end
        `CORE_ST_LSU : begin
          ovl_exec_state_we  = (~lsu_stall_ex_i   |
                                lsu_stack_start_i |
                                fault_dblfault_ex);
          ovl_nxt_exec_state = ovl_idle_state;
        end
        `CORE_ST_INT : begin
          ovl_exec_state_we  = int_entry_i | int_return_i;
          ovl_nxt_exec_state = ovl_idle_state;
        end
        `CORE_ST_DBG : begin
          ovl_exec_state_we  = ~(nvic_dbg_halt_req_i | lsu_stall_ex_i);
          ovl_nxt_exec_state = ovl_idle_state;
        end
        default : begin
          ovl_exec_state_we  = 1'b0;
          ovl_nxt_exec_state = 3'bxxx;
        end
      endcase
    end

  always @ (posedge hclk or negedge hreset_n)
    if (!hreset_n)
      ovl_exec_state <= `CORE_ST_RST;
    else if (ovl_exec_state_we)
      ovl_exec_state <= ovl_nxt_exec_state;

  assert_never_unknown #(0,3,0,"Invalid state transition - X propogate")
    ovl_opcode_excl(hclk, hreset_n, 1'b1, ovl_exec_state);

  assert_zero_one_hot #(0,2,0,"ALU op and LSU op must be exclusive")
    ovl_statecode_excl(hclk, hreset_n, {((|instr_alu_ctl_de_i[17:13]) |
                                         instr_alu_ctl_de_i[3]),
                                        instr_lsu_ctl_de_i[0]});

  assert_never #(0,0,"ALU stall should only be asserted when the ALU is active")
    ovl_astall_check(hclk, hreset_n, (alu_stall_ex_i &
                                      (ovl_exec_state!=`CORE_ST_ARITH)));

  assert_never #(0,0,"alu_stall_ex/lsu_stall_ex should be exclusive")
    ovl_stall_check(hclk, hreset_n, alu_stall_ex_i & lsu_stall_ex_i);

  assert_never #(0,0,"dbg_halted has been incorrectly formed")
    ovl_dbg_halted_check(hclk, hreset_n, (dbg_halted &
                                          (ovl_exec_state!=`CORE_ST_DBG)));

  assert_never #(0,0,"Tracking terms incorrectly formed against dbg_halted")
    ovl_dbg_halted2_check(hclk, hreset_n,
                          (dbg_halted &
                           (int_stack_op_i | instr_not_bkpt_ex |
                            instr_valid_ex | ~rst_pc_valid_ex)));

  assert_never #(0,0,"instr_valid_ex has been incorrectly formed")
    ovl_instr_valid_check(hclk, hreset_n,
                          (((ovl_exec_state==`CORE_ST_LSU) |
                            (ovl_exec_state==`CORE_ST_ARITH)) &
                           ~instr_valid_ex)                     |
                          (instr_valid_ex & ~instr_not_bkpt_ex) |
                          (instr_valid_ex & dbg_stall)          |
                          ((ovl_exec_state==`CORE_ST_DBG) & instr_valid_ex));

  assert_never #(0,0,"instr_not_bkpt_ex has been incorrectly formed")
    ovl_not_bkpt_check(hclk, hreset_n,
                       (((ovl_exec_state==`CORE_ST_LSU)                        |
                         (ovl_exec_state==`CORE_ST_ARITH)                      |
                         (ovl_exec_state==`CORE_ST_RST)) & ~instr_not_bkpt_ex) |
                       ((ovl_exec_state==`CORE_ST_DBG) &  instr_not_bkpt_ex));

  assert_zero_one_hot #(0,2,0,"Tracking controls should be exclusive")
    ovl_track_excl(hclk, hreset_n,
                   { (~rst_pc_valid_ex | instr_valid_ex | instr_not_bkpt_ex),
                     int_stack_op_i });

  assert_never #(0,0,"svc_stall_ex has been incorrectly formed")
    ovl_svc_stall_check(hclk, hreset_n, (svc_stall_ex &
                                         (int_stack_op_i | ~instr_not_bkpt_ex)));

  assert_never #(0,0,"bkpt_stall_ex has been incorrectly formed")
    ovl_bkpt_stall_check(hclk, hreset_n, ((instr_bkpt_ex | bkpt_stall_ex) &
                                          (int_stack_op_i | instr_not_bkpt_ex)));

  assert_never #(0,0, "drive instr_link_ex only if the current branch is executed")
    ovl_link_evict(hclk, hreset_n, (|instr_link_ex) & ~instr_ccpass_ex_i);

  assert_never #(0,0,"only drive instr_link_ex[1] with instr_link_ex[0]")
    ovl_link_check(hclk, hreset_n, instr_link_ex[1] & ~instr_link_ex[0]);

  assert_next #(0,1,0,0,0,"instr_bkpt_ex must be pulsed")
    ovl_instr_bkpt_pulsed(hclk, hreset_n, instr_bkpt_ex, ~instr_bkpt_ex);

  assert_next #(0,1,0,0,0,"fault_nocopro_ex must be pulsed")
    ovl_fault_nocopro_pulsed(hclk, hreset_n,
                             fault_nocopro_ex, ~fault_nocopro_ex);

  assert_next #(0,1,0,0,0,"fault_fetch_ex must be pulsed")
    ovl_fault_fetch_pulsed(hclk, hreset_n,
                           (|fault_fetch_ex), ~(|fault_fetch_ex));

  assert_next #(0,1,0,0,0,"fault_state_ex must be pulsed")
    ovl_fault_state_pulsed(hclk, hreset_n, fault_state_ex, ~fault_state_ex);

  assert_next #(0,1,0,0,0,"fault_ici_ex must be pulsed")
   ovl_fault_ici_pulsed(hclk, hreset_n, fault_ici_ex, ~fault_ici_ex);

  assert_next #(0,1,0,0,0,"fault_svc_ex must be pulsed")
    ovl_fault_svc_pulsed(hclk, hreset_n, fault_svc_ex, ~fault_svc_ex);

  assert_next #(0,1,0,0,0,"dpu_slp_ctl_ex[1] must be pulsed")
    ovl_wfe_pulsed(hclk, hreset_n, dpu_slp_ctl_ex[1], ~dpu_slp_ctl_ex[1]);

  assert_next #(0,1,0,0,0,"dpu_slp_ctl_ex[0] must be pulsed")
    ovl_wfi_pulsed(hclk, hreset_n, dpu_slp_ctl_ex[0], ~dpu_slp_ctl_ex[0]);

  assert_next #(0,1,0,0,0,"fault_undef_ex must be pulsed")
    ovl_undef_pulsed(hclk, hreset_n, fault_undef_ex, ~fault_undef_ex);

  assert_next #(0,1,0,0,0,"instr_link_ex must be pulsed")
    ovl_link_pulsed(hclk, hreset_n, (|instr_link_ex), ~(|instr_link_ex));

  assert_never #(0,0,"pflush and inc_pc must be mutually exclusive")
    ovl_evict_incpc_check(hclk, hreset_n,
                          ((|instr_br_pflush_ex[1:0]) & rf_inc_pc_ex));

  assert_zero_one_hot #(0,5,0,"instr_msr_ctl_ex must be exclusive")
    ovl_msr_ctl_excl(hclk, hreset_n, instr_msr_ctl_ex);

  assert_never #(0,0,"rf_inc_pc_ex and rf_pc_ctl_ex do not match")
    ovl_rf_pc_ctl_check(hclk, hreset_n, ((rf_inc_pc_ex & ~rf_pc_ctl0_ex) &
                                         ~(rf_pc_ctl0_we & instr_valid_de_i)));

  assert_never #(0,0,"instr_wfi_ex and instr_wfe_ex must be exclusive")
    ovl_wfi_wfe_excl(hclk, hreset_n, instr_wfi_ex & instr_wfe_ex);

  assert_never #(0,0,"instr_advance_ex cannot be set during interrupt processing")
    ovl_instr_advance_ex_check(hclk, hreset_n, int_stack_op_i & instr_advance_ex);

  assert_next #(0,1,0,0,0,"msr_stall_ex must be pulsed")
    ovl_msr_stall_ex_pulsed(hclk, hreset_n,
                            (msr_stall_ex & ~nvic_int_invoke_i),
                            ~(msr_stall_ex & ~nvic_int_invoke_i));

  assert_next #(0,1,0,0,0,"msr_stall_reg must be pulsed")
    ovl_msr_stall_reg_pulsed(hclk, hreset_n, msr_stall_reg, ~msr_stall_reg);

  assert_never #(0,0,"rf_sp_sel_ex is incorrectly formed")
    ovl_rf_sp_sel_ex_check(hclk, hreset_n,
                           (nxt_process_sp_ex & ~instr_msr_ctl_ex[4] &
                            ~int_isr_exit_ex & ~dbg_ctrl_wr_ex_i));

  assert_never #(0,0,"rf_sp_sel_ex controls must be exclusive")
    ovl_sp_sel_ex_check2(hclk, hreset_n, int_isr_exit_ex & dbg_ctrl_wr_ex_i);

  assert_never #(0,0,"FAULTMASK cannot be set in HardFault or NMI")
    ovl_fmask_check(hclk, hreset_n, (dpu_fmask_we & dpu_fmask_ex &
                                     (|nvic_int_in_nmihf_i[1:0]) & ~dbg_ctrl_wr_ex_i &
                                     ~(int_vector_fault_i & ~rst_pc_valid_ex)));

  assert_zero_one_hot #(0,3,0,
    "RF A enable from LSU, ALU & decode should be exclusive")
    ovl_rd_a_en_excl(hclk, hreset_n, { lsu_rf_rd_a_en_ex_i,
                                       alu_rf_rd_a_en_ex_i,
                                       instr_rf_rd_a_en_de_i});

  assert_zero_one_hot #(0,4,0,
    "RF D enable from ALU, LSU, fetch and FPU should be exclusive")
    ovl_wr_d_en_excl(hclk, hreset_n, { alu_rf_wr_d_en_ex_i,
                                       lsu_rf_wr_d_en_ex_i,
                                       rf_wr_d_en_fe_i,
                                       fpu_rf_wr_en_ex_i});

  assert_next #(0,1,0,0,0,"instr_detect_exit_ex must be pulsed")
    ovl_detect_exit_pulsed(hclk, hreset_n,
                           instr_detect_exit_ex, ~instr_detect_exit_ex);

  assert_never #(0,0,
    "lsu_rf_rd_a_en_ex request cannot be set without lsu_rf_rd_a_en_fast_ex")
    ovl_lsu_rd_a_en_check(hclk, hreset_n, (lsu_rf_rd_a_en_ex_i &
                                           ~lsu_rf_rd_a_en_fast_ex_i));

  assert_never #(0,0, "LSU debug control set must only be asserted when halted")
    ovl_dbg_ctrl_check(hclk, hreset_n, dbg_ctrl_wr_ex_i & ~dbg_halted);

  assert_never #(0,0,0,"D write datas should be exclusive")
    ovl_d_data_excl(hclk, hreset_n, ((|e_rf_wr_d_data_ex_i) &
                                     (|rf_wr_d_data_erly_ex)));

  assert_never #(0,0,0,"Z write datas should be exclusive")
    ovl_z_data_excl(hclk, hreset_n, ((|lsu_rf_wr_z_data_ex_i) &
                                     (|e_rf_wr_z_data_ex_i)));

`endif

`include "cm3_dpu_undefs.vp"

endmodule
