`include "cm3_nvic_defs.vp"

module cm3_nvic_tree
  (// Inputs
  int_state_i, int_lvl_i,
  int_num_o, int_hi_lvl_o
  );

  parameter LVL_WIDTH       = 3;                    // Interrupt priority width
  parameter MAX_WIDTH       = `max_ints * LVL_WIDTH;

  input [`max_ints-1:0]     int_state_i;
  input [MAX_WIDTH-1:0]     int_lvl_i;

  output [7:0]              int_num_o;
  output [LVL_WIDTH-1:0]    int_hi_lvl_o;

  wire [LVL_WIDTH-1:0]      lvl___1_to___0;
  wire [1:0]                num___1_to___0;
  wire [LVL_WIDTH-1:0]      lvl___3_to___2;
  wire [1:0]                num___3_to___2;
  wire [LVL_WIDTH-1:0]      lvl___5_to___4;
  wire [1:0]                num___5_to___4;
  wire [LVL_WIDTH-1:0]      lvl___7_to___6;
  wire [1:0]                num___7_to___6;
  wire [LVL_WIDTH-1:0]      lvl___9_to___8;
  wire [1:0]                num___9_to___8;
  wire [LVL_WIDTH-1:0]      lvl__11_to__10;
  wire [1:0]                num__11_to__10;
  wire [LVL_WIDTH-1:0]      lvl__13_to__12;
  wire [1:0]                num__13_to__12;
  wire [LVL_WIDTH-1:0]      lvl__15_to__14;
  wire [1:0]                num__15_to__14;
  wire [LVL_WIDTH-1:0]      lvl__17_to__16;
  wire [1:0]                num__17_to__16;
  wire [LVL_WIDTH-1:0]      lvl__19_to__18;
  wire [1:0]                num__19_to__18;
  wire [LVL_WIDTH-1:0]      lvl__21_to__20;
  wire [1:0]                num__21_to__20;
  wire [LVL_WIDTH-1:0]      lvl__23_to__22;
  wire [1:0]                num__23_to__22;
  wire [LVL_WIDTH-1:0]      lvl__25_to__24;
  wire [1:0]                num__25_to__24;
  wire [LVL_WIDTH-1:0]      lvl__27_to__26;
  wire [1:0]                num__27_to__26;
  wire [LVL_WIDTH-1:0]      lvl__29_to__28;
  wire [1:0]                num__29_to__28;
  wire [LVL_WIDTH-1:0]      lvl__31_to__30;
  wire [1:0]                num__31_to__30;
  wire [LVL_WIDTH-1:0]      lvl__33_to__32;
  wire [1:0]                num__33_to__32;
  wire [LVL_WIDTH-1:0]      lvl__35_to__34;
  wire [1:0]                num__35_to__34;
  wire [LVL_WIDTH-1:0]      lvl__37_to__36;
  wire [1:0]                num__37_to__36;
  wire [LVL_WIDTH-1:0]      lvl__39_to__38;
  wire [1:0]                num__39_to__38;
  wire [LVL_WIDTH-1:0]      lvl__41_to__40;
  wire [1:0]                num__41_to__40;
  wire [LVL_WIDTH-1:0]      lvl__43_to__42;
  wire [1:0]                num__43_to__42;
  wire [LVL_WIDTH-1:0]      lvl__45_to__44;
  wire [1:0]                num__45_to__44;
  wire [LVL_WIDTH-1:0]      lvl__47_to__46;
  wire [1:0]                num__47_to__46;
  wire [LVL_WIDTH-1:0]      lvl__49_to__48;
  wire [1:0]                num__49_to__48;
  wire [LVL_WIDTH-1:0]      lvl__51_to__50;
  wire [1:0]                num__51_to__50;
  wire [LVL_WIDTH-1:0]      lvl__53_to__52;
  wire [1:0]                num__53_to__52;
  wire [LVL_WIDTH-1:0]      lvl__55_to__54;
  wire [1:0]                num__55_to__54;
  wire [LVL_WIDTH-1:0]      lvl__57_to__56;
  wire [1:0]                num__57_to__56;
  wire [LVL_WIDTH-1:0]      lvl__59_to__58;
  wire [1:0]                num__59_to__58;
  wire [LVL_WIDTH-1:0]      lvl__61_to__60;
  wire [1:0]                num__61_to__60;
  wire [LVL_WIDTH-1:0]      lvl__63_to__62;
  wire [1:0]                num__63_to__62;
  wire [LVL_WIDTH-1:0]      lvl__65_to__64;
  wire [1:0]                num__65_to__64;
  wire [LVL_WIDTH-1:0]      lvl__67_to__66;
  wire [1:0]                num__67_to__66;
  wire [LVL_WIDTH-1:0]      lvl__69_to__68;
  wire [1:0]                num__69_to__68;
  wire [LVL_WIDTH-1:0]      lvl__71_to__70;
  wire [1:0]                num__71_to__70;
  wire [LVL_WIDTH-1:0]      lvl__73_to__72;
  wire [1:0]                num__73_to__72;
  wire [LVL_WIDTH-1:0]      lvl__75_to__74;
  wire [1:0]                num__75_to__74;
  wire [LVL_WIDTH-1:0]      lvl__77_to__76;
  wire [1:0]                num__77_to__76;
  wire [LVL_WIDTH-1:0]      lvl__79_to__78;
  wire [1:0]                num__79_to__78;
  wire [LVL_WIDTH-1:0]      lvl__81_to__80;
  wire [1:0]                num__81_to__80;
  wire [LVL_WIDTH-1:0]      lvl__83_to__82;
  wire [1:0]                num__83_to__82;
  wire [LVL_WIDTH-1:0]      lvl__85_to__84;
  wire [1:0]                num__85_to__84;
  wire [LVL_WIDTH-1:0]      lvl__87_to__86;
  wire [1:0]                num__87_to__86;
  wire [LVL_WIDTH-1:0]      lvl__89_to__88;
  wire [1:0]                num__89_to__88;
  wire [LVL_WIDTH-1:0]      lvl__91_to__90;
  wire [1:0]                num__91_to__90;
  wire [LVL_WIDTH-1:0]      lvl__93_to__92;
  wire [1:0]                num__93_to__92;
  wire [LVL_WIDTH-1:0]      lvl__95_to__94;
  wire [1:0]                num__95_to__94;
  wire [LVL_WIDTH-1:0]      lvl__97_to__96;
  wire [1:0]                num__97_to__96;
  wire [LVL_WIDTH-1:0]      lvl__99_to__98;
  wire [1:0]                num__99_to__98;
  wire [LVL_WIDTH-1:0]      lvl_101_to_100;
  wire [1:0]                num_101_to_100;
  wire [LVL_WIDTH-1:0]      lvl_103_to_102;
  wire [1:0]                num_103_to_102;
  wire [LVL_WIDTH-1:0]      lvl_105_to_104;
  wire [1:0]                num_105_to_104;
  wire [LVL_WIDTH-1:0]      lvl_107_to_106;
  wire [1:0]                num_107_to_106;
  wire [LVL_WIDTH-1:0]      lvl_109_to_108;
  wire [1:0]                num_109_to_108;
  wire [LVL_WIDTH-1:0]      lvl_111_to_110;
  wire [1:0]                num_111_to_110;
  wire [LVL_WIDTH-1:0]      lvl_113_to_112;
  wire [1:0]                num_113_to_112;
  wire [LVL_WIDTH-1:0]      lvl_115_to_114;
  wire [1:0]                num_115_to_114;
  wire [LVL_WIDTH-1:0]      lvl_117_to_116;
  wire [1:0]                num_117_to_116;
  wire [LVL_WIDTH-1:0]      lvl_119_to_118;
  wire [1:0]                num_119_to_118;
  wire [LVL_WIDTH-1:0]      lvl_121_to_120;
  wire [1:0]                num_121_to_120;
  wire [LVL_WIDTH-1:0]      lvl_123_to_122;
  wire [1:0]                num_123_to_122;
  wire [LVL_WIDTH-1:0]      lvl_125_to_124;
  wire [1:0]                num_125_to_124;
  wire [LVL_WIDTH-1:0]      lvl_127_to_126;
  wire [1:0]                num_127_to_126;
  wire [LVL_WIDTH-1:0]      lvl_129_to_128;
  wire [1:0]                num_129_to_128;
  wire [LVL_WIDTH-1:0]      lvl_131_to_130;
  wire [1:0]                num_131_to_130;
  wire [LVL_WIDTH-1:0]      lvl_133_to_132;
  wire [1:0]                num_133_to_132;
  wire [LVL_WIDTH-1:0]      lvl_135_to_134;
  wire [1:0]                num_135_to_134;
  wire [LVL_WIDTH-1:0]      lvl_137_to_136;
  wire [1:0]                num_137_to_136;
  wire [LVL_WIDTH-1:0]      lvl_139_to_138;
  wire [1:0]                num_139_to_138;
  wire [LVL_WIDTH-1:0]      lvl_141_to_140;
  wire [1:0]                num_141_to_140;
  wire [LVL_WIDTH-1:0]      lvl_143_to_142;
  wire [1:0]                num_143_to_142;
  wire [LVL_WIDTH-1:0]      lvl_145_to_144;
  wire [1:0]                num_145_to_144;
  wire [LVL_WIDTH-1:0]      lvl_147_to_146;
  wire [1:0]                num_147_to_146;
  wire [LVL_WIDTH-1:0]      lvl_149_to_148;
  wire [1:0]                num_149_to_148;
  wire [LVL_WIDTH-1:0]      lvl_151_to_150;
  wire [1:0]                num_151_to_150;
  wire [LVL_WIDTH-1:0]      lvl_153_to_152;
  wire [1:0]                num_153_to_152;
  wire [LVL_WIDTH-1:0]      lvl_155_to_154;
  wire [1:0]                num_155_to_154;
  wire [LVL_WIDTH-1:0]      lvl_157_to_156;
  wire [1:0]                num_157_to_156;
  wire [LVL_WIDTH-1:0]      lvl_159_to_158;
  wire [1:0]                num_159_to_158;
  wire [LVL_WIDTH-1:0]      lvl_161_to_160;
  wire [1:0]                num_161_to_160;
  wire [LVL_WIDTH-1:0]      lvl_163_to_162;
  wire [1:0]                num_163_to_162;
  wire [LVL_WIDTH-1:0]      lvl_165_to_164;
  wire [1:0]                num_165_to_164;
  wire [LVL_WIDTH-1:0]      lvl_167_to_166;
  wire [1:0]                num_167_to_166;
  wire [LVL_WIDTH-1:0]      lvl_169_to_168;
  wire [1:0]                num_169_to_168;
  wire [LVL_WIDTH-1:0]      lvl_171_to_170;
  wire [1:0]                num_171_to_170;
  wire [LVL_WIDTH-1:0]      lvl_173_to_172;
  wire [1:0]                num_173_to_172;
  wire [LVL_WIDTH-1:0]      lvl_175_to_174;
  wire [1:0]                num_175_to_174;
  wire [LVL_WIDTH-1:0]      lvl_177_to_176;
  wire [1:0]                num_177_to_176;
  wire [LVL_WIDTH-1:0]      lvl_179_to_178;
  wire [1:0]                num_179_to_178;
  wire [LVL_WIDTH-1:0]      lvl_181_to_180;
  wire [1:0]                num_181_to_180;
  wire [LVL_WIDTH-1:0]      lvl_183_to_182;
  wire [1:0]                num_183_to_182;
  wire [LVL_WIDTH-1:0]      lvl_185_to_184;
  wire [1:0]                num_185_to_184;
  wire [LVL_WIDTH-1:0]      lvl_187_to_186;
  wire [1:0]                num_187_to_186;
  wire [LVL_WIDTH-1:0]      lvl_189_to_188;
  wire [1:0]                num_189_to_188;
  wire [LVL_WIDTH-1:0]      lvl_191_to_190;
  wire [1:0]                num_191_to_190;
  wire [LVL_WIDTH-1:0]      lvl_193_to_192;
  wire [1:0]                num_193_to_192;
  wire [LVL_WIDTH-1:0]      lvl_195_to_194;
  wire [1:0]                num_195_to_194;
  wire [LVL_WIDTH-1:0]      lvl_197_to_196;
  wire [1:0]                num_197_to_196;
  wire [LVL_WIDTH-1:0]      lvl_199_to_198;
  wire [1:0]                num_199_to_198;
  wire [LVL_WIDTH-1:0]      lvl_201_to_200;
  wire [1:0]                num_201_to_200;
  wire [LVL_WIDTH-1:0]      lvl_203_to_202;
  wire [1:0]                num_203_to_202;
  wire [LVL_WIDTH-1:0]      lvl_205_to_204;
  wire [1:0]                num_205_to_204;
  wire [LVL_WIDTH-1:0]      lvl_207_to_206;
  wire [1:0]                num_207_to_206;
  wire [LVL_WIDTH-1:0]      lvl_209_to_208;
  wire [1:0]                num_209_to_208;
  wire [LVL_WIDTH-1:0]      lvl_211_to_210;
  wire [1:0]                num_211_to_210;
  wire [LVL_WIDTH-1:0]      lvl_213_to_212;
  wire [1:0]                num_213_to_212;
  wire [LVL_WIDTH-1:0]      lvl_215_to_214;
  wire [1:0]                num_215_to_214;
  wire [LVL_WIDTH-1:0]      lvl_217_to_216;
  wire [1:0]                num_217_to_216;
  wire [LVL_WIDTH-1:0]      lvl_219_to_218;
  wire [1:0]                num_219_to_218;
  wire [LVL_WIDTH-1:0]      lvl_221_to_220;
  wire [1:0]                num_221_to_220;
  wire [LVL_WIDTH-1:0]      lvl_223_to_222;
  wire [1:0]                num_223_to_222;
  wire [LVL_WIDTH-1:0]      lvl_225_to_224;
  wire [1:0]                num_225_to_224;
  wire [LVL_WIDTH-1:0]      lvl_227_to_226;
  wire [1:0]                num_227_to_226;
  wire [LVL_WIDTH-1:0]      lvl_229_to_228;
  wire [1:0]                num_229_to_228;
  wire [LVL_WIDTH-1:0]      lvl_231_to_230;
  wire [1:0]                num_231_to_230;
  wire [LVL_WIDTH-1:0]      lvl_233_to_232;
  wire [1:0]                num_233_to_232;
  wire [LVL_WIDTH-1:0]      lvl_235_to_234;
  wire [1:0]                num_235_to_234;
  wire [LVL_WIDTH-1:0]      lvl_237_to_236;
  wire [1:0]                num_237_to_236;
  wire [LVL_WIDTH-1:0]      lvl_239_to_238;
  wire [1:0]                num_239_to_238;
  wire [LVL_WIDTH-1:0]      lvl_241_to_240;
  wire [1:0]                num_241_to_240;
  wire [LVL_WIDTH-1:0]      lvl_243_to_242;
  wire [1:0]                num_243_to_242;
  wire [LVL_WIDTH-1:0]      lvl_245_to_244;
  wire [1:0]                num_245_to_244;
  wire [LVL_WIDTH-1:0]      lvl_247_to_246;
  wire [1:0]                num_247_to_246;
  wire [LVL_WIDTH-1:0]      lvl_249_to_248;
  wire [1:0]                num_249_to_248;
  wire [LVL_WIDTH-1:0]      lvl_251_to_250;
  wire [1:0]                num_251_to_250;
  wire [LVL_WIDTH-1:0]      lvl_253_to_252;
  wire [1:0]                num_253_to_252;
  wire [LVL_WIDTH-1:0]      lvl_255_to_254;
  wire [1:0]                num_255_to_254;
  wire [LVL_WIDTH-1:0]      lvl___3_to___0;
  wire [2:0]                num___3_to___0;
  wire [LVL_WIDTH-1:0]      lvl___7_to___4;
  wire [2:0]                num___7_to___4;
  wire [LVL_WIDTH-1:0]      lvl__11_to___8;
  wire [2:0]                num__11_to___8;
  wire [LVL_WIDTH-1:0]      lvl__15_to__12;
  wire [2:0]                num__15_to__12;
  wire [LVL_WIDTH-1:0]      lvl__19_to__16;
  wire [2:0]                num__19_to__16;
  wire [LVL_WIDTH-1:0]      lvl__23_to__20;
  wire [2:0]                num__23_to__20;
  wire [LVL_WIDTH-1:0]      lvl__27_to__24;
  wire [2:0]                num__27_to__24;
  wire [LVL_WIDTH-1:0]      lvl__31_to__28;
  wire [2:0]                num__31_to__28;
  wire [LVL_WIDTH-1:0]      lvl__35_to__32;
  wire [2:0]                num__35_to__32;
  wire [LVL_WIDTH-1:0]      lvl__39_to__36;
  wire [2:0]                num__39_to__36;
  wire [LVL_WIDTH-1:0]      lvl__43_to__40;
  wire [2:0]                num__43_to__40;
  wire [LVL_WIDTH-1:0]      lvl__47_to__44;
  wire [2:0]                num__47_to__44;
  wire [LVL_WIDTH-1:0]      lvl__51_to__48;
  wire [2:0]                num__51_to__48;
  wire [LVL_WIDTH-1:0]      lvl__55_to__52;
  wire [2:0]                num__55_to__52;
  wire [LVL_WIDTH-1:0]      lvl__59_to__56;
  wire [2:0]                num__59_to__56;
  wire [LVL_WIDTH-1:0]      lvl__63_to__60;
  wire [2:0]                num__63_to__60;
  wire [LVL_WIDTH-1:0]      lvl__67_to__64;
  wire [2:0]                num__67_to__64;
  wire [LVL_WIDTH-1:0]      lvl__71_to__68;
  wire [2:0]                num__71_to__68;
  wire [LVL_WIDTH-1:0]      lvl__75_to__72;
  wire [2:0]                num__75_to__72;
  wire [LVL_WIDTH-1:0]      lvl__79_to__76;
  wire [2:0]                num__79_to__76;
  wire [LVL_WIDTH-1:0]      lvl__83_to__80;
  wire [2:0]                num__83_to__80;
  wire [LVL_WIDTH-1:0]      lvl__87_to__84;
  wire [2:0]                num__87_to__84;
  wire [LVL_WIDTH-1:0]      lvl__91_to__88;
  wire [2:0]                num__91_to__88;
  wire [LVL_WIDTH-1:0]      lvl__95_to__92;
  wire [2:0]                num__95_to__92;
  wire [LVL_WIDTH-1:0]      lvl__99_to__96;
  wire [2:0]                num__99_to__96;
  wire [LVL_WIDTH-1:0]      lvl_103_to_100;
  wire [2:0]                num_103_to_100;
  wire [LVL_WIDTH-1:0]      lvl_107_to_104;
  wire [2:0]                num_107_to_104;
  wire [LVL_WIDTH-1:0]      lvl_111_to_108;
  wire [2:0]                num_111_to_108;
  wire [LVL_WIDTH-1:0]      lvl_115_to_112;
  wire [2:0]                num_115_to_112;
  wire [LVL_WIDTH-1:0]      lvl_119_to_116;
  wire [2:0]                num_119_to_116;
  wire [LVL_WIDTH-1:0]      lvl_123_to_120;
  wire [2:0]                num_123_to_120;
  wire [LVL_WIDTH-1:0]      lvl_127_to_124;
  wire [2:0]                num_127_to_124;
  wire [LVL_WIDTH-1:0]      lvl_131_to_128;
  wire [2:0]                num_131_to_128;
  wire [LVL_WIDTH-1:0]      lvl_135_to_132;
  wire [2:0]                num_135_to_132;
  wire [LVL_WIDTH-1:0]      lvl_139_to_136;
  wire [2:0]                num_139_to_136;
  wire [LVL_WIDTH-1:0]      lvl_143_to_140;
  wire [2:0]                num_143_to_140;
  wire [LVL_WIDTH-1:0]      lvl_147_to_144;
  wire [2:0]                num_147_to_144;
  wire [LVL_WIDTH-1:0]      lvl_151_to_148;
  wire [2:0]                num_151_to_148;
  wire [LVL_WIDTH-1:0]      lvl_155_to_152;
  wire [2:0]                num_155_to_152;
  wire [LVL_WIDTH-1:0]      lvl_159_to_156;
  wire [2:0]                num_159_to_156;
  wire [LVL_WIDTH-1:0]      lvl_163_to_160;
  wire [2:0]                num_163_to_160;
  wire [LVL_WIDTH-1:0]      lvl_167_to_164;
  wire [2:0]                num_167_to_164;
  wire [LVL_WIDTH-1:0]      lvl_171_to_168;
  wire [2:0]                num_171_to_168;
  wire [LVL_WIDTH-1:0]      lvl_175_to_172;
  wire [2:0]                num_175_to_172;
  wire [LVL_WIDTH-1:0]      lvl_179_to_176;
  wire [2:0]                num_179_to_176;
  wire [LVL_WIDTH-1:0]      lvl_183_to_180;
  wire [2:0]                num_183_to_180;
  wire [LVL_WIDTH-1:0]      lvl_187_to_184;
  wire [2:0]                num_187_to_184;
  wire [LVL_WIDTH-1:0]      lvl_191_to_188;
  wire [2:0]                num_191_to_188;
  wire [LVL_WIDTH-1:0]      lvl_195_to_192;
  wire [2:0]                num_195_to_192;
  wire [LVL_WIDTH-1:0]      lvl_199_to_196;
  wire [2:0]                num_199_to_196;
  wire [LVL_WIDTH-1:0]      lvl_203_to_200;
  wire [2:0]                num_203_to_200;
  wire [LVL_WIDTH-1:0]      lvl_207_to_204;
  wire [2:0]                num_207_to_204;
  wire [LVL_WIDTH-1:0]      lvl_211_to_208;
  wire [2:0]                num_211_to_208;
  wire [LVL_WIDTH-1:0]      lvl_215_to_212;
  wire [2:0]                num_215_to_212;
  wire [LVL_WIDTH-1:0]      lvl_219_to_216;
  wire [2:0]                num_219_to_216;
  wire [LVL_WIDTH-1:0]      lvl_223_to_220;
  wire [2:0]                num_223_to_220;
  wire [LVL_WIDTH-1:0]      lvl_227_to_224;
  wire [2:0]                num_227_to_224;
  wire [LVL_WIDTH-1:0]      lvl_231_to_228;
  wire [2:0]                num_231_to_228;
  wire [LVL_WIDTH-1:0]      lvl_235_to_232;
  wire [2:0]                num_235_to_232;
  wire [LVL_WIDTH-1:0]      lvl_239_to_236;
  wire [2:0]                num_239_to_236;
  wire [LVL_WIDTH-1:0]      lvl_243_to_240;
  wire [2:0]                num_243_to_240;
  wire [LVL_WIDTH-1:0]      lvl_247_to_244;
  wire [2:0]                num_247_to_244;
  wire [LVL_WIDTH-1:0]      lvl_251_to_248;
  wire [2:0]                num_251_to_248;
  wire [LVL_WIDTH-1:0]      lvl_255_to_252;
  wire [2:0]                num_255_to_252;
  wire [LVL_WIDTH-1:0]      lvl___7_to___0;
  wire [3:0]                num___7_to___0;
  wire [LVL_WIDTH-1:0]      lvl__15_to___8;
  wire [3:0]                num__15_to___8;
  wire [LVL_WIDTH-1:0]      lvl__23_to__16;
  wire [3:0]                num__23_to__16;
  wire [LVL_WIDTH-1:0]      lvl__31_to__24;
  wire [3:0]                num__31_to__24;
  wire [LVL_WIDTH-1:0]      lvl__39_to__32;
  wire [3:0]                num__39_to__32;
  wire [LVL_WIDTH-1:0]      lvl__47_to__40;
  wire [3:0]                num__47_to__40;
  wire [LVL_WIDTH-1:0]      lvl__55_to__48;
  wire [3:0]                num__55_to__48;
  wire [LVL_WIDTH-1:0]      lvl__63_to__56;
  wire [3:0]                num__63_to__56;
  wire [LVL_WIDTH-1:0]      lvl__71_to__64;
  wire [3:0]                num__71_to__64;
  wire [LVL_WIDTH-1:0]      lvl__79_to__72;
  wire [3:0]                num__79_to__72;
  wire [LVL_WIDTH-1:0]      lvl__87_to__80;
  wire [3:0]                num__87_to__80;
  wire [LVL_WIDTH-1:0]      lvl__95_to__88;
  wire [3:0]                num__95_to__88;
  wire [LVL_WIDTH-1:0]      lvl_103_to__96;
  wire [3:0]                num_103_to__96;
  wire [LVL_WIDTH-1:0]      lvl_111_to_104;
  wire [3:0]                num_111_to_104;
  wire [LVL_WIDTH-1:0]      lvl_119_to_112;
  wire [3:0]                num_119_to_112;
  wire [LVL_WIDTH-1:0]      lvl_127_to_120;
  wire [3:0]                num_127_to_120;
  wire [LVL_WIDTH-1:0]      lvl_135_to_128;
  wire [3:0]                num_135_to_128;
  wire [LVL_WIDTH-1:0]      lvl_143_to_136;
  wire [3:0]                num_143_to_136;
  wire [LVL_WIDTH-1:0]      lvl_151_to_144;
  wire [3:0]                num_151_to_144;
  wire [LVL_WIDTH-1:0]      lvl_159_to_152;
  wire [3:0]                num_159_to_152;
  wire [LVL_WIDTH-1:0]      lvl_167_to_160;
  wire [3:0]                num_167_to_160;
  wire [LVL_WIDTH-1:0]      lvl_175_to_168;
  wire [3:0]                num_175_to_168;
  wire [LVL_WIDTH-1:0]      lvl_183_to_176;
  wire [3:0]                num_183_to_176;
  wire [LVL_WIDTH-1:0]      lvl_191_to_184;
  wire [3:0]                num_191_to_184;
  wire [LVL_WIDTH-1:0]      lvl_199_to_192;
  wire [3:0]                num_199_to_192;
  wire [LVL_WIDTH-1:0]      lvl_207_to_200;
  wire [3:0]                num_207_to_200;
  wire [LVL_WIDTH-1:0]      lvl_215_to_208;
  wire [3:0]                num_215_to_208;
  wire [LVL_WIDTH-1:0]      lvl_223_to_216;
  wire [3:0]                num_223_to_216;
  wire [LVL_WIDTH-1:0]      lvl_231_to_224;
  wire [3:0]                num_231_to_224;
  wire [LVL_WIDTH-1:0]      lvl_239_to_232;
  wire [3:0]                num_239_to_232;
  wire [LVL_WIDTH-1:0]      lvl_247_to_240;
  wire [3:0]                num_247_to_240;
  wire [LVL_WIDTH-1:0]      lvl_255_to_248;
  wire [3:0]                num_255_to_248;
  wire [LVL_WIDTH-1:0]      lvl__15_to___0;
  wire [4:0]                num__15_to___0;
  wire [LVL_WIDTH-1:0]      lvl__31_to__16;
  wire [4:0]                num__31_to__16;
  wire [LVL_WIDTH-1:0]      lvl__47_to__32;
  wire [4:0]                num__47_to__32;
  wire [LVL_WIDTH-1:0]      lvl__63_to__48;
  wire [4:0]                num__63_to__48;
  wire [LVL_WIDTH-1:0]      lvl__79_to__64;
  wire [4:0]                num__79_to__64;
  wire [LVL_WIDTH-1:0]      lvl__95_to__80;
  wire [4:0]                num__95_to__80;
  wire [LVL_WIDTH-1:0]      lvl_111_to__96;
  wire [4:0]                num_111_to__96;
  wire [LVL_WIDTH-1:0]      lvl_127_to_112;
  wire [4:0]                num_127_to_112;
  wire [LVL_WIDTH-1:0]      lvl_143_to_128;
  wire [4:0]                num_143_to_128;
  wire [LVL_WIDTH-1:0]      lvl_159_to_144;
  wire [4:0]                num_159_to_144;
  wire [LVL_WIDTH-1:0]      lvl_175_to_160;
  wire [4:0]                num_175_to_160;
  wire [LVL_WIDTH-1:0]      lvl_191_to_176;
  wire [4:0]                num_191_to_176;
  wire [LVL_WIDTH-1:0]      lvl_207_to_192;
  wire [4:0]                num_207_to_192;
  wire [LVL_WIDTH-1:0]      lvl_223_to_208;
  wire [4:0]                num_223_to_208;
  wire [LVL_WIDTH-1:0]      lvl_239_to_224;
  wire [4:0]                num_239_to_224;
  wire [LVL_WIDTH-1:0]      lvl_255_to_240;
  wire [4:0]                num_255_to_240;
  wire [LVL_WIDTH-1:0]      lvl__31_to___0;
  wire [5:0]                num__31_to___0;
  wire [LVL_WIDTH-1:0]      lvl__63_to__32;
  wire [5:0]                num__63_to__32;
  wire [LVL_WIDTH-1:0]      lvl__95_to__64;
  wire [5:0]                num__95_to__64;
  wire [LVL_WIDTH-1:0]      lvl_127_to__96;
  wire [5:0]                num_127_to__96;
  wire [LVL_WIDTH-1:0]      lvl_159_to_128;
  wire [5:0]                num_159_to_128;
  wire [LVL_WIDTH-1:0]      lvl_191_to_160;
  wire [5:0]                num_191_to_160;
  wire [LVL_WIDTH-1:0]      lvl_223_to_192;
  wire [5:0]                num_223_to_192;
  wire [LVL_WIDTH-1:0]      lvl_255_to_224;
  wire [5:0]                num_255_to_224;
  wire [LVL_WIDTH-1:0]      lvl__63_to___0;
  wire [6:0]                num__63_to___0;
  wire [LVL_WIDTH-1:0]      lvl_127_to__64;
  wire [6:0]                num_127_to__64;
  wire [LVL_WIDTH-1:0]      lvl_191_to_128;
  wire [6:0]                num_191_to_128;
  wire [LVL_WIDTH-1:0]      lvl_255_to_192;
  wire [6:0]                num_255_to_192;
  wire [LVL_WIDTH-1:0]      lvl_127_to___0;
  wire [7:0]                num_127_to___0;
  wire [LVL_WIDTH-1:0]      lvl_255_to_128;
  wire [7:0]                num_255_to_128;
  wire [LVL_WIDTH-1:0]      lvl_255_to___0;
  wire [8:0]                num_255_to___0;

  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell___1_to___0 (int_lvl_i[(  2*LVL_WIDTH)-1:  1*LVL_WIDTH], int_lvl_i[(  1*LVL_WIDTH)-1:  0*LVL_WIDTH], int_state_i[  1], int_state_i[  0], lvl___1_to___0, num___1_to___0);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell___3_to___2 (int_lvl_i[(  4*LVL_WIDTH)-1:  3*LVL_WIDTH], int_lvl_i[(  3*LVL_WIDTH)-1:  2*LVL_WIDTH], int_state_i[  3], int_state_i[  2], lvl___3_to___2, num___3_to___2);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell___5_to___4 (int_lvl_i[(  6*LVL_WIDTH)-1:  5*LVL_WIDTH], int_lvl_i[(  5*LVL_WIDTH)-1:  4*LVL_WIDTH], int_state_i[  5], int_state_i[  4], lvl___5_to___4, num___5_to___4);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell___7_to___6 (int_lvl_i[(  8*LVL_WIDTH)-1:  7*LVL_WIDTH], int_lvl_i[(  7*LVL_WIDTH)-1:  6*LVL_WIDTH], int_state_i[  7], int_state_i[  6], lvl___7_to___6, num___7_to___6);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell___9_to___8 (int_lvl_i[( 10*LVL_WIDTH)-1:  9*LVL_WIDTH], int_lvl_i[(  9*LVL_WIDTH)-1:  8*LVL_WIDTH], int_state_i[  9], int_state_i[  8], lvl___9_to___8, num___9_to___8);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell__11_to__10 (int_lvl_i[( 12*LVL_WIDTH)-1: 11*LVL_WIDTH], int_lvl_i[( 11*LVL_WIDTH)-1: 10*LVL_WIDTH], int_state_i[ 11], int_state_i[ 10], lvl__11_to__10, num__11_to__10);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell__13_to__12 (int_lvl_i[( 14*LVL_WIDTH)-1: 13*LVL_WIDTH], int_lvl_i[( 13*LVL_WIDTH)-1: 12*LVL_WIDTH], int_state_i[ 13], int_state_i[ 12], lvl__13_to__12, num__13_to__12);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell__15_to__14 (int_lvl_i[( 16*LVL_WIDTH)-1: 15*LVL_WIDTH], int_lvl_i[( 15*LVL_WIDTH)-1: 14*LVL_WIDTH], int_state_i[ 15], int_state_i[ 14], lvl__15_to__14, num__15_to__14);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell__17_to__16 (int_lvl_i[( 18*LVL_WIDTH)-1: 17*LVL_WIDTH], int_lvl_i[( 17*LVL_WIDTH)-1: 16*LVL_WIDTH], int_state_i[ 17], int_state_i[ 16], lvl__17_to__16, num__17_to__16);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell__19_to__18 (int_lvl_i[( 20*LVL_WIDTH)-1: 19*LVL_WIDTH], int_lvl_i[( 19*LVL_WIDTH)-1: 18*LVL_WIDTH], int_state_i[ 19], int_state_i[ 18], lvl__19_to__18, num__19_to__18);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell__21_to__20 (int_lvl_i[( 22*LVL_WIDTH)-1: 21*LVL_WIDTH], int_lvl_i[( 21*LVL_WIDTH)-1: 20*LVL_WIDTH], int_state_i[ 21], int_state_i[ 20], lvl__21_to__20, num__21_to__20);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell__23_to__22 (int_lvl_i[( 24*LVL_WIDTH)-1: 23*LVL_WIDTH], int_lvl_i[( 23*LVL_WIDTH)-1: 22*LVL_WIDTH], int_state_i[ 23], int_state_i[ 22], lvl__23_to__22, num__23_to__22);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell__25_to__24 (int_lvl_i[( 26*LVL_WIDTH)-1: 25*LVL_WIDTH], int_lvl_i[( 25*LVL_WIDTH)-1: 24*LVL_WIDTH], int_state_i[ 25], int_state_i[ 24], lvl__25_to__24, num__25_to__24);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell__27_to__26 (int_lvl_i[( 28*LVL_WIDTH)-1: 27*LVL_WIDTH], int_lvl_i[( 27*LVL_WIDTH)-1: 26*LVL_WIDTH], int_state_i[ 27], int_state_i[ 26], lvl__27_to__26, num__27_to__26);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell__29_to__28 (int_lvl_i[( 30*LVL_WIDTH)-1: 29*LVL_WIDTH], int_lvl_i[( 29*LVL_WIDTH)-1: 28*LVL_WIDTH], int_state_i[ 29], int_state_i[ 28], lvl__29_to__28, num__29_to__28);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell__31_to__30 (int_lvl_i[( 32*LVL_WIDTH)-1: 31*LVL_WIDTH], int_lvl_i[( 31*LVL_WIDTH)-1: 30*LVL_WIDTH], int_state_i[ 31], int_state_i[ 30], lvl__31_to__30, num__31_to__30);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell__33_to__32 (int_lvl_i[( 34*LVL_WIDTH)-1: 33*LVL_WIDTH], int_lvl_i[( 33*LVL_WIDTH)-1: 32*LVL_WIDTH], int_state_i[ 33], int_state_i[ 32], lvl__33_to__32, num__33_to__32);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell__35_to__34 (int_lvl_i[( 36*LVL_WIDTH)-1: 35*LVL_WIDTH], int_lvl_i[( 35*LVL_WIDTH)-1: 34*LVL_WIDTH], int_state_i[ 35], int_state_i[ 34], lvl__35_to__34, num__35_to__34);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell__37_to__36 (int_lvl_i[( 38*LVL_WIDTH)-1: 37*LVL_WIDTH], int_lvl_i[( 37*LVL_WIDTH)-1: 36*LVL_WIDTH], int_state_i[ 37], int_state_i[ 36], lvl__37_to__36, num__37_to__36);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell__39_to__38 (int_lvl_i[( 40*LVL_WIDTH)-1: 39*LVL_WIDTH], int_lvl_i[( 39*LVL_WIDTH)-1: 38*LVL_WIDTH], int_state_i[ 39], int_state_i[ 38], lvl__39_to__38, num__39_to__38);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell__41_to__40 (int_lvl_i[( 42*LVL_WIDTH)-1: 41*LVL_WIDTH], int_lvl_i[( 41*LVL_WIDTH)-1: 40*LVL_WIDTH], int_state_i[ 41], int_state_i[ 40], lvl__41_to__40, num__41_to__40);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell__43_to__42 (int_lvl_i[( 44*LVL_WIDTH)-1: 43*LVL_WIDTH], int_lvl_i[( 43*LVL_WIDTH)-1: 42*LVL_WIDTH], int_state_i[ 43], int_state_i[ 42], lvl__43_to__42, num__43_to__42);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell__45_to__44 (int_lvl_i[( 46*LVL_WIDTH)-1: 45*LVL_WIDTH], int_lvl_i[( 45*LVL_WIDTH)-1: 44*LVL_WIDTH], int_state_i[ 45], int_state_i[ 44], lvl__45_to__44, num__45_to__44);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell__47_to__46 (int_lvl_i[( 48*LVL_WIDTH)-1: 47*LVL_WIDTH], int_lvl_i[( 47*LVL_WIDTH)-1: 46*LVL_WIDTH], int_state_i[ 47], int_state_i[ 46], lvl__47_to__46, num__47_to__46);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell__49_to__48 (int_lvl_i[( 50*LVL_WIDTH)-1: 49*LVL_WIDTH], int_lvl_i[( 49*LVL_WIDTH)-1: 48*LVL_WIDTH], int_state_i[ 49], int_state_i[ 48], lvl__49_to__48, num__49_to__48);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell__51_to__50 (int_lvl_i[( 52*LVL_WIDTH)-1: 51*LVL_WIDTH], int_lvl_i[( 51*LVL_WIDTH)-1: 50*LVL_WIDTH], int_state_i[ 51], int_state_i[ 50], lvl__51_to__50, num__51_to__50);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell__53_to__52 (int_lvl_i[( 54*LVL_WIDTH)-1: 53*LVL_WIDTH], int_lvl_i[( 53*LVL_WIDTH)-1: 52*LVL_WIDTH], int_state_i[ 53], int_state_i[ 52], lvl__53_to__52, num__53_to__52);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell__55_to__54 (int_lvl_i[( 56*LVL_WIDTH)-1: 55*LVL_WIDTH], int_lvl_i[( 55*LVL_WIDTH)-1: 54*LVL_WIDTH], int_state_i[ 55], int_state_i[ 54], lvl__55_to__54, num__55_to__54);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell__57_to__56 (int_lvl_i[( 58*LVL_WIDTH)-1: 57*LVL_WIDTH], int_lvl_i[( 57*LVL_WIDTH)-1: 56*LVL_WIDTH], int_state_i[ 57], int_state_i[ 56], lvl__57_to__56, num__57_to__56);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell__59_to__58 (int_lvl_i[( 60*LVL_WIDTH)-1: 59*LVL_WIDTH], int_lvl_i[( 59*LVL_WIDTH)-1: 58*LVL_WIDTH], int_state_i[ 59], int_state_i[ 58], lvl__59_to__58, num__59_to__58);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell__61_to__60 (int_lvl_i[( 62*LVL_WIDTH)-1: 61*LVL_WIDTH], int_lvl_i[( 61*LVL_WIDTH)-1: 60*LVL_WIDTH], int_state_i[ 61], int_state_i[ 60], lvl__61_to__60, num__61_to__60);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell__63_to__62 (int_lvl_i[( 64*LVL_WIDTH)-1: 63*LVL_WIDTH], int_lvl_i[( 63*LVL_WIDTH)-1: 62*LVL_WIDTH], int_state_i[ 63], int_state_i[ 62], lvl__63_to__62, num__63_to__62);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell__65_to__64 (int_lvl_i[( 66*LVL_WIDTH)-1: 65*LVL_WIDTH], int_lvl_i[( 65*LVL_WIDTH)-1: 64*LVL_WIDTH], int_state_i[ 65], int_state_i[ 64], lvl__65_to__64, num__65_to__64);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell__67_to__66 (int_lvl_i[( 68*LVL_WIDTH)-1: 67*LVL_WIDTH], int_lvl_i[( 67*LVL_WIDTH)-1: 66*LVL_WIDTH], int_state_i[ 67], int_state_i[ 66], lvl__67_to__66, num__67_to__66);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell__69_to__68 (int_lvl_i[( 70*LVL_WIDTH)-1: 69*LVL_WIDTH], int_lvl_i[( 69*LVL_WIDTH)-1: 68*LVL_WIDTH], int_state_i[ 69], int_state_i[ 68], lvl__69_to__68, num__69_to__68);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell__71_to__70 (int_lvl_i[( 72*LVL_WIDTH)-1: 71*LVL_WIDTH], int_lvl_i[( 71*LVL_WIDTH)-1: 70*LVL_WIDTH], int_state_i[ 71], int_state_i[ 70], lvl__71_to__70, num__71_to__70);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell__73_to__72 (int_lvl_i[( 74*LVL_WIDTH)-1: 73*LVL_WIDTH], int_lvl_i[( 73*LVL_WIDTH)-1: 72*LVL_WIDTH], int_state_i[ 73], int_state_i[ 72], lvl__73_to__72, num__73_to__72);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell__75_to__74 (int_lvl_i[( 76*LVL_WIDTH)-1: 75*LVL_WIDTH], int_lvl_i[( 75*LVL_WIDTH)-1: 74*LVL_WIDTH], int_state_i[ 75], int_state_i[ 74], lvl__75_to__74, num__75_to__74);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell__77_to__76 (int_lvl_i[( 78*LVL_WIDTH)-1: 77*LVL_WIDTH], int_lvl_i[( 77*LVL_WIDTH)-1: 76*LVL_WIDTH], int_state_i[ 77], int_state_i[ 76], lvl__77_to__76, num__77_to__76);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell__79_to__78 (int_lvl_i[( 80*LVL_WIDTH)-1: 79*LVL_WIDTH], int_lvl_i[( 79*LVL_WIDTH)-1: 78*LVL_WIDTH], int_state_i[ 79], int_state_i[ 78], lvl__79_to__78, num__79_to__78);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell__81_to__80 (int_lvl_i[( 82*LVL_WIDTH)-1: 81*LVL_WIDTH], int_lvl_i[( 81*LVL_WIDTH)-1: 80*LVL_WIDTH], int_state_i[ 81], int_state_i[ 80], lvl__81_to__80, num__81_to__80);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell__83_to__82 (int_lvl_i[( 84*LVL_WIDTH)-1: 83*LVL_WIDTH], int_lvl_i[( 83*LVL_WIDTH)-1: 82*LVL_WIDTH], int_state_i[ 83], int_state_i[ 82], lvl__83_to__82, num__83_to__82);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell__85_to__84 (int_lvl_i[( 86*LVL_WIDTH)-1: 85*LVL_WIDTH], int_lvl_i[( 85*LVL_WIDTH)-1: 84*LVL_WIDTH], int_state_i[ 85], int_state_i[ 84], lvl__85_to__84, num__85_to__84);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell__87_to__86 (int_lvl_i[( 88*LVL_WIDTH)-1: 87*LVL_WIDTH], int_lvl_i[( 87*LVL_WIDTH)-1: 86*LVL_WIDTH], int_state_i[ 87], int_state_i[ 86], lvl__87_to__86, num__87_to__86);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell__89_to__88 (int_lvl_i[( 90*LVL_WIDTH)-1: 89*LVL_WIDTH], int_lvl_i[( 89*LVL_WIDTH)-1: 88*LVL_WIDTH], int_state_i[ 89], int_state_i[ 88], lvl__89_to__88, num__89_to__88);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell__91_to__90 (int_lvl_i[( 92*LVL_WIDTH)-1: 91*LVL_WIDTH], int_lvl_i[( 91*LVL_WIDTH)-1: 90*LVL_WIDTH], int_state_i[ 91], int_state_i[ 90], lvl__91_to__90, num__91_to__90);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell__93_to__92 (int_lvl_i[( 94*LVL_WIDTH)-1: 93*LVL_WIDTH], int_lvl_i[( 93*LVL_WIDTH)-1: 92*LVL_WIDTH], int_state_i[ 93], int_state_i[ 92], lvl__93_to__92, num__93_to__92);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell__95_to__94 (int_lvl_i[( 96*LVL_WIDTH)-1: 95*LVL_WIDTH], int_lvl_i[( 95*LVL_WIDTH)-1: 94*LVL_WIDTH], int_state_i[ 95], int_state_i[ 94], lvl__95_to__94, num__95_to__94);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell__97_to__96 (int_lvl_i[( 98*LVL_WIDTH)-1: 97*LVL_WIDTH], int_lvl_i[( 97*LVL_WIDTH)-1: 96*LVL_WIDTH], int_state_i[ 97], int_state_i[ 96], lvl__97_to__96, num__97_to__96);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell__99_to__98 (int_lvl_i[(100*LVL_WIDTH)-1: 99*LVL_WIDTH], int_lvl_i[( 99*LVL_WIDTH)-1: 98*LVL_WIDTH], int_state_i[ 99], int_state_i[ 98], lvl__99_to__98, num__99_to__98);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_101_to_100 (int_lvl_i[(102*LVL_WIDTH)-1:101*LVL_WIDTH], int_lvl_i[(101*LVL_WIDTH)-1:100*LVL_WIDTH], int_state_i[101], int_state_i[100], lvl_101_to_100, num_101_to_100);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_103_to_102 (int_lvl_i[(104*LVL_WIDTH)-1:103*LVL_WIDTH], int_lvl_i[(103*LVL_WIDTH)-1:102*LVL_WIDTH], int_state_i[103], int_state_i[102], lvl_103_to_102, num_103_to_102);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_105_to_104 (int_lvl_i[(106*LVL_WIDTH)-1:105*LVL_WIDTH], int_lvl_i[(105*LVL_WIDTH)-1:104*LVL_WIDTH], int_state_i[105], int_state_i[104], lvl_105_to_104, num_105_to_104);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_107_to_106 (int_lvl_i[(108*LVL_WIDTH)-1:107*LVL_WIDTH], int_lvl_i[(107*LVL_WIDTH)-1:106*LVL_WIDTH], int_state_i[107], int_state_i[106], lvl_107_to_106, num_107_to_106);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_109_to_108 (int_lvl_i[(110*LVL_WIDTH)-1:109*LVL_WIDTH], int_lvl_i[(109*LVL_WIDTH)-1:108*LVL_WIDTH], int_state_i[109], int_state_i[108], lvl_109_to_108, num_109_to_108);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_111_to_110 (int_lvl_i[(112*LVL_WIDTH)-1:111*LVL_WIDTH], int_lvl_i[(111*LVL_WIDTH)-1:110*LVL_WIDTH], int_state_i[111], int_state_i[110], lvl_111_to_110, num_111_to_110);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_113_to_112 (int_lvl_i[(114*LVL_WIDTH)-1:113*LVL_WIDTH], int_lvl_i[(113*LVL_WIDTH)-1:112*LVL_WIDTH], int_state_i[113], int_state_i[112], lvl_113_to_112, num_113_to_112);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_115_to_114 (int_lvl_i[(116*LVL_WIDTH)-1:115*LVL_WIDTH], int_lvl_i[(115*LVL_WIDTH)-1:114*LVL_WIDTH], int_state_i[115], int_state_i[114], lvl_115_to_114, num_115_to_114);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_117_to_116 (int_lvl_i[(118*LVL_WIDTH)-1:117*LVL_WIDTH], int_lvl_i[(117*LVL_WIDTH)-1:116*LVL_WIDTH], int_state_i[117], int_state_i[116], lvl_117_to_116, num_117_to_116);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_119_to_118 (int_lvl_i[(120*LVL_WIDTH)-1:119*LVL_WIDTH], int_lvl_i[(119*LVL_WIDTH)-1:118*LVL_WIDTH], int_state_i[119], int_state_i[118], lvl_119_to_118, num_119_to_118);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_121_to_120 (int_lvl_i[(122*LVL_WIDTH)-1:121*LVL_WIDTH], int_lvl_i[(121*LVL_WIDTH)-1:120*LVL_WIDTH], int_state_i[121], int_state_i[120], lvl_121_to_120, num_121_to_120);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_123_to_122 (int_lvl_i[(124*LVL_WIDTH)-1:123*LVL_WIDTH], int_lvl_i[(123*LVL_WIDTH)-1:122*LVL_WIDTH], int_state_i[123], int_state_i[122], lvl_123_to_122, num_123_to_122);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_125_to_124 (int_lvl_i[(126*LVL_WIDTH)-1:125*LVL_WIDTH], int_lvl_i[(125*LVL_WIDTH)-1:124*LVL_WIDTH], int_state_i[125], int_state_i[124], lvl_125_to_124, num_125_to_124);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_127_to_126 (int_lvl_i[(128*LVL_WIDTH)-1:127*LVL_WIDTH], int_lvl_i[(127*LVL_WIDTH)-1:126*LVL_WIDTH], int_state_i[127], int_state_i[126], lvl_127_to_126, num_127_to_126);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_129_to_128 (int_lvl_i[(130*LVL_WIDTH)-1:129*LVL_WIDTH], int_lvl_i[(129*LVL_WIDTH)-1:128*LVL_WIDTH], int_state_i[129], int_state_i[128], lvl_129_to_128, num_129_to_128);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_131_to_130 (int_lvl_i[(132*LVL_WIDTH)-1:131*LVL_WIDTH], int_lvl_i[(131*LVL_WIDTH)-1:130*LVL_WIDTH], int_state_i[131], int_state_i[130], lvl_131_to_130, num_131_to_130);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_133_to_132 (int_lvl_i[(134*LVL_WIDTH)-1:133*LVL_WIDTH], int_lvl_i[(133*LVL_WIDTH)-1:132*LVL_WIDTH], int_state_i[133], int_state_i[132], lvl_133_to_132, num_133_to_132);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_135_to_134 (int_lvl_i[(136*LVL_WIDTH)-1:135*LVL_WIDTH], int_lvl_i[(135*LVL_WIDTH)-1:134*LVL_WIDTH], int_state_i[135], int_state_i[134], lvl_135_to_134, num_135_to_134);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_137_to_136 (int_lvl_i[(138*LVL_WIDTH)-1:137*LVL_WIDTH], int_lvl_i[(137*LVL_WIDTH)-1:136*LVL_WIDTH], int_state_i[137], int_state_i[136], lvl_137_to_136, num_137_to_136);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_139_to_138 (int_lvl_i[(140*LVL_WIDTH)-1:139*LVL_WIDTH], int_lvl_i[(139*LVL_WIDTH)-1:138*LVL_WIDTH], int_state_i[139], int_state_i[138], lvl_139_to_138, num_139_to_138);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_141_to_140 (int_lvl_i[(142*LVL_WIDTH)-1:141*LVL_WIDTH], int_lvl_i[(141*LVL_WIDTH)-1:140*LVL_WIDTH], int_state_i[141], int_state_i[140], lvl_141_to_140, num_141_to_140);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_143_to_142 (int_lvl_i[(144*LVL_WIDTH)-1:143*LVL_WIDTH], int_lvl_i[(143*LVL_WIDTH)-1:142*LVL_WIDTH], int_state_i[143], int_state_i[142], lvl_143_to_142, num_143_to_142);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_145_to_144 (int_lvl_i[(146*LVL_WIDTH)-1:145*LVL_WIDTH], int_lvl_i[(145*LVL_WIDTH)-1:144*LVL_WIDTH], int_state_i[145], int_state_i[144], lvl_145_to_144, num_145_to_144);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_147_to_146 (int_lvl_i[(148*LVL_WIDTH)-1:147*LVL_WIDTH], int_lvl_i[(147*LVL_WIDTH)-1:146*LVL_WIDTH], int_state_i[147], int_state_i[146], lvl_147_to_146, num_147_to_146);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_149_to_148 (int_lvl_i[(150*LVL_WIDTH)-1:149*LVL_WIDTH], int_lvl_i[(149*LVL_WIDTH)-1:148*LVL_WIDTH], int_state_i[149], int_state_i[148], lvl_149_to_148, num_149_to_148);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_151_to_150 (int_lvl_i[(152*LVL_WIDTH)-1:151*LVL_WIDTH], int_lvl_i[(151*LVL_WIDTH)-1:150*LVL_WIDTH], int_state_i[151], int_state_i[150], lvl_151_to_150, num_151_to_150);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_153_to_152 (int_lvl_i[(154*LVL_WIDTH)-1:153*LVL_WIDTH], int_lvl_i[(153*LVL_WIDTH)-1:152*LVL_WIDTH], int_state_i[153], int_state_i[152], lvl_153_to_152, num_153_to_152);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_155_to_154 (int_lvl_i[(156*LVL_WIDTH)-1:155*LVL_WIDTH], int_lvl_i[(155*LVL_WIDTH)-1:154*LVL_WIDTH], int_state_i[155], int_state_i[154], lvl_155_to_154, num_155_to_154);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_157_to_156 (int_lvl_i[(158*LVL_WIDTH)-1:157*LVL_WIDTH], int_lvl_i[(157*LVL_WIDTH)-1:156*LVL_WIDTH], int_state_i[157], int_state_i[156], lvl_157_to_156, num_157_to_156);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_159_to_158 (int_lvl_i[(160*LVL_WIDTH)-1:159*LVL_WIDTH], int_lvl_i[(159*LVL_WIDTH)-1:158*LVL_WIDTH], int_state_i[159], int_state_i[158], lvl_159_to_158, num_159_to_158);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_161_to_160 (int_lvl_i[(162*LVL_WIDTH)-1:161*LVL_WIDTH], int_lvl_i[(161*LVL_WIDTH)-1:160*LVL_WIDTH], int_state_i[161], int_state_i[160], lvl_161_to_160, num_161_to_160);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_163_to_162 (int_lvl_i[(164*LVL_WIDTH)-1:163*LVL_WIDTH], int_lvl_i[(163*LVL_WIDTH)-1:162*LVL_WIDTH], int_state_i[163], int_state_i[162], lvl_163_to_162, num_163_to_162);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_165_to_164 (int_lvl_i[(166*LVL_WIDTH)-1:165*LVL_WIDTH], int_lvl_i[(165*LVL_WIDTH)-1:164*LVL_WIDTH], int_state_i[165], int_state_i[164], lvl_165_to_164, num_165_to_164);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_167_to_166 (int_lvl_i[(168*LVL_WIDTH)-1:167*LVL_WIDTH], int_lvl_i[(167*LVL_WIDTH)-1:166*LVL_WIDTH], int_state_i[167], int_state_i[166], lvl_167_to_166, num_167_to_166);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_169_to_168 (int_lvl_i[(170*LVL_WIDTH)-1:169*LVL_WIDTH], int_lvl_i[(169*LVL_WIDTH)-1:168*LVL_WIDTH], int_state_i[169], int_state_i[168], lvl_169_to_168, num_169_to_168);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_171_to_170 (int_lvl_i[(172*LVL_WIDTH)-1:171*LVL_WIDTH], int_lvl_i[(171*LVL_WIDTH)-1:170*LVL_WIDTH], int_state_i[171], int_state_i[170], lvl_171_to_170, num_171_to_170);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_173_to_172 (int_lvl_i[(174*LVL_WIDTH)-1:173*LVL_WIDTH], int_lvl_i[(173*LVL_WIDTH)-1:172*LVL_WIDTH], int_state_i[173], int_state_i[172], lvl_173_to_172, num_173_to_172);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_175_to_174 (int_lvl_i[(176*LVL_WIDTH)-1:175*LVL_WIDTH], int_lvl_i[(175*LVL_WIDTH)-1:174*LVL_WIDTH], int_state_i[175], int_state_i[174], lvl_175_to_174, num_175_to_174);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_177_to_176 (int_lvl_i[(178*LVL_WIDTH)-1:177*LVL_WIDTH], int_lvl_i[(177*LVL_WIDTH)-1:176*LVL_WIDTH], int_state_i[177], int_state_i[176], lvl_177_to_176, num_177_to_176);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_179_to_178 (int_lvl_i[(180*LVL_WIDTH)-1:179*LVL_WIDTH], int_lvl_i[(179*LVL_WIDTH)-1:178*LVL_WIDTH], int_state_i[179], int_state_i[178], lvl_179_to_178, num_179_to_178);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_181_to_180 (int_lvl_i[(182*LVL_WIDTH)-1:181*LVL_WIDTH], int_lvl_i[(181*LVL_WIDTH)-1:180*LVL_WIDTH], int_state_i[181], int_state_i[180], lvl_181_to_180, num_181_to_180);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_183_to_182 (int_lvl_i[(184*LVL_WIDTH)-1:183*LVL_WIDTH], int_lvl_i[(183*LVL_WIDTH)-1:182*LVL_WIDTH], int_state_i[183], int_state_i[182], lvl_183_to_182, num_183_to_182);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_185_to_184 (int_lvl_i[(186*LVL_WIDTH)-1:185*LVL_WIDTH], int_lvl_i[(185*LVL_WIDTH)-1:184*LVL_WIDTH], int_state_i[185], int_state_i[184], lvl_185_to_184, num_185_to_184);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_187_to_186 (int_lvl_i[(188*LVL_WIDTH)-1:187*LVL_WIDTH], int_lvl_i[(187*LVL_WIDTH)-1:186*LVL_WIDTH], int_state_i[187], int_state_i[186], lvl_187_to_186, num_187_to_186);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_189_to_188 (int_lvl_i[(190*LVL_WIDTH)-1:189*LVL_WIDTH], int_lvl_i[(189*LVL_WIDTH)-1:188*LVL_WIDTH], int_state_i[189], int_state_i[188], lvl_189_to_188, num_189_to_188);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_191_to_190 (int_lvl_i[(192*LVL_WIDTH)-1:191*LVL_WIDTH], int_lvl_i[(191*LVL_WIDTH)-1:190*LVL_WIDTH], int_state_i[191], int_state_i[190], lvl_191_to_190, num_191_to_190);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_193_to_192 (int_lvl_i[(194*LVL_WIDTH)-1:193*LVL_WIDTH], int_lvl_i[(193*LVL_WIDTH)-1:192*LVL_WIDTH], int_state_i[193], int_state_i[192], lvl_193_to_192, num_193_to_192);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_195_to_194 (int_lvl_i[(196*LVL_WIDTH)-1:195*LVL_WIDTH], int_lvl_i[(195*LVL_WIDTH)-1:194*LVL_WIDTH], int_state_i[195], int_state_i[194], lvl_195_to_194, num_195_to_194);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_197_to_196 (int_lvl_i[(198*LVL_WIDTH)-1:197*LVL_WIDTH], int_lvl_i[(197*LVL_WIDTH)-1:196*LVL_WIDTH], int_state_i[197], int_state_i[196], lvl_197_to_196, num_197_to_196);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_199_to_198 (int_lvl_i[(200*LVL_WIDTH)-1:199*LVL_WIDTH], int_lvl_i[(199*LVL_WIDTH)-1:198*LVL_WIDTH], int_state_i[199], int_state_i[198], lvl_199_to_198, num_199_to_198);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_201_to_200 (int_lvl_i[(202*LVL_WIDTH)-1:201*LVL_WIDTH], int_lvl_i[(201*LVL_WIDTH)-1:200*LVL_WIDTH], int_state_i[201], int_state_i[200], lvl_201_to_200, num_201_to_200);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_203_to_202 (int_lvl_i[(204*LVL_WIDTH)-1:203*LVL_WIDTH], int_lvl_i[(203*LVL_WIDTH)-1:202*LVL_WIDTH], int_state_i[203], int_state_i[202], lvl_203_to_202, num_203_to_202);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_205_to_204 (int_lvl_i[(206*LVL_WIDTH)-1:205*LVL_WIDTH], int_lvl_i[(205*LVL_WIDTH)-1:204*LVL_WIDTH], int_state_i[205], int_state_i[204], lvl_205_to_204, num_205_to_204);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_207_to_206 (int_lvl_i[(208*LVL_WIDTH)-1:207*LVL_WIDTH], int_lvl_i[(207*LVL_WIDTH)-1:206*LVL_WIDTH], int_state_i[207], int_state_i[206], lvl_207_to_206, num_207_to_206);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_209_to_208 (int_lvl_i[(210*LVL_WIDTH)-1:209*LVL_WIDTH], int_lvl_i[(209*LVL_WIDTH)-1:208*LVL_WIDTH], int_state_i[209], int_state_i[208], lvl_209_to_208, num_209_to_208);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_211_to_210 (int_lvl_i[(212*LVL_WIDTH)-1:211*LVL_WIDTH], int_lvl_i[(211*LVL_WIDTH)-1:210*LVL_WIDTH], int_state_i[211], int_state_i[210], lvl_211_to_210, num_211_to_210);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_213_to_212 (int_lvl_i[(214*LVL_WIDTH)-1:213*LVL_WIDTH], int_lvl_i[(213*LVL_WIDTH)-1:212*LVL_WIDTH], int_state_i[213], int_state_i[212], lvl_213_to_212, num_213_to_212);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_215_to_214 (int_lvl_i[(216*LVL_WIDTH)-1:215*LVL_WIDTH], int_lvl_i[(215*LVL_WIDTH)-1:214*LVL_WIDTH], int_state_i[215], int_state_i[214], lvl_215_to_214, num_215_to_214);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_217_to_216 (int_lvl_i[(218*LVL_WIDTH)-1:217*LVL_WIDTH], int_lvl_i[(217*LVL_WIDTH)-1:216*LVL_WIDTH], int_state_i[217], int_state_i[216], lvl_217_to_216, num_217_to_216);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_219_to_218 (int_lvl_i[(220*LVL_WIDTH)-1:219*LVL_WIDTH], int_lvl_i[(219*LVL_WIDTH)-1:218*LVL_WIDTH], int_state_i[219], int_state_i[218], lvl_219_to_218, num_219_to_218);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_221_to_220 (int_lvl_i[(222*LVL_WIDTH)-1:221*LVL_WIDTH], int_lvl_i[(221*LVL_WIDTH)-1:220*LVL_WIDTH], int_state_i[221], int_state_i[220], lvl_221_to_220, num_221_to_220);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_223_to_222 (int_lvl_i[(224*LVL_WIDTH)-1:223*LVL_WIDTH], int_lvl_i[(223*LVL_WIDTH)-1:222*LVL_WIDTH], int_state_i[223], int_state_i[222], lvl_223_to_222, num_223_to_222);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_225_to_224 (int_lvl_i[(226*LVL_WIDTH)-1:225*LVL_WIDTH], int_lvl_i[(225*LVL_WIDTH)-1:224*LVL_WIDTH], int_state_i[225], int_state_i[224], lvl_225_to_224, num_225_to_224);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_227_to_226 (int_lvl_i[(228*LVL_WIDTH)-1:227*LVL_WIDTH], int_lvl_i[(227*LVL_WIDTH)-1:226*LVL_WIDTH], int_state_i[227], int_state_i[226], lvl_227_to_226, num_227_to_226);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_229_to_228 (int_lvl_i[(230*LVL_WIDTH)-1:229*LVL_WIDTH], int_lvl_i[(229*LVL_WIDTH)-1:228*LVL_WIDTH], int_state_i[229], int_state_i[228], lvl_229_to_228, num_229_to_228);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_231_to_230 (int_lvl_i[(232*LVL_WIDTH)-1:231*LVL_WIDTH], int_lvl_i[(231*LVL_WIDTH)-1:230*LVL_WIDTH], int_state_i[231], int_state_i[230], lvl_231_to_230, num_231_to_230);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_233_to_232 (int_lvl_i[(234*LVL_WIDTH)-1:233*LVL_WIDTH], int_lvl_i[(233*LVL_WIDTH)-1:232*LVL_WIDTH], int_state_i[233], int_state_i[232], lvl_233_to_232, num_233_to_232);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_235_to_234 (int_lvl_i[(236*LVL_WIDTH)-1:235*LVL_WIDTH], int_lvl_i[(235*LVL_WIDTH)-1:234*LVL_WIDTH], int_state_i[235], int_state_i[234], lvl_235_to_234, num_235_to_234);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_237_to_236 (int_lvl_i[(238*LVL_WIDTH)-1:237*LVL_WIDTH], int_lvl_i[(237*LVL_WIDTH)-1:236*LVL_WIDTH], int_state_i[237], int_state_i[236], lvl_237_to_236, num_237_to_236);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_239_to_238 (int_lvl_i[(240*LVL_WIDTH)-1:239*LVL_WIDTH], int_lvl_i[(239*LVL_WIDTH)-1:238*LVL_WIDTH], int_state_i[239], int_state_i[238], lvl_239_to_238, num_239_to_238);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_241_to_240 (int_lvl_i[(242*LVL_WIDTH)-1:241*LVL_WIDTH], int_lvl_i[(241*LVL_WIDTH)-1:240*LVL_WIDTH], int_state_i[241], int_state_i[240], lvl_241_to_240, num_241_to_240);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_243_to_242 (int_lvl_i[(244*LVL_WIDTH)-1:243*LVL_WIDTH], int_lvl_i[(243*LVL_WIDTH)-1:242*LVL_WIDTH], int_state_i[243], int_state_i[242], lvl_243_to_242, num_243_to_242);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_245_to_244 (int_lvl_i[(246*LVL_WIDTH)-1:245*LVL_WIDTH], int_lvl_i[(245*LVL_WIDTH)-1:244*LVL_WIDTH], int_state_i[245], int_state_i[244], lvl_245_to_244, num_245_to_244);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_247_to_246 (int_lvl_i[(248*LVL_WIDTH)-1:247*LVL_WIDTH], int_lvl_i[(247*LVL_WIDTH)-1:246*LVL_WIDTH], int_state_i[247], int_state_i[246], lvl_247_to_246, num_247_to_246);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_249_to_248 (int_lvl_i[(250*LVL_WIDTH)-1:249*LVL_WIDTH], int_lvl_i[(249*LVL_WIDTH)-1:248*LVL_WIDTH], int_state_i[249], int_state_i[248], lvl_249_to_248, num_249_to_248);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_251_to_250 (int_lvl_i[(252*LVL_WIDTH)-1:251*LVL_WIDTH], int_lvl_i[(251*LVL_WIDTH)-1:250*LVL_WIDTH], int_state_i[251], int_state_i[250], lvl_251_to_250, num_251_to_250);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_253_to_252 (int_lvl_i[(254*LVL_WIDTH)-1:253*LVL_WIDTH], int_lvl_i[(253*LVL_WIDTH)-1:252*LVL_WIDTH], int_state_i[253], int_state_i[252], lvl_253_to_252, num_253_to_252);
  cm3_nvic_cell #(LVL_WIDTH, 0) u_cell_255_to_254 (int_lvl_i[(256*LVL_WIDTH)-1:255*LVL_WIDTH], int_lvl_i[(255*LVL_WIDTH)-1:254*LVL_WIDTH], int_state_i[255], int_state_i[254], lvl_255_to_254, num_255_to_254);

  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell___3_to___0 (lvl___3_to___2, lvl___1_to___0, num___3_to___2, num___1_to___0, lvl___3_to___0, num___3_to___0);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell___7_to___4 (lvl___7_to___6, lvl___5_to___4, num___7_to___6, num___5_to___4, lvl___7_to___4, num___7_to___4);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell__11_to___8 (lvl__11_to__10, lvl___9_to___8, num__11_to__10, num___9_to___8, lvl__11_to___8, num__11_to___8);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell__15_to__12 (lvl__15_to__14, lvl__13_to__12, num__15_to__14, num__13_to__12, lvl__15_to__12, num__15_to__12);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell__19_to__16 (lvl__19_to__18, lvl__17_to__16, num__19_to__18, num__17_to__16, lvl__19_to__16, num__19_to__16);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell__23_to__20 (lvl__23_to__22, lvl__21_to__20, num__23_to__22, num__21_to__20, lvl__23_to__20, num__23_to__20);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell__27_to__24 (lvl__27_to__26, lvl__25_to__24, num__27_to__26, num__25_to__24, lvl__27_to__24, num__27_to__24);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell__31_to__28 (lvl__31_to__30, lvl__29_to__28, num__31_to__30, num__29_to__28, lvl__31_to__28, num__31_to__28);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell__35_to__32 (lvl__35_to__34, lvl__33_to__32, num__35_to__34, num__33_to__32, lvl__35_to__32, num__35_to__32);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell__39_to__36 (lvl__39_to__38, lvl__37_to__36, num__39_to__38, num__37_to__36, lvl__39_to__36, num__39_to__36);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell__43_to__40 (lvl__43_to__42, lvl__41_to__40, num__43_to__42, num__41_to__40, lvl__43_to__40, num__43_to__40);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell__47_to__44 (lvl__47_to__46, lvl__45_to__44, num__47_to__46, num__45_to__44, lvl__47_to__44, num__47_to__44);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell__51_to__48 (lvl__51_to__50, lvl__49_to__48, num__51_to__50, num__49_to__48, lvl__51_to__48, num__51_to__48);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell__55_to__52 (lvl__55_to__54, lvl__53_to__52, num__55_to__54, num__53_to__52, lvl__55_to__52, num__55_to__52);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell__59_to__56 (lvl__59_to__58, lvl__57_to__56, num__59_to__58, num__57_to__56, lvl__59_to__56, num__59_to__56);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell__63_to__60 (lvl__63_to__62, lvl__61_to__60, num__63_to__62, num__61_to__60, lvl__63_to__60, num__63_to__60);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell__67_to__64 (lvl__67_to__66, lvl__65_to__64, num__67_to__66, num__65_to__64, lvl__67_to__64, num__67_to__64);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell__71_to__68 (lvl__71_to__70, lvl__69_to__68, num__71_to__70, num__69_to__68, lvl__71_to__68, num__71_to__68);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell__75_to__72 (lvl__75_to__74, lvl__73_to__72, num__75_to__74, num__73_to__72, lvl__75_to__72, num__75_to__72);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell__79_to__76 (lvl__79_to__78, lvl__77_to__76, num__79_to__78, num__77_to__76, lvl__79_to__76, num__79_to__76);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell__83_to__80 (lvl__83_to__82, lvl__81_to__80, num__83_to__82, num__81_to__80, lvl__83_to__80, num__83_to__80);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell__87_to__84 (lvl__87_to__86, lvl__85_to__84, num__87_to__86, num__85_to__84, lvl__87_to__84, num__87_to__84);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell__91_to__88 (lvl__91_to__90, lvl__89_to__88, num__91_to__90, num__89_to__88, lvl__91_to__88, num__91_to__88);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell__95_to__92 (lvl__95_to__94, lvl__93_to__92, num__95_to__94, num__93_to__92, lvl__95_to__92, num__95_to__92);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell__99_to__96 (lvl__99_to__98, lvl__97_to__96, num__99_to__98, num__97_to__96, lvl__99_to__96, num__99_to__96);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell_103_to_100 (lvl_103_to_102, lvl_101_to_100, num_103_to_102, num_101_to_100, lvl_103_to_100, num_103_to_100);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell_107_to_104 (lvl_107_to_106, lvl_105_to_104, num_107_to_106, num_105_to_104, lvl_107_to_104, num_107_to_104);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell_111_to_108 (lvl_111_to_110, lvl_109_to_108, num_111_to_110, num_109_to_108, lvl_111_to_108, num_111_to_108);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell_115_to_112 (lvl_115_to_114, lvl_113_to_112, num_115_to_114, num_113_to_112, lvl_115_to_112, num_115_to_112);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell_119_to_116 (lvl_119_to_118, lvl_117_to_116, num_119_to_118, num_117_to_116, lvl_119_to_116, num_119_to_116);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell_123_to_120 (lvl_123_to_122, lvl_121_to_120, num_123_to_122, num_121_to_120, lvl_123_to_120, num_123_to_120);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell_127_to_124 (lvl_127_to_126, lvl_125_to_124, num_127_to_126, num_125_to_124, lvl_127_to_124, num_127_to_124);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell_131_to_128 (lvl_131_to_130, lvl_129_to_128, num_131_to_130, num_129_to_128, lvl_131_to_128, num_131_to_128);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell_135_to_132 (lvl_135_to_134, lvl_133_to_132, num_135_to_134, num_133_to_132, lvl_135_to_132, num_135_to_132);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell_139_to_136 (lvl_139_to_138, lvl_137_to_136, num_139_to_138, num_137_to_136, lvl_139_to_136, num_139_to_136);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell_143_to_140 (lvl_143_to_142, lvl_141_to_140, num_143_to_142, num_141_to_140, lvl_143_to_140, num_143_to_140);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell_147_to_144 (lvl_147_to_146, lvl_145_to_144, num_147_to_146, num_145_to_144, lvl_147_to_144, num_147_to_144);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell_151_to_148 (lvl_151_to_150, lvl_149_to_148, num_151_to_150, num_149_to_148, lvl_151_to_148, num_151_to_148);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell_155_to_152 (lvl_155_to_154, lvl_153_to_152, num_155_to_154, num_153_to_152, lvl_155_to_152, num_155_to_152);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell_159_to_156 (lvl_159_to_158, lvl_157_to_156, num_159_to_158, num_157_to_156, lvl_159_to_156, num_159_to_156);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell_163_to_160 (lvl_163_to_162, lvl_161_to_160, num_163_to_162, num_161_to_160, lvl_163_to_160, num_163_to_160);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell_167_to_164 (lvl_167_to_166, lvl_165_to_164, num_167_to_166, num_165_to_164, lvl_167_to_164, num_167_to_164);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell_171_to_168 (lvl_171_to_170, lvl_169_to_168, num_171_to_170, num_169_to_168, lvl_171_to_168, num_171_to_168);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell_175_to_172 (lvl_175_to_174, lvl_173_to_172, num_175_to_174, num_173_to_172, lvl_175_to_172, num_175_to_172);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell_179_to_176 (lvl_179_to_178, lvl_177_to_176, num_179_to_178, num_177_to_176, lvl_179_to_176, num_179_to_176);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell_183_to_180 (lvl_183_to_182, lvl_181_to_180, num_183_to_182, num_181_to_180, lvl_183_to_180, num_183_to_180);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell_187_to_184 (lvl_187_to_186, lvl_185_to_184, num_187_to_186, num_185_to_184, lvl_187_to_184, num_187_to_184);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell_191_to_188 (lvl_191_to_190, lvl_189_to_188, num_191_to_190, num_189_to_188, lvl_191_to_188, num_191_to_188);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell_195_to_192 (lvl_195_to_194, lvl_193_to_192, num_195_to_194, num_193_to_192, lvl_195_to_192, num_195_to_192);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell_199_to_196 (lvl_199_to_198, lvl_197_to_196, num_199_to_198, num_197_to_196, lvl_199_to_196, num_199_to_196);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell_203_to_200 (lvl_203_to_202, lvl_201_to_200, num_203_to_202, num_201_to_200, lvl_203_to_200, num_203_to_200);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell_207_to_204 (lvl_207_to_206, lvl_205_to_204, num_207_to_206, num_205_to_204, lvl_207_to_204, num_207_to_204);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell_211_to_208 (lvl_211_to_210, lvl_209_to_208, num_211_to_210, num_209_to_208, lvl_211_to_208, num_211_to_208);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell_215_to_212 (lvl_215_to_214, lvl_213_to_212, num_215_to_214, num_213_to_212, lvl_215_to_212, num_215_to_212);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell_219_to_216 (lvl_219_to_218, lvl_217_to_216, num_219_to_218, num_217_to_216, lvl_219_to_216, num_219_to_216);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell_223_to_220 (lvl_223_to_222, lvl_221_to_220, num_223_to_222, num_221_to_220, lvl_223_to_220, num_223_to_220);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell_227_to_224 (lvl_227_to_226, lvl_225_to_224, num_227_to_226, num_225_to_224, lvl_227_to_224, num_227_to_224);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell_231_to_228 (lvl_231_to_230, lvl_229_to_228, num_231_to_230, num_229_to_228, lvl_231_to_228, num_231_to_228);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell_235_to_232 (lvl_235_to_234, lvl_233_to_232, num_235_to_234, num_233_to_232, lvl_235_to_232, num_235_to_232);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell_239_to_236 (lvl_239_to_238, lvl_237_to_236, num_239_to_238, num_237_to_236, lvl_239_to_236, num_239_to_236);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell_243_to_240 (lvl_243_to_242, lvl_241_to_240, num_243_to_242, num_241_to_240, lvl_243_to_240, num_243_to_240);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell_247_to_244 (lvl_247_to_246, lvl_245_to_244, num_247_to_246, num_245_to_244, lvl_247_to_244, num_247_to_244);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell_251_to_248 (lvl_251_to_250, lvl_249_to_248, num_251_to_250, num_249_to_248, lvl_251_to_248, num_251_to_248);
  cm3_nvic_cell #(LVL_WIDTH, 1) u_cell_255_to_252 (lvl_255_to_254, lvl_253_to_252, num_255_to_254, num_253_to_252, lvl_255_to_252, num_255_to_252);

  cm3_nvic_cell #(LVL_WIDTH, 2) u_cell___7_to___0 (lvl___7_to___4, lvl___3_to___0, num___7_to___4, num___3_to___0, lvl___7_to___0, num___7_to___0);
  cm3_nvic_cell #(LVL_WIDTH, 2) u_cell__15_to___8 (lvl__15_to__12, lvl__11_to___8, num__15_to__12, num__11_to___8, lvl__15_to___8, num__15_to___8);
  cm3_nvic_cell #(LVL_WIDTH, 2) u_cell__23_to__16 (lvl__23_to__20, lvl__19_to__16, num__23_to__20, num__19_to__16, lvl__23_to__16, num__23_to__16);
  cm3_nvic_cell #(LVL_WIDTH, 2) u_cell__31_to__24 (lvl__31_to__28, lvl__27_to__24, num__31_to__28, num__27_to__24, lvl__31_to__24, num__31_to__24);
  cm3_nvic_cell #(LVL_WIDTH, 2) u_cell__39_to__32 (lvl__39_to__36, lvl__35_to__32, num__39_to__36, num__35_to__32, lvl__39_to__32, num__39_to__32);
  cm3_nvic_cell #(LVL_WIDTH, 2) u_cell__47_to__40 (lvl__47_to__44, lvl__43_to__40, num__47_to__44, num__43_to__40, lvl__47_to__40, num__47_to__40);
  cm3_nvic_cell #(LVL_WIDTH, 2) u_cell__55_to__48 (lvl__55_to__52, lvl__51_to__48, num__55_to__52, num__51_to__48, lvl__55_to__48, num__55_to__48);
  cm3_nvic_cell #(LVL_WIDTH, 2) u_cell__63_to__56 (lvl__63_to__60, lvl__59_to__56, num__63_to__60, num__59_to__56, lvl__63_to__56, num__63_to__56);
  cm3_nvic_cell #(LVL_WIDTH, 2) u_cell__71_to__64 (lvl__71_to__68, lvl__67_to__64, num__71_to__68, num__67_to__64, lvl__71_to__64, num__71_to__64);
  cm3_nvic_cell #(LVL_WIDTH, 2) u_cell__79_to__72 (lvl__79_to__76, lvl__75_to__72, num__79_to__76, num__75_to__72, lvl__79_to__72, num__79_to__72);
  cm3_nvic_cell #(LVL_WIDTH, 2) u_cell__87_to__80 (lvl__87_to__84, lvl__83_to__80, num__87_to__84, num__83_to__80, lvl__87_to__80, num__87_to__80);
  cm3_nvic_cell #(LVL_WIDTH, 2) u_cell__95_to__88 (lvl__95_to__92, lvl__91_to__88, num__95_to__92, num__91_to__88, lvl__95_to__88, num__95_to__88);
  cm3_nvic_cell #(LVL_WIDTH, 2) u_cell_103_to__96 (lvl_103_to_100, lvl__99_to__96, num_103_to_100, num__99_to__96, lvl_103_to__96, num_103_to__96);
  cm3_nvic_cell #(LVL_WIDTH, 2) u_cell_111_to_104 (lvl_111_to_108, lvl_107_to_104, num_111_to_108, num_107_to_104, lvl_111_to_104, num_111_to_104);
  cm3_nvic_cell #(LVL_WIDTH, 2) u_cell_119_to_112 (lvl_119_to_116, lvl_115_to_112, num_119_to_116, num_115_to_112, lvl_119_to_112, num_119_to_112);
  cm3_nvic_cell #(LVL_WIDTH, 2) u_cell_127_to_120 (lvl_127_to_124, lvl_123_to_120, num_127_to_124, num_123_to_120, lvl_127_to_120, num_127_to_120);
  cm3_nvic_cell #(LVL_WIDTH, 2) u_cell_135_to_128 (lvl_135_to_132, lvl_131_to_128, num_135_to_132, num_131_to_128, lvl_135_to_128, num_135_to_128);
  cm3_nvic_cell #(LVL_WIDTH, 2) u_cell_143_to_136 (lvl_143_to_140, lvl_139_to_136, num_143_to_140, num_139_to_136, lvl_143_to_136, num_143_to_136);
  cm3_nvic_cell #(LVL_WIDTH, 2) u_cell_151_to_144 (lvl_151_to_148, lvl_147_to_144, num_151_to_148, num_147_to_144, lvl_151_to_144, num_151_to_144);
  cm3_nvic_cell #(LVL_WIDTH, 2) u_cell_159_to_152 (lvl_159_to_156, lvl_155_to_152, num_159_to_156, num_155_to_152, lvl_159_to_152, num_159_to_152);
  cm3_nvic_cell #(LVL_WIDTH, 2) u_cell_167_to_160 (lvl_167_to_164, lvl_163_to_160, num_167_to_164, num_163_to_160, lvl_167_to_160, num_167_to_160);
  cm3_nvic_cell #(LVL_WIDTH, 2) u_cell_175_to_168 (lvl_175_to_172, lvl_171_to_168, num_175_to_172, num_171_to_168, lvl_175_to_168, num_175_to_168);
  cm3_nvic_cell #(LVL_WIDTH, 2) u_cell_183_to_176 (lvl_183_to_180, lvl_179_to_176, num_183_to_180, num_179_to_176, lvl_183_to_176, num_183_to_176);
  cm3_nvic_cell #(LVL_WIDTH, 2) u_cell_191_to_184 (lvl_191_to_188, lvl_187_to_184, num_191_to_188, num_187_to_184, lvl_191_to_184, num_191_to_184);
  cm3_nvic_cell #(LVL_WIDTH, 2) u_cell_199_to_192 (lvl_199_to_196, lvl_195_to_192, num_199_to_196, num_195_to_192, lvl_199_to_192, num_199_to_192);
  cm3_nvic_cell #(LVL_WIDTH, 2) u_cell_207_to_200 (lvl_207_to_204, lvl_203_to_200, num_207_to_204, num_203_to_200, lvl_207_to_200, num_207_to_200);
  cm3_nvic_cell #(LVL_WIDTH, 2) u_cell_215_to_208 (lvl_215_to_212, lvl_211_to_208, num_215_to_212, num_211_to_208, lvl_215_to_208, num_215_to_208);
  cm3_nvic_cell #(LVL_WIDTH, 2) u_cell_223_to_216 (lvl_223_to_220, lvl_219_to_216, num_223_to_220, num_219_to_216, lvl_223_to_216, num_223_to_216);
  cm3_nvic_cell #(LVL_WIDTH, 2) u_cell_231_to_224 (lvl_231_to_228, lvl_227_to_224, num_231_to_228, num_227_to_224, lvl_231_to_224, num_231_to_224);
  cm3_nvic_cell #(LVL_WIDTH, 2) u_cell_239_to_232 (lvl_239_to_236, lvl_235_to_232, num_239_to_236, num_235_to_232, lvl_239_to_232, num_239_to_232);
  cm3_nvic_cell #(LVL_WIDTH, 2) u_cell_247_to_240 (lvl_247_to_244, lvl_243_to_240, num_247_to_244, num_243_to_240, lvl_247_to_240, num_247_to_240);
  cm3_nvic_cell #(LVL_WIDTH, 2) u_cell_255_to_248 (lvl_255_to_252, lvl_251_to_248, num_255_to_252, num_251_to_248, lvl_255_to_248, num_255_to_248);

  cm3_nvic_cell #(LVL_WIDTH, 3) u_cell__15_to___0 (lvl__15_to___8, lvl___7_to___0, num__15_to___8, num___7_to___0, lvl__15_to___0, num__15_to___0);
  cm3_nvic_cell #(LVL_WIDTH, 3) u_cell__31_to__16 (lvl__31_to__24, lvl__23_to__16, num__31_to__24, num__23_to__16, lvl__31_to__16, num__31_to__16);
  cm3_nvic_cell #(LVL_WIDTH, 3) u_cell__47_to__32 (lvl__47_to__40, lvl__39_to__32, num__47_to__40, num__39_to__32, lvl__47_to__32, num__47_to__32);
  cm3_nvic_cell #(LVL_WIDTH, 3) u_cell__63_to__48 (lvl__63_to__56, lvl__55_to__48, num__63_to__56, num__55_to__48, lvl__63_to__48, num__63_to__48);
  cm3_nvic_cell #(LVL_WIDTH, 3) u_cell__79_to__64 (lvl__79_to__72, lvl__71_to__64, num__79_to__72, num__71_to__64, lvl__79_to__64, num__79_to__64);
  cm3_nvic_cell #(LVL_WIDTH, 3) u_cell__95_to__80 (lvl__95_to__88, lvl__87_to__80, num__95_to__88, num__87_to__80, lvl__95_to__80, num__95_to__80);
  cm3_nvic_cell #(LVL_WIDTH, 3) u_cell_111_to__96 (lvl_111_to_104, lvl_103_to__96, num_111_to_104, num_103_to__96, lvl_111_to__96, num_111_to__96);
  cm3_nvic_cell #(LVL_WIDTH, 3) u_cell_127_to_112 (lvl_127_to_120, lvl_119_to_112, num_127_to_120, num_119_to_112, lvl_127_to_112, num_127_to_112);
  cm3_nvic_cell #(LVL_WIDTH, 3) u_cell_143_to_128 (lvl_143_to_136, lvl_135_to_128, num_143_to_136, num_135_to_128, lvl_143_to_128, num_143_to_128);
  cm3_nvic_cell #(LVL_WIDTH, 3) u_cell_159_to_144 (lvl_159_to_152, lvl_151_to_144, num_159_to_152, num_151_to_144, lvl_159_to_144, num_159_to_144);
  cm3_nvic_cell #(LVL_WIDTH, 3) u_cell_175_to_160 (lvl_175_to_168, lvl_167_to_160, num_175_to_168, num_167_to_160, lvl_175_to_160, num_175_to_160);
  cm3_nvic_cell #(LVL_WIDTH, 3) u_cell_191_to_176 (lvl_191_to_184, lvl_183_to_176, num_191_to_184, num_183_to_176, lvl_191_to_176, num_191_to_176);
  cm3_nvic_cell #(LVL_WIDTH, 3) u_cell_207_to_192 (lvl_207_to_200, lvl_199_to_192, num_207_to_200, num_199_to_192, lvl_207_to_192, num_207_to_192);
  cm3_nvic_cell #(LVL_WIDTH, 3) u_cell_223_to_208 (lvl_223_to_216, lvl_215_to_208, num_223_to_216, num_215_to_208, lvl_223_to_208, num_223_to_208);
  cm3_nvic_cell #(LVL_WIDTH, 3) u_cell_239_to_224 (lvl_239_to_232, lvl_231_to_224, num_239_to_232, num_231_to_224, lvl_239_to_224, num_239_to_224);
  cm3_nvic_cell #(LVL_WIDTH, 3) u_cell_255_to_240 (lvl_255_to_248, lvl_247_to_240, num_255_to_248, num_247_to_240, lvl_255_to_240, num_255_to_240);

  cm3_nvic_cell #(LVL_WIDTH, 4) u_cell__31_to___0 (lvl__31_to__16, lvl__15_to___0, num__31_to__16, num__15_to___0, lvl__31_to___0, num__31_to___0);
  cm3_nvic_cell #(LVL_WIDTH, 4) u_cell__63_to__32 (lvl__63_to__48, lvl__47_to__32, num__63_to__48, num__47_to__32, lvl__63_to__32, num__63_to__32);
  cm3_nvic_cell #(LVL_WIDTH, 4) u_cell__95_to__64 (lvl__95_to__80, lvl__79_to__64, num__95_to__80, num__79_to__64, lvl__95_to__64, num__95_to__64);
  cm3_nvic_cell #(LVL_WIDTH, 4) u_cell_127_to__96 (lvl_127_to_112, lvl_111_to__96, num_127_to_112, num_111_to__96, lvl_127_to__96, num_127_to__96);
  cm3_nvic_cell #(LVL_WIDTH, 4) u_cell_159_to_128 (lvl_159_to_144, lvl_143_to_128, num_159_to_144, num_143_to_128, lvl_159_to_128, num_159_to_128);
  cm3_nvic_cell #(LVL_WIDTH, 4) u_cell_191_to_160 (lvl_191_to_176, lvl_175_to_160, num_191_to_176, num_175_to_160, lvl_191_to_160, num_191_to_160);
  cm3_nvic_cell #(LVL_WIDTH, 4) u_cell_223_to_192 (lvl_223_to_208, lvl_207_to_192, num_223_to_208, num_207_to_192, lvl_223_to_192, num_223_to_192);
  cm3_nvic_cell #(LVL_WIDTH, 4) u_cell_255_to_224 (lvl_255_to_240, lvl_239_to_224, num_255_to_240, num_239_to_224, lvl_255_to_224, num_255_to_224);

  cm3_nvic_cell #(LVL_WIDTH, 5) u_cell__63_to___0 (lvl__63_to__32, lvl__31_to___0, num__63_to__32, num__31_to___0, lvl__63_to___0, num__63_to___0);
  cm3_nvic_cell #(LVL_WIDTH, 5) u_cell_127_to__64 (lvl_127_to__96, lvl__95_to__64, num_127_to__96, num__95_to__64, lvl_127_to__64, num_127_to__64);
  cm3_nvic_cell #(LVL_WIDTH, 5) u_cell_191_to_128 (lvl_191_to_160, lvl_159_to_128, num_191_to_160, num_159_to_128, lvl_191_to_128, num_191_to_128);
  cm3_nvic_cell #(LVL_WIDTH, 5) u_cell_255_to_192 (lvl_255_to_224, lvl_223_to_192, num_255_to_224, num_223_to_192, lvl_255_to_192, num_255_to_192);

  cm3_nvic_cell #(LVL_WIDTH, 6) u_cell_127_to___0 (lvl_127_to__64, lvl__63_to___0, num_127_to__64, num__63_to___0, lvl_127_to___0, num_127_to___0);
  cm3_nvic_cell #(LVL_WIDTH, 6) u_cell_255_to_128 (lvl_255_to_192, lvl_191_to_128, num_255_to_192, num_191_to_128, lvl_255_to_128, num_255_to_128);

  cm3_nvic_cell #(LVL_WIDTH, 7) u_cell_255_to___0 (lvl_255_to_128, lvl_127_to___0, num_255_to_128, num_127_to___0, lvl_255_to___0, num_255_to___0);

  assign int_num_o     = num_255_to___0[8:1];
  assign int_hi_lvl_o  = lvl_255_to___0;

endmodule

`include "cm3_nvic_undefs.vp"
