`include "cm3_tpiu_defs.vp"
module cm3_tpiu_trace_clk (
  clk, reset_n,
  trace_clk_o
  );

  parameter TRACE_LVL = 1;


  input          clk;        // Trace out clock input
  input          reset_n;    // Reset for TRACECLKIN domain

  output         trace_clk_o;   // Output at half clock frequency.

  reg            trace_clk;

  wire           nxt_trace_clk;

  assign trace_clk_o    = (TRACE_LVL > 0) ? trace_clk : 1'b0;

  assign nxt_trace_clk = ~trace_clk;

  always @(posedge clk or negedge reset_n)
    if (!reset_n)
      trace_clk <= 1'b0;
    else
      trace_clk <= nxt_trace_clk;

endmodule // cm3_tpiu_trace_clk
