module output_arb_t (
    hclk ,
    hreset_n,

    req_port0_i,
    req_port1_i,

    hreadym_i,
    hselm_i,
    htransm_i,
    hburstm_i,
    hmastlockm_i,
    addr_in_port_o,
    no_port_o
    );

    input        hclk;           // AHB system clock
    input        hreset_n;       // AHB system reset
    input        req_port0_i;    // Port 0 request signal
    input        req_port1_i;    // Port 1 request signal
    input        hreadym_i;      // Transfer done
    input        hselm_i;        // Slave select line
    input  [1:0] htransm_i;      // Transfer type
    input  [2:0] hburstm_i;      // Burst type
    input        hmastlockm_i;   // Locked transfer
    output [3:0] addr_in_port_o; // Port address input
    output       no_port_o;      // No port selected signal

  assign  addr_in_port_o = {3'b000,req_port1_i & ~req_port0_i};
  assign  no_port_o      = ~hreadym_i | (~req_port0_i & ~req_port1_i);

endmodule

